//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include <stdarg.h>
#ifdef _WIN32
	#include <windows.h>
#endif

#include <gtk/gtk.h>
//extern "C" {
//	#include "html_widget.h"

	#include "libgtkhtml/gtkhtmlcontext.h"
	#include "libgtkhtml/graphics/htmlpainter.h"
	#include "libgtkhtml/layout/htmlbox.h"
	#include "libgtkhtml/view/htmlview.h"
	#include "libgtkhtml/view/htmlselection.h"
	#include "libgtkhtml/dom/dom-types.h"
	#include "libgtkhtml/util/htmlstream.h"
//}
#include "AnsiString.h"

#define PLAT_GTK 1

#define CUSTOM_CONTROL_ID       1001
/*#define EVENT_UPDATE_CLASS_LIST 351*/
#define EVENT_ON_URL            350
#define EVENT_ON_IMAGE_REQUEST  351
#define EVENT_ON_SUBMIT         352
#define P_CLEARCACHE            10001
#define P_SELECTION             10002


#define MAX_CTRLS                   0xFF


/*typedef struct {
    Gtk::Widget *sci;
    GtkWidget *sci_obj;
} _OBJECTS;*/

#define MAX_CACHE   0x200

/*_OBJECTS Controls[0x200];
int ControlsCount=0;*/

typedef struct {
    AnsiString _element;
    AnsiString _content;
} _REQUESTED;

_REQUESTED Requested[MAX_CACHE];
int RequestedCount=0;


INVOKER RemoteInvoker=0;

/*Gtk::Widget *GetGTKMM(GtkWidget *sci_obj) {
    for (int i=0;i<ControlsCount;i++) {
        if (Controls[i].sci_obj==sci_obj)
            return Controls[i].sci;
    }
    return 0;
}*/


gboolean request_object(HtmlView *html_view, HtmlEmbedded *widget, void *user_data) {
    GtkWidget *label;

    label = gtk_label_new("The included HTML <object> tag is not supported.\nIncluded Plugins might not be displayed.");
    gtk_widget_show(label);
    gtk_container_add(GTK_CONTAINER (widget), label); 	

    return TRUE;
}

void on_url(HtmlDocument *document, const gchar *url, void *user_data) {
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_URL, url);
}

void request_url(HtmlDocument *document, const gchar *url, HtmlStream *stream, void *user_data) {
    for (int i=0;i<RequestedCount;i++) {
        if (Requested[i]._element==(char *)url) {
            html_document_write_stream(document,Requested[i]._content.c_str(),Requested[i]._content.Length());
            //html_stream_write(stream,Requested[i]._content.c_str(),Requested[i]._content.Length());
            return;
        }
    }
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_IMAGE_REQUEST, url);
}

void request_image(HtmlImageFactory *image_factory, const gchar *url, HtmlStream *stream, void *user_data) {
    for (int i=0;i<RequestedCount;i++) {
        if (Requested[i]._element==(char *)url) {
            //html_document_write_stream(document,Requested[i]._content.c_str(),Requested[i]._content.Length());
            if (Requested[i]._content.Length()) {
                html_stream_write(stream,Requested[i]._content.c_str(),Requested[i]._content.Length());
			    if (gtk_events_pending ())
				    gtk_main_iteration ();
                html_stream_close (stream);
            }
            return;
        }
    }
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_IMAGE_REQUEST, url);
}

void submit(HtmlDocument *document, const gchar *method, const gchar *url, const gchar *encoding, void *user_data) {
    AnsiString data;
    if (method)
        data=(char *)method;
    data+=(char *)":";
    if (encoding)
        data+=(char *)encoding;
    data+=(char *)":";
    if (url)
        data+=(char *)url;

    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SUBMIT, data.c_str());
}

// Control invoker function
AnsiString buffered_text;
PREFIX int Invoke(void *context,int INVOKE_TYPE,...) {
    va_list arg;
    switch (INVOKE_TYPE) {
        case INVOKE_QUERYTEST:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id=va_arg(arg, int);
                va_end(arg);

                if (cls_id==CUSTOM_CONTROL_ID)
                    return E_ACCEPTED;
            }
            break;
        case INVOKE_SETEVENT:
            {
                if (!RemoteInvoker)
                    break;
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int event_id    =   va_arg(arg, int);
                char *str_buffer=   va_arg(arg, char *);
                int buf_len     =   va_arg(arg, int);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

                /*RemoteInvoker(context,INVOKE_GETEXTRAPTR,&sp);
                if (!sp) {
                    RemoteInvoker(context,INVOKE_SETEXTRAPTR,(void*)sp);
                }*/
	            HtmlView *view=HTML_VIEW(context);

                switch (event_id) {
                    case EVENT_ON_URL:
                    	g_signal_connect (view->document, "link_clicked", G_CALLBACK (on_url),context);
                        //g_signal_connect (view->document, "request_url", G_CALLBACK (request_url),context);
                        return E_ACCEPTED;
                        break;
                    case EVENT_ON_SUBMIT:
                        g_signal_connect (view->document, "submit", G_CALLBACK (submit),context);
                        return E_ACCEPTED;
                        break;
                    case EVENT_ON_IMAGE_REQUEST:
                        g_signal_connect (view->document->image_factory, "request_image", G_CALLBACK (request_image),context);
                        //g_signal_connect (view->document, "request_url", G_CALLBACK (request_url),context);
                        return E_ACCEPTED;
                        break;
                }
            }
            break;
        case INVOKE_SETPROPERTY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int prop_id     =   va_arg(arg, int);
                char *str_buffer=   va_arg(arg, char *);
                int buf_len     =   va_arg(arg, int);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

	            HtmlView *view=HTML_VIEW(context);

                switch (prop_id) {
                    case P_CAPTION:
                        {

	                        HtmlDocument *document = view->document;//html_document_new();
	                        //html_view_set_document (view, NULL);
	                        html_document_clear (document);
	                        //html_view_set_document (view, document);
	                        if (html_document_open_stream (document, "text/html")) {
		                        html_document_write_stream (document, str_buffer, buf_len);
		                        html_document_close_stream (document);
	                        }
                        }
                        break;
                    case P_RATIO:
                        html_view_set_magnification(view,AnsiString(str_buffer).ToFloat());
                        break;
                    case P_POSITION:
                        if (str_buffer)
                            html_view_jump_to_anchor(view,str_buffer);
                        break;
                    case P_CLEARCACHE:
                        RequestedCount=0;
                        break;
                    default:
                        return E_NOTIMPLEMENTED;
                }
                
                return E_NOERROR;
            }
            break;
        case INVOKE_GETPROPERTY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int prop_id     =   va_arg(arg, int);
                char **str_buffer=   va_arg(arg, char **);
                int *buf_len     =   va_arg(arg, int*);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;


                HtmlView *view=HTML_VIEW(context);
                switch (prop_id) {
                    /*case P_CAPTION:
                        return E_ACCEPTED;*/
                        case P_SELECTION:
                            {
                                buffered_text=(char *)html_selection_get_text(view);
                                *str_buffer=buffered_text.c_str();
                                *buf_len=buffered_text.Length();
                            }
                            return E_ACCEPTED;
                    default:
                        return E_NOTIMPLEMENTED;
                }
                
                return E_NOERROR;
            }
            break;
        case INVOKE_SETSTREAM:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                char *target    =   va_arg(arg, char *);
                int len_target  =   va_arg(arg, int);
                char *value     =   va_arg(arg, char *);
                int len_value   =   va_arg(arg, int);
                va_end(arg);

                if (RequestedCount==MAX_CACHE)
                    RequestedCount=0;

                Requested[RequestedCount]._element=target;
                Requested[RequestedCount]._content.LoadBuffer(value, len_value);
                RequestedCount++;

                return E_NOERROR;
            }
            break;
        case INVOKE_SETSECONDARYSTREAM:
            // not needed
            break;
        case INVOKE_CUSTOMMESSAGE:
            {
            }
            break;
        case INVOKE_CREATE:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                void **handler  =   va_arg(arg, void **);
                int *pack_type  =   va_arg(arg, int *);
                va_end(arg);
                *pack_type=(int)0;

                if (cls_id!=CUSTOM_CONTROL_ID)
                    break;

                HtmlDocument *document = html_document_new();
                GtkWidget *widget=html_view_new();
                html_view_set_document (HTML_VIEW (widget), document);

                gtk_widget_set_usize(widget, 320, 240);

                *handler=widget;

                /*Controls[ControlsCount].sci=wrapped;
                Controls[ControlsCount++].sci_obj=widget;*/
                
                g_signal_connect (HTML_VIEW(widget), "request_object", G_CALLBACK (request_object),context);

                //gtk_html_set_allow_frameset(GTK_HTML(widget), TRUE);
                //gtk_html_set_images_blocking(GTK_HTML(widget), FALSE);

                return E_ACCEPTED;
            }
            break;
        case INVOKE_DESTROY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                void *handler  =   va_arg(arg, void *);
                va_end(arg);

                if (cls_id!=CUSTOM_CONTROL_ID)
                    break;

                return E_ACCEPTED;
            }
            break;
        case INVOKE_INITLIBRARY:
            va_start(arg, INVOKE_TYPE);
            RemoteInvoker     =   va_arg(arg, INVOKER);
            va_end(arg);
            return E_NOERROR;

        case INVOKE_DONELIBRARY:
            return E_NOERROR;

        default:
            return E_NOTIMPLEMENTED;
    }
    return E_NOTIMPLEMENTED;
}


