//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include <stdarg.h>
#ifdef _WIN32
	#include <windows.h>
#endif

#include <gtk/gtk.h>
#include <webkit/webkit.h>
extern "C" {
    #include <libsoup/soup.h>
}
#include "AnsiString.h"
#include "semhh.h"

#include <microhttpd.h>
#define PAGE "<html><head><title>Embedded server</title></head><body>If you see this, something went wrong</body></html>"
#include <string.h>
#include <sstream>

#define CUSTOM_CONTROL_ID       1012

#define EVENT_BASE_INDEX			350

#define EVENT_ON_CONSOLE_MESSAGE	350
#define EVENT_ON_COPY_CLIPBOARD		351
#define EVENT_ON_CREATE_WEBVIEW		352
#define EVENT_ON_CUT_CLIPBOARD		353
#define EVENT_ON_HOVER_LINK			354
#define EVENT_ON_ICON_LOADED		355
#define EVENT_ON_LOAD_COMMITED		356
#define EVENT_ON_LOAD_FINISHED		357
#define EVENT_ON_PROGRESS_CHANGED	358
#define EVENT_ON_LOAD_STARTED		359
#define EVENT_ON_NAVIGATION_REQUESTED 360
#define EVENT_ON_PASTE_CLIPBOARD	361
#define EVENT_ON_POPULATE_POPUP		362
#define EVENT_ON_SCRIPT_ALERT		363
#define EVENT_ON_SELECT_ALL			364
#define EVENT_ON_SELECTION_CHANGED	365
#define EVENT_ON_STATUSBAR_TEXT_CHANGED	366
#define EVENT_ON_TITLE_CHANGED		367
#define EVENT_ON_WINDOW_OBJECT_CLEARED	368
#define EVENT_ON_SCRIPT_PROMPT		369
#define EVENT_ON_SCRIPT_CONFIRM		370
#define EVENT_ON_WEB_VIEW_READY		371
#define EVENT_ON_DOWNLOAD_REQUESTED	372

#define EVENT_ON_WEBSERVER_REQUEST	373

#define EVENT_ON_REQUEST            374

#define EVENTS_COUNT				23

#define P_OPENURL               10001
#define P_STOPLOADING			10002
#define P_WEBCOPY				10003
#define P_WEBCUT				10004
#define P_WEBPASTE				10005
#define P_WEBDELETE				10006
#define P_EXECUTESCRIPT			10007

#define P_CANGOFORWARD			10008
#define P_CANGOBACK				10009
#define P_WEBCANPASTE			10010

#define P_OPENSTRING			10011

#define P_SELECTALL				10012
#define P_HIGHLIGHTMATCHES		10013
#define P_MATAINBACKFORWARD		10014
#define P_WEBBACK				10015
#define P_FORWARD				10016
#define P_UNMARKTEXTMATCHES		10017
#define P_SEARCHNEXT			10018
#define P_SEARCHPREV			10019
#define P_SENSITIVE				10020
#define P_MARKTEXTMATCHES		10021
#define P_RELOAD				10022
#define P_EVENTRESPONSETRUE		10023
#define P_WEBPRINT				10024
#define P_WEBINSPECTOR			10025
#define P_EVENTRESPONSEFALSE	10026
#define P_WEBVIEWNEW			10027

#define P_INITWEBSERVER			10028
#define P_STOPWEBSERVER			10029
#define P_WEBSERVERRUNNING		10030

#define P_WEBRESPONSE			10031
#define P_REGISTERFORRESPONSE	10032

#define P_WEBCLEARCACHE			10033

#define MAX_CACHE				0x200
typedef struct {
    AnsiString _element;
    AnsiString _content;
} _REQUESTED;

_REQUESTED Requested[MAX_CACHE];
int RequestedCount=0;


INVOKER RemoteInvoker=0;
int sensitive=0;
WebKitWebView *other=0;
HHSEM sem_wait_prop;
int prop_set=false;
AnsiString prop_data;

void *ctxt[0xFFF];
int ctxt_count=0;

gboolean event_response[EVENTS_COUNT];

gboolean console_message(WebKitWebView *web_view,
                                                        gchar         *message,
                                                        gint           line,
                                                        gchar         *source_id,
														gpointer       user_data) {
	AnsiString res((char *)source_id);
	res+=(char *)":";
	res+=AnsiString((long)line);
	res+=(char *)" ";
	res+=(char *)message;
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_CONSOLE_MESSAGE, res.c_str());
	return event_response[EVENT_ON_CONSOLE_MESSAGE-EVENT_BASE_INDEX];
}

void copy_clipboard(WebKitWebView *web_view, gpointer       user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_COPY_CLIPBOARD, (char *)"0");
	//return event_response[EVENT_ON_COPY_CLIPBOARD-EVENT_BASE_INDEX];
}

WebKitWebView *create_web_view(WebKitWebView *web_view, WebKitWebFrame *frame, gpointer        user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_CREATE_WEBVIEW, (char *)webkit_web_frame_get_uri(frame));
	//return event_response[EVENT_ON_CREATE_WEBVIEW-EVENT_BASE_INDEX];
	if (other)
		return other;
	return web_view;
}

void cut_clipboard(WebKitWebView *web_view, gpointer       user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_CUT_CLIPBOARD, (char *)"0");
	//return event_response[EVENT_ON_CUT_CLIPBOARD-EVENT_BASE_INDEX];
}

void hovering_over_link(WebKitWebView *web_view, gchar *title, gchar *uri, gpointer user_data)  {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_HOVER_LINK, (char *)uri);
	//return event_response[EVENT_ON_HOVER_LINK-EVENT_BASE_INDEX];
}

void icon_loaded(WebKitWebView *web_view, gpointer       user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_ICON_LOADED, (char *)"0");
	//return event_response[EVENT_ON_ICON_LOADED-EVENT_BASE_INDEX];
}

gboolean web_view_ready(WebKitWebView *web_view, gpointer       user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_WEB_VIEW_READY, (char *)"0");
	return event_response[EVENT_ON_WEB_VIEW_READY-EVENT_BASE_INDEX];
}

void load_commited(WebKitWebView *web_view, WebKitWebFrame *frame, gpointer        user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_LOAD_COMMITED, (char *)webkit_web_frame_get_uri(frame));
	//return event_response[EVENT_ON_LOAD_COMMITED-EVENT_BASE_INDEX];
}

void load_finished(WebKitWebView *web_view, WebKitWebFrame *frame, gpointer        user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_LOAD_FINISHED, (char *)webkit_web_frame_get_uri(frame));
	//return event_response[EVENT_ON_LOAD_FINISHED-EVENT_BASE_INDEX];
}

void load_progress_changed(WebKitWebView *web_view, gint progress, gpointer user_data) {
	AnsiString res((long)progress);
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_PROGRESS_CHANGED, (char *)res.c_str());
	//return event_response[EVENT_ON_PROGRESS_CHANGED-EVENT_BASE_INDEX];
}

void load_started(WebKitWebView *web_view, WebKitWebFrame *frame, gpointer        user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_LOAD_STARTED, (char *)webkit_web_frame_get_uri(frame));
	//return event_response[EVENT_ON_LOAD_STARTED-EVENT_BASE_INDEX];
}

WebKitNavigationResponse navigation_requested(WebKitWebView        *web_view,
                                                        WebKitWebFrame       *frame,
                                                        WebKitNetworkRequest *request,
														gpointer              user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_NAVIGATION_REQUESTED, (char *)webkit_network_request_get_uri(request));
	if (event_response[EVENT_ON_NAVIGATION_REQUESTED-EVENT_BASE_INDEX]==FALSE)
		return WEBKIT_NAVIGATION_RESPONSE_ACCEPT;
	else
		return WEBKIT_NAVIGATION_RESPONSE_IGNORE;
}

void paste_clipboard(WebKitWebView *web_view, gpointer       user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_PASTE_CLIPBOARD, (char *)"0");
	//return event_response[EVENT_ON_PASTE_CLIPBOARD-EVENT_BASE_INDEX];
}

void populate_popup(WebKitWebView *web_view, GtkMenu *menu, gpointer       user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_POPULATE_POPUP, (char *)"0");
	//return event_response[EVENT_ON_POPULATE_POPUP-EVENT_BASE_INDEX];
}

gboolean script_alert(WebKitWebView *web_view, WebKitWebFrame *frame, gchar          *message, gpointer        user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SCRIPT_ALERT, (char *)message);
	return event_response[EVENT_ON_SCRIPT_ALERT-EVENT_BASE_INDEX];
}

gboolean script_confirm(WebKitWebView *web_view, WebKitWebFrame *frame, gchar          *message, gboolean        confirmed, gpointer        user_data) {
	AnsiString res((long)confirmed);
	res+=(char *)":";
	res+=(char *)message;
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SCRIPT_CONFIRM, (char *)res.c_str());
	return event_response[EVENT_ON_SCRIPT_CONFIRM-EVENT_BASE_INDEX];
}

gboolean script_prompt(WebKitWebView  *web_view,
                                                        WebKitWebFrame *frame,
                                                        gchar          *message,
                                                        gchar          *default1,
                                                        gpointer        text,
														gpointer        user_data) {

	AnsiString res((char *)default1);
	res+=(char *)":";
	res+=(char *)message;
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SCRIPT_PROMPT, (char *)res.c_str());
	return event_response[EVENT_ON_SCRIPT_PROMPT-EVENT_BASE_INDEX];
}

void select_all(WebKitWebView *web_view, gpointer user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SELECT_ALL, (char *)"0");
	//return event_response[EVENT_ON_SELECT_ALL-EVENT_BASE_INDEX];
}

void selection_changed(WebKitWebView *web_view, gpointer user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SELECTION_CHANGED, (char *)"0");
	//return event_response[EVENT_ON_SELECTION_CHANGED-EVENT_BASE_INDEX];
}

void status_bar_text_changed(WebKitWebView *webkitwebview,
                                                        gchar         *arg1,
                                                        gpointer       user_data)  {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_STATUSBAR_TEXT_CHANGED, (char *)arg1);
	//return event_response[EVENT_ON_STATUSBAR_TEXT_CHANGED-EVENT_BASE_INDEX];
}

void title_changed(WebKitWebView *webkitwebview,	WebKitWebFrame *frame,
                                                        gchar         *title,
                                                        gpointer       user_data)  {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_TITLE_CHANGED, (char *)title);
	//return event_response[EVENT_ON_TITLE_CHANGED-EVENT_BASE_INDEX];
}

void window_object_cleared(WebKitWebView  *web_view,
                                                        WebKitWebFrame *frame,
                                                        gpointer        context,
                                                        gpointer        arg3,
                                                        gpointer        user_data) {
	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_WINDOW_OBJECT_CLEARED, (char *)webkit_web_frame_get_uri(frame));
	//return event_response[EVENT_ON_WINDOW_OBJECT_CLEARED-EVENT_BASE_INDEX];
}

gboolean download_requested(WebKitWebView *web_view,
                                                        GObject       *download,
														gpointer       user_data) {

	RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_DOWNLOAD_REQUESTED, (char *)webkit_download_get_uri(WEBKIT_DOWNLOAD(download)));
	return event_response[EVENT_ON_DOWNLOAD_REQUESTED-EVENT_BASE_INDEX];
}


std::string encodeForXml( const std::string &sSrc )
{
	std::ostringstream sRet;

	for( std::string::const_iterator iter = sSrc.begin(); iter!=sSrc.end(); iter++ )
    {
         unsigned char c = (unsigned char)*iter;

         switch( c )
         {
             case '&': sRet << "&amp;"; break;
             case '<': sRet << "&lt;"; break;
             case '>': sRet << "&gt;"; break;
             case '"': sRet << "&quot;"; break;
             case '\'': sRet << "&apos;"; break;

             default:
              if ( c<32 || c>127 )
              {
                   sRet << "&#" << (unsigned int)c << ";";
              }
              else
              {
                   sRet << c;
              }
         }
    }

    return sRet.str();
}

static int ahc_accept(void *cls, const struct sockaddr * addr, socklen_t addrlen) {
	//char *ip=inet_ntoa(sin_addr);
	const char *ip=inet_ntoa(((sockaddr_in *)addr)->sin_addr);
	if (AnsiString("127.0.0.1")!=(char *)ip)
		return MHD_NO;
	return MHD_YES;
}

static int
ahc_echo (void *user_data,
          struct MHD_Connection *connection,
          const char *url,
          const char *method,
          const char *version,
          const char *upload_data, size_t *upload_data_size, void **ptr)
{
  static int aptr=-1;
  //const char *me = (const char *)cls;
  struct MHD_Response *response;
  int ret;

  std::string request="<request><url>";
  request+=encodeForXml(url);
  request+="</url><method>";
  request+=method;
  request+="</method><version>";
  request+=version;
  request+="</version><data>";
  request+=encodeForXml(upload_data);
  request+="</data></request>";
/*
  if (0 != strcmp (method, "GET"))
    return MHD_NO;              // unexpected method*/
  if (&aptr != *ptr)
    {
      // do never respond on first call
      *ptr = &aptr;
      return MHD_YES;
    }
  *ptr = NULL;                  // reset when done

  //======================================================================//

  for (int i=0;i<ctxt_count;i++) {
       RemoteInvoker(ctxt[i], INVOKE_FIREEVENT, (int)EVENT_ON_WEBSERVER_REQUEST, (char *)request.c_str());
  }
  /*char *target=0;
  int target_len=0;
  char *value=0;
  int value_len=0;
  char *sender;*/

  //do {
	  /*semp(sem_wait_prop);
	  if (prop_set) {
		  if (prop_data.Length()) {
			  response = MHD_create_response_from_data (prop_data.Length(),
														(void *)prop_data.c_str(), MHD_NO, MHD_NO);
			  ret = MHD_queue_response (connection, MHD_HTTP_OK, response);
			  MHD_destroy_response (response);
		  }

		  prop_set=false;
		  //prop_data=(char *)"";
          semv(sem_wait_prop);
		  break;
	  }
	  semv(sem_wait_prop);*/
	for (int i=0;i<RequestedCount;i++) {
		if (Requested[i]._element==(char *)url) {
			//html_document_write_stream(document,Requested[i]._content.c_str(),Requested[i]._content.Length());
			if (Requested[i]._content.Length()) {
			  //html_stream_write(stream,Requested[i]._content.c_str(),Requested[i]._content.Length());
			  response = MHD_create_response_from_data (Requested[i]._content.Length(),
														(void *)Requested[i]._content.c_str(), MHD_NO, MHD_NO);
			  ret = MHD_queue_response (connection, MHD_HTTP_OK, response);
			  MHD_destroy_response (response);
			}
			return MHD_YES;
		}
	}
  //} while (true);
  //if (!prop_data.Length())
      return MHD_NO;
  //return MHD_YES;
  /*response = MHD_create_response_from_data (0,(void *)0, MHD_NO, MHD_NO);
  ret = MHD_queue_response (connection, MHD_HTTP_OK, response);
  MHD_destroy_response (response);*/

  //return MHD_NO;
  //======================================================================//
  //return ret;
}

gpointer last_data=0;

void pre_session_request_queued_cb(WebKitWebView  *web_view,
                                                        WebKitWebFrame *frame,
                                                        gpointer        context,
                                                        gpointer        arg3,
                                                        gpointer        user_data) {
	last_data=user_data;
}
//#include <iostream>
void session_request_queued_cb(SoupSession* session, SoupMessage* msg, gpointer user_data) {
    //if (msg->method && !strncmp (msg->method, "POST", 4))
    {
        if (!last_data)
            last_data=user_data;
        if (soup_message_body_get_accumulate (msg->request_body))
        {
            //std::cerr << "BODY2: " << msg->request_body->data << "\n";
            SoupBuffer* buffer = soup_message_body_flatten (msg->request_body);
            //GHashTable* keys = soup_form_decode (body->data);
            //formhistory_update_main_hash (keys);
            /*std::cerr << "METHOD: " << msg->method << "\n";
            if (msg->request_body->length) {
                std::cerr << "BUFFER DATA: " << msg->request_body->data << "\n";
                std::cerr << "BUFFER LEN: " << msg->request_body->length << "\n";
            }*/
            //GHashTable* keys = soup_form_decode (body->data);
            AnsiString data;
            AnsiString data2;

            data2.LoadBuffer((char *)buffer->data, buffer->length);

            data=(char *)msg->method;
            data+=(char *)" ";
            data+=(char *)soup_uri_to_string(soup_message_get_uri(msg), FALSE);
            data+=(char *)"\r\n\r\n";
            data+=data2;

	        RemoteInvoker(user_data, INVOKE_FIREEVENT2, (int)EVENT_ON_REQUEST, (char *)data.c_str(), (int)data.Length());
            soup_buffer_free (buffer);

            /*AnsiString s="<html><body>HELLO WORLD !</body></html>";
            //soup_session_cancel_message(session, msg, 200);
            soup_message_set_response(msg, "text/html", SOUP_MEMORY_STATIC, s.c_str(), s.Length());
            soup_message_set_status(msg, 200);
            soup_message_set_http_version(msg, SOUP_HTTP_1_0);
            //soup_session_send_message(session,msg);
            //g_signal_emit_by_name(msg, "finished", msg, user_data);
            soup_session_requeue_message(session,msg);
            g_signal_emit_by_name(msg, "finished", msg, user_data);*/

        }
    }
}

// Control invoker function
AnsiString buffered_text;
struct MHD_Daemon *d=NULL;

PREFIX int Invoke(void *context,int INVOKE_TYPE,...) {
    va_list arg;
    switch (INVOKE_TYPE) {
        case INVOKE_QUERYTEST:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id=va_arg(arg, int);
                va_end(arg);

                if (cls_id==CUSTOM_CONTROL_ID)
                    return E_ACCEPTED;
            }
            break;
        case INVOKE_SETEVENT:
            {
                if (!RemoteInvoker)
                    break;
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int event_id    =   va_arg(arg, int);
                char *str_buffer=   va_arg(arg, char *);
                int buf_len     =   va_arg(arg, int);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

				WebKitWebView* web_view=WEBKIT_WEB_VIEW(context);

				switch (event_id) {
					case EVENT_ON_CONSOLE_MESSAGE:
						g_signal_connect (web_view, "console-message", G_CALLBACK (console_message),context);
						break;
                    case EVENT_ON_COPY_CLIPBOARD:
						g_signal_connect (web_view, "copy_clipboard", G_CALLBACK (copy_clipboard),context);
						break;
                    case EVENT_ON_CREATE_WEBVIEW:
						g_signal_connect (web_view, "create-web-view", G_CALLBACK (create_web_view),context);
						break;
                    case EVENT_ON_CUT_CLIPBOARD:
						g_signal_connect (web_view, "cut-clipboard", G_CALLBACK (cut_clipboard),context);
						break;
                    case EVENT_ON_HOVER_LINK:
						g_signal_connect (web_view, "hovering-over-link", G_CALLBACK (hovering_over_link),context);
						break;
                    case EVENT_ON_ICON_LOADED:
						g_signal_connect (web_view, "icon-loaded", G_CALLBACK (icon_loaded),context);
						break;
                    case EVENT_ON_LOAD_COMMITED:
						g_signal_connect (web_view, "load-committed", G_CALLBACK (load_commited),context);
						break;
                    case EVENT_ON_LOAD_FINISHED:
						g_signal_connect (web_view, "load-finished", G_CALLBACK (load_finished),context);
						break;
                    case EVENT_ON_PROGRESS_CHANGED:
						g_signal_connect (web_view, "load-progress-changed", G_CALLBACK (load_progress_changed),context);
						break;
                    case EVENT_ON_LOAD_STARTED:
						g_signal_connect (web_view, "load-started", G_CALLBACK (load_started),context);
						break;
                    case EVENT_ON_NAVIGATION_REQUESTED:
						g_signal_connect (web_view, "navigation-requested", G_CALLBACK (navigation_requested),context);
						break;
                    case EVENT_ON_PASTE_CLIPBOARD:
						g_signal_connect (web_view, "paste-clipboard", G_CALLBACK (paste_clipboard),context);
						break;
                    case EVENT_ON_POPULATE_POPUP:
						g_signal_connect (web_view, "populate-popup", G_CALLBACK (populate_popup),context);
						break;
                    case EVENT_ON_SCRIPT_ALERT:
						g_signal_connect (web_view, "script-alert", G_CALLBACK (script_alert),context);
						break;
                    case EVENT_ON_SELECT_ALL:
						g_signal_connect (web_view, "select-all", G_CALLBACK (select_all),context);
						break;
                    case EVENT_ON_SELECTION_CHANGED:
						g_signal_connect (web_view, "selection-changed", G_CALLBACK (selection_changed),context);
						break;
                    case EVENT_ON_STATUSBAR_TEXT_CHANGED:
						g_signal_connect (web_view, "status-bar-text-changed", G_CALLBACK (status_bar_text_changed),context);
						break;
                    case EVENT_ON_TITLE_CHANGED:
						g_signal_connect (web_view, "title-changed", G_CALLBACK (title_changed),context);
						break;
                    case EVENT_ON_WINDOW_OBJECT_CLEARED:
						g_signal_connect (web_view, "window-object-cleared", G_CALLBACK (window_object_cleared),context);
						break;
					case EVENT_ON_SCRIPT_PROMPT:
						g_signal_connect (web_view, "script-prompt", G_CALLBACK (script_prompt),context);
						break;
                    case EVENT_ON_SCRIPT_CONFIRM:
						g_signal_connect (web_view, "script-confirm", G_CALLBACK (script_confirm),context);
						break;
					case EVENT_ON_WEB_VIEW_READY:
						g_signal_connect (web_view, "web-view-ready", G_CALLBACK (web_view_ready),context);
						break;
					case EVENT_ON_DOWNLOAD_REQUESTED:
						g_signal_connect (web_view, "download-requested", G_CALLBACK (download_requested),context);
						break;
					case EVENT_ON_WEBSERVER_REQUEST:
						if (ctxt_count+1<0xFFF) {
							ctxt[ctxt_count++]=context;
						}
						break;
                    case EVENT_ON_REQUEST:
                        {
                            SoupSession *session = webkit_get_default_session ();
						    g_signal_connect (web_view, "window-object-cleared", G_CALLBACK (pre_session_request_queued_cb),context);
                            g_signal_connect (session, "request-queued", G_CALLBACK (session_request_queued_cb), context);
                        }
						break;
				}
                /*switch (event_id) {
                    case EVENT_ON_URL:
                    	g_signal_connect (web_view, "link_clicked", G_CALLBACK (on_url),context);
                        //g_signal_connect (view->document, "request_url", G_CALLBACK (request_url),context);
                        return E_ACCEPTED;
                        break;
                }*/
            }
            break;
        case INVOKE_SETPROPERTY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int prop_id     =   va_arg(arg, int);
                char *str_buffer=   va_arg(arg, char *);
                int buf_len     =   va_arg(arg, int);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

				WebKitWebView* web_view=WEBKIT_WEB_VIEW(context);
				AnsiString buf_val;
				buf_val.LoadBuffer(str_buffer, buf_len);

                switch (prop_id) {
                    case P_OPENURL:
						{
							if (str_buffer[0]=='$') {
								char *tmp=0;
								RemoteInvoker(context, INVOKE_GETTMPCOOKIES, &tmp);
								AnsiString myURI="file://";
								myURI+=tmp;
								myURI+=(str_buffer+1);
								webkit_web_view_open(web_view, myURI.c_str());
							} else
								webkit_web_view_open(web_view, str_buffer);
						}
                        break;
					case P_OPENSTRING:
						{
							char *tmp=0;
							RemoteInvoker(context, INVOKE_GETTMPCOOKIES, &tmp);
							AnsiString myURI="file://";
							myURI+=tmp;
							myURI+="/index.html";
							webkit_web_view_load_html_string(web_view, str_buffer, myURI.c_str()/*"file://document.html"*/);
						}
                        break;
                    case P_STOPLOADING:
						webkit_web_view_stop_loading(web_view);
                        break;
                    case P_WEBCOPY:
						webkit_web_view_copy_clipboard(web_view);
                        break;
                    case P_WEBCUT:
						webkit_web_view_cut_clipboard(web_view);
                        break;
                    case P_WEBPASTE:
						webkit_web_view_paste_clipboard(web_view);
                        break;
                    case P_WEBDELETE:
						webkit_web_view_delete_selection(web_view);
                        break;
					case P_EXECUTESCRIPT:
						webkit_web_view_execute_script(web_view, str_buffer);
                        break;
					case P_SELECTALL:
						webkit_web_view_select_all(web_view);
                        break;
					case P_HIGHLIGHTMATCHES:
						webkit_web_view_set_highlight_text_matches(web_view, buf_val.ToInt());
                        break;
					case P_MATAINBACKFORWARD:
						webkit_web_view_set_maintains_back_forward_list(web_view, buf_val.ToInt());
                        break;
					case P_WEBBACK:
						webkit_web_view_go_back(web_view);
                        break;
					case P_FORWARD:
						webkit_web_view_go_forward(web_view);
                        break;
					case P_UNMARKTEXTMATCHES:
						webkit_web_view_unmark_text_matches(web_view);
                        break;
					case P_SEARCHNEXT:
						webkit_web_view_search_text(web_view, str_buffer, sensitive, TRUE, TRUE);
                        break;
					case P_SEARCHPREV:
						webkit_web_view_search_text(web_view, str_buffer, sensitive, FALSE, TRUE);
                        break;
					case P_SENSITIVE:
						sensitive=buf_val.ToInt();
                        break;
					case P_MARKTEXTMATCHES:
						webkit_web_view_mark_text_matches(web_view, str_buffer, sensitive, 0xFF);
                        break;
					case P_RELOAD:
						webkit_web_view_reload(web_view);
						break;
					case P_EVENTRESPONSETRUE:
						{
							int ev_id=buf_val.ToInt();
							ev_id-=EVENT_BASE_INDEX;
							if ((ev_id>=0) && (ev_id<EVENTS_COUNT))
								event_response[ev_id]=TRUE;
						}
						break;
					case P_EVENTRESPONSEFALSE:
						{
							int ev_id=buf_val.ToInt();
							ev_id-=EVENT_BASE_INDEX;
							if ((ev_id>=0) && (ev_id<EVENTS_COUNT))
								event_response[ev_id]=FALSE;
						}
						break;
					case P_WEBPRINT:
						{
								WebKitWebFrame *main_frame=webkit_web_view_get_main_frame(web_view);
								if (main_frame)
									webkit_web_frame_print(main_frame);
						}
						break;
					case P_WEBINSPECTOR:
						{
								WebKitWebInspector *inspector = webkit_web_view_get_inspector (WEBKIT_WEB_VIEW(web_view));
								if (inspector) {
									void *handler=0;
									int cls_id=0;
									RemoteInvoker(context, INVOKE_GETCONTROL, (int)buf_val.ToInt(), &handler, &cls_id);
									if (handler) {
										gtk_container_add (GTK_CONTAINER (handler), GTK_WIDGET (inspector));
										gtk_widget_show(GTK_WIDGET(inspector));
									}
								}
						}
						break;
					case P_WEBVIEWNEW:
						{
							void *handler=0;
							int cls_id=0;
							RemoteInvoker(context, INVOKE_GETCONTROL, (int)buf_val.ToInt(), &handler, &cls_id);
							if ((handler) && (cls_id==CUSTOM_CONTROL_ID)){
								other=WEBKIT_WEB_VIEW(handler);
							}
						}
						break;
					case P_INITWEBSERVER:
						{
							  if (d)
								  MHD_stop_daemon (d);
							  d = MHD_start_daemon(MHD_USE_THREAD_PER_CONNECTION | MHD_USE_DEBUG,
													buf_val.ToInt(),
													&ahc_accept, NULL, &ahc_echo, (void *)context, MHD_OPTION_END);
						}
						break;
					case P_STOPWEBSERVER:
						{
							if (d) {
								MHD_stop_daemon (d);
								d=NULL;
							}
						}
						break;
					case P_WEBRESPONSE:
						{
							semp(sem_wait_prop);
							prop_set=1;
							prop_data=buf_val;
							semv(sem_wait_prop);
						}
						break;
                    case P_WEBCLEARCACHE:
                        RequestedCount=0;
                        break;
                    default:
                        return E_NOTIMPLEMENTED;
                }
                return E_NOERROR;
            }
            break;
        case INVOKE_GETPROPERTY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int prop_id     =   va_arg(arg, int);
                char **str_buffer=   va_arg(arg, char **);
                int *buf_len     =   va_arg(arg, int*);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

				WebKitWebView* web_view=WEBKIT_WEB_VIEW(context);
                switch (prop_id) {
                        case P_CANGOFORWARD:
							buffered_text=AnsiString((long)webkit_web_view_can_go_forward(web_view));
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                            return E_ACCEPTED;
                        case P_CANGOBACK:
							buffered_text=AnsiString((long)webkit_web_view_can_go_back(web_view));
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                            return E_ACCEPTED;
                        case P_WEBCANPASTE:
							buffered_text=AnsiString((long)webkit_web_view_can_paste_clipboard(web_view));
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                            return E_ACCEPTED;
						case P_OPENURL:
							{
								/*WebKitWebFrame *main_frame=webkit_web_view_get_main_frame(web_view);
								if (main_frame) {
									buffered_text=AnsiString((char *)webkit_web_frame_get_uri(main_frame));
									*str_buffer=buffered_text.c_str();
									*buf_len=buffered_text.Length();
								}*/
								buffered_text=AnsiString((char *)webkit_web_view_get_uri(web_view));
								*str_buffer=buffered_text.c_str();
								*buf_len=buffered_text.Length();
							}
                            return E_ACCEPTED;
						case P_WEBSERVERRUNNING:
							{
								buffered_text=AnsiString((long)d);
								*str_buffer=buffered_text.c_str();
								*buf_len=buffered_text.Length();
							}
                    default:
                        return E_NOTIMPLEMENTED;
                }
                return E_NOERROR;
            }
            break;
        case INVOKE_SETSTREAM:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                char *target    =   va_arg(arg, char *);
                int len_target  =   va_arg(arg, int);
                char *value     =   va_arg(arg, char *);
                int len_value   =   va_arg(arg, int);
                va_end(arg);

				AnsiString param(target);
				AnsiString pval(value);
				if ((param==(char *)"editable") || 
					(param==(char *)"full-content-zoom") || 
					(param==(char *)"transparent")) {
					GValue *prop_val = g_new0 (GValue, 1);
					g_value_init (prop_val, G_TYPE_BOOLEAN);
					g_value_set_boolean (prop_val, pval.ToInt());
					g_object_set_property (G_OBJECT(context), target, prop_val);

					g_value_unset (prop_val);
					g_free (prop_val);
				} else
				if (param==(char *)"zoom-level") {
					GValue *prop_val = g_new0 (GValue, 1);
					g_value_init (prop_val, G_TYPE_FLOAT);
					g_value_set_float (prop_val, pval.ToFloat());
					g_object_set_property (G_OBJECT(context), target, prop_val);

					g_value_unset (prop_val);
					g_free (prop_val);
				} else
				if ((param==(char *)"auto-load-images") ||
				  (param==(char *)"auto-shrink-images") ||
				  (param==(char *)"enable-developer-extras") ||
				  (param==(char *)"enable-plugins") ||
				  (param==(char *)"enable-scripts") ||
				  (param==(char *)"print-backgrounds") ||
				  (param==(char *)"resizable-text-areas")) {
					GValue *prop_val = g_new0 (GValue, 1);
					g_value_init (prop_val, G_TYPE_BOOLEAN);
					g_value_set_boolean (prop_val, pval.ToInt());

					WebKitWebSettings *settings = webkit_web_view_get_settings (WEBKIT_WEB_VIEW(context));
					if (!settings)
						settings=webkit_web_settings_new ();
					g_object_set_property (G_OBJECT(context), target, prop_val);
					webkit_web_view_set_settings (WEBKIT_WEB_VIEW(context), settings);

					g_value_unset (prop_val);
					g_free (prop_val);
				} else
				if ((param==(char *)"cursive-font-family") ||
				  (param==(char *)"default-encoding") ||
				  (param==(char *)"default-font-family") ||
				  (param==(char *)"fantasy-font-family") ||
				  (param==(char *)"monospace-font-family") ||
				  (param==(char *)"sans-serif-font-family") ||
				  (param==(char *)"serif-font-family") ||
				  (param==(char *)"user-stylesheet-uri")) {
					GValue *prop_val = g_new0 (GValue, 1);
					g_value_init (prop_val, G_TYPE_STRING);
					g_value_set_string (prop_val, pval.c_str());

					WebKitWebSettings *settings = webkit_web_view_get_settings (WEBKIT_WEB_VIEW(context));
					if (!settings)
						settings=webkit_web_settings_new ();
					g_object_set_property (G_OBJECT(context), target, prop_val);
					webkit_web_view_set_settings (WEBKIT_WEB_VIEW(context), settings);

					g_value_unset (prop_val);
					g_free (prop_val);
				} else
				if ((param==(char *)"default-font-size") ||
				  (param==(char *)"default-monospace-font-size") ||
				  (param==(char *)"minimum-font-size") ||
				  (param==(char *)"minimum-logical-font-size")) {
					GValue *prop_val = g_new0 (GValue, 1);
					g_value_init (prop_val, G_TYPE_INT);
					g_value_set_int (prop_val, pval.ToInt());

					WebKitWebSettings *settings = webkit_web_view_get_settings (WEBKIT_WEB_VIEW(context));
					if (!settings)
						settings=webkit_web_settings_new ();
					g_object_set_property (G_OBJECT (context), target, prop_val);
					webkit_web_view_set_settings (WEBKIT_WEB_VIEW(context), settings);

					g_value_unset (prop_val);
					g_free (prop_val);
				} else
				if (param==(char *)"zoom-step") {
					GValue *prop_val = g_new0 (GValue, 1);
					g_value_init (prop_val, G_TYPE_FLOAT);
					g_value_set_boolean (prop_val, pval.ToInt());

					WebKitWebSettings *settings = webkit_web_view_get_settings (WEBKIT_WEB_VIEW(context));
					if (!settings)
						settings=webkit_web_settings_new ();
					g_object_set_property (G_OBJECT (context), target, prop_val);
					webkit_web_view_set_settings (WEBKIT_WEB_VIEW(context), settings);

					g_value_unset (prop_val);
					g_free (prop_val);
				}
                return E_NOERROR;
            }
            break;
        case INVOKE_SETSECONDARYSTREAM:
			{
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                char *target    =   va_arg(arg, char *);
                int len_target  =   va_arg(arg, int);
                char *value     =   va_arg(arg, char *);
                int len_value   =   va_arg(arg, int);
                va_end(arg);

                if (RequestedCount==MAX_CACHE)
                    RequestedCount=0;

                Requested[RequestedCount]._element=target;
                Requested[RequestedCount]._content.LoadBuffer(value, len_value);
                RequestedCount++;
			}
            break;
        case INVOKE_CUSTOMMESSAGE:
            {
            }
            break;
        case INVOKE_CREATE:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                void **handler  =   va_arg(arg, void **);
                int *pack_type  =   va_arg(arg, int *);
                va_end(arg);
                *pack_type=(int)0;

                if (cls_id!=CUSTOM_CONTROL_ID)
                    break;

/*                HtmlDocument *document = html_document_new();
                GtkWidget *widget=html_view_new();
                html_view_set_document (HTML_VIEW (widget), document);

                gtk_widget_set_usize(widget, 320, 240);

                Gtk::Widget *wrapped=Glib::wrap(widget);
                *handler=wrapped;
                
                g_signal_connect (HTML_VIEW(widget), "request_object", G_CALLBACK (request_object),context);
*/
				WebKitWebView* web_view=WEBKIT_WEB_VIEW (webkit_web_view_new ());
                //Gtk::Widget *wrapped=Glib::wrap(GTK_WIDGET(web_view));
				GtkWidget *wrapped=0;
				if (RemoteInvoker) {
					RemoteInvoker(web_view, INVOKE_GETHANDLE, &wrapped);
				}

                gtk_widget_set_usize(GTK_WIDGET(web_view), 320, 240);
                *handler=wrapped;

                return E_ACCEPTED;
            }
            break;
        case INVOKE_DESTROY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                void *handler  =   va_arg(arg, void *);
                va_end(arg);

                if (cls_id!=CUSTOM_CONTROL_ID)
                    break;
                
                //delete (Gtk::Widget*)handler;
				if (d)
					MHD_stop_daemon (d);

                return E_ACCEPTED;
            }
            break;
        case INVOKE_INITLIBRARY:
			seminit(sem_wait_prop, 1);

            va_start(arg, INVOKE_TYPE);
            RemoteInvoker     =   va_arg(arg, INVOKER);
            va_end(arg);
			for (int i=0;i<EVENTS_COUNT;i++) {
				event_response[i]=FALSE;
			}
            return E_NOERROR;
        case INVOKE_DONELIBRARY:
            return E_NOERROR;

        default:
            return E_NOTIMPLEMENTED;
    }
    return E_NOTIMPLEMENTED;
}


