#include "AXControl.h"

#define AX_DLL      "AXManager.dll"


typedef void (*ADD_RESULT_FUNC)(void *ptr, char *result);
typedef int (*EVENT_CALLBACK)(void *ptr, DISPID dispIdMember,DISPPARAMS __RPC_FAR *Params, VARIANT __RPC_FAR *pVarResult);
typedef int (*EVENT_DONE)(void *ptr, DISPID dispIdMember, int parameters_count);

typedef void (*VOID_DLLCALL)();
typedef int (*CREATE_CONTROL_PROC)(HWND Handle, char *AXName, char *LicenceKey);
//typedef int (*SET_PROPERTY)(HWND Handle, char *prop_name, char *value);
typedef int (*SET_PROPERTY)(HWND Handle, char *method_name, char *value[], int param_count, void *ptr_id, ADD_RESULT_FUNC __caller_AddResult);
typedef int (*CALL_METHOD)(HWND Handle, char *method_name, char *value[], int param_count, void *ptr_id, ADD_RESULT_FUNC __caller_AddResult);
typedef int (*GET_PROPERTY)(HWND Handle, char *method_name, char *value[], int param_count, void *ptr_id, ADD_RESULT_FUNC __caller_AddResult);

typedef int (*SET_EVENT_WATHCER)(HWND Handle, void *ptr, EVENT_CALLBACK fevent, ADD_RESULT_FUNC __caller_AddResult, EVENT_DONE edone);
typedef int (*DONE_EVENTS)(HWND Handle, int cookie);


VOID_DLLCALL        ComInit=0;
VOID_DLLCALL        ComTerminate=0;
CREATE_CONTROL_PROC AXCreateControl=0;
SET_PROPERTY        DLLSetProperty=0; 
CALL_METHOD         CallFunction=0;
GET_PROPERTY        DLLGetProperty=0; 
SET_EVENT_WATHCER   SetEventWatcher=0;
DONE_EVENTS         DoneEvents=0;


HMODULE CAXControl::LoadAXModule() {
    InitCommonControls();

    HMODULE hMOD=LoadLibrary(AX_DLL);
    if (hMOD) {
        ComInit=(VOID_DLLCALL)GetProcAddress(hMOD,"ComInit");
        ComTerminate=(VOID_DLLCALL)GetProcAddress(hMOD,"ComTerminate");
        AXCreateControl=(CREATE_CONTROL_PROC)GetProcAddress(hMOD,"AXCreateControl");
        DLLSetProperty=(SET_PROPERTY)GetProcAddress(hMOD,"SetProperty");
        CallFunction=(CALL_METHOD)GetProcAddress(hMOD,"CallFunction");
        DLLGetProperty=(GET_PROPERTY)GetProcAddress(hMOD,"GetProperty");
        SetEventWatcher=(SET_EVENT_WATHCER)GetProcAddress(hMOD,"SetEventWatcher");
        DoneEvents=(DONE_EVENTS)GetProcAddress(hMOD,"DoneEvents");
    }
    if (ComInit)
        ComInit();
    return hMOD;
}

void CAXControl::FreeAXModule(HMODULE hMOD) {
    if ((hMOD) && (ComTerminate))
        ComTerminate();
    FreeModule(hMOD);
}

void CAXControl::AddResult(void *ptr, char *data) {

    CAXControl *THIS_PTR=(CAXControl *)ptr;
    THIS_PTR->LAST_RESULTS[THIS_PTR->LAST_RESULTS_COUNT++]=data;
}

/*#include <fstream>
void __DEBUG_PRINT(char *str) {
        std::ofstream out;
        out.open("debug-output.txt", std::ios_base::out | std::ios_base::app);
        out << str << "\n";
        out.close();
}*/

void CAXControl::AddEventParameter(void *ptr, char *data) {
    CAXControl *THIS_PTR=(CAXControl *)ptr;
    THIS_PTR->EVENT_PARAMETERS[THIS_PTR->EVENT_PARAMETERS_COUNT++]=data;
    //THIS_PTR->EVENT_PARAMETERS.Add(new AnsiString(data),DATA_STRING);
    //__DEBUG_PRINT(data);
}

int CAXControl::EventDone(void *ptr, DISPID dispIdMember, int parameters_count) {
    CAXControl *THIS_PTR=(CAXControl *)ptr;
    THIS_PTR->_EFUNC(THIS_PTR->SenderID, dispIdMember,parameters_count);
    return 1;
}

int CAXControl::EventNotify(void *ptr, DISPID dispIdMember,DISPPARAMS __RPC_FAR *Params, VARIANT __RPC_FAR *pVarResult) {
    // return 1 = exista evenimentul, 0 nu exista ...
    CAXControl *THIS_PTR=(CAXControl *)ptr;
    for (int i=0;i<THIS_PTR->EVENTS_COUNT;i++) {
        if (THIS_PTR->EVENTS[i]==dispIdMember) {
            // Params->cArgs = nr. argumentelor ale evenimentului prins
            //THIS_PTR->_EFUNC(THIS_PTR->SenderID, dispIdMember, Params->cArgs);
            //THIS_PTR->EVENT_PARAMETERS.Clear();
            return 1;
        }
    }
    return 0;
}

CAXControl::CAXControl(HWND Parent, AX_EVENT_FUNC ef, AnsiString _SenderID) {
        Handle=Parent;
        /*Handle=CreateWindow(    WC_STATIC,
                                "", 
                                WS_VISIBLE | WS_CHILD | SS_CENTER,
                                CW_USEDEFAULT,
                                CW_USEDEFAULT,
                                CW_USEDEFAULT,
                                CW_USEDEFAULT,
                                Parent,
                                NULL,
                                GetModuleHandle(NULL),
                                this);*/

        //this->spControl=0;
        //SetWindowLong(Parent,GWL_USERDATA,(LONG)this);
        //OLDPROC=(WNDPROC)SetWindowLong(Handle,GWL_WNDPROC,(LONG)WndProc);
        this->EVENTS_ID=0;
        this->EVENTS=0;
        this->EVENTS_COUNT=0;

        this->PARAMETERS_COUNT=0;
        this->LAST_RESULTS_COUNT=0;
        this->EVENT_PARAMETERS_COUNT=0;
        this->_EFUNC=ef;
        this->SenderID=_SenderID;
}

int CAXControl::InitControl(char *AXName, char *LicenceKey) {
    //Beep(1000,1000);
    if (!AXCreateControl(Handle,AXName,LicenceKey))
        MessageBox(0,"Error creating control",AXName,MB_ICONWARNING | MB_OK);
    else {
        SetEventWatcher(Handle,this,CAXControl::EventNotify,CAXControl::AddEventParameter,CAXControl::EventDone);
    }
    return 1;
}

int CAXControl::SetAXProperty(char *name/*, char *value*/) {
    //return DLLSetProperty(/*spControl*/Handle, name, value);
    LAST_RESULTS_COUNT=0;
    int res=0;
    char **parameters=0;
    int param_count=PARAMETERS_COUNT;
    if (param_count) {
        parameters=new char * [param_count];
        for (int i=0;i<param_count;i++)
            parameters[i]=PARAMETERS[i].c_str();
    }
    res=DLLSetProperty(Handle,name,parameters,param_count,this,CAXControl::AddResult);
    // executzie metoda ...
    if ((param_count) && (parameters))
        delete[] parameters;
    // delete-ul se face aici pt ansistring si restul ...
    // golire lista de parametri ...
    PARAMETERS_COUNT=0;
    return res;
}

int CAXControl::GetAXProperty(char *name/*, char *value*/) {
    //return DLLSetProperty(/*spControl*/Handle, name, value);
    LAST_RESULTS_COUNT=0;
    int res=0;
    char **parameters=0;
    int param_count=PARAMETERS_COUNT;
    if (param_count) {
        parameters=new char * [param_count];
        for (int i=0;i<param_count;i++)
            parameters[i]=PARAMETERS[i].c_str();
    }
    res=DLLGetProperty(Handle,name,parameters,param_count,this,CAXControl::AddResult);
    // executzie metoda ...
    if ((param_count) && (parameters))
        delete[] parameters;
    // delete-ul se face aici pt ansistring si restul ...
    // golire lista de parametri ...
    PARAMETERS_COUNT=0;
    return res;
}

int CAXControl::AddParameter(char *parameter) {
    PARAMETERS[PARAMETERS_COUNT++]=parameter;
    return 0;
}

AnsiString CAXControl::GetLastResult(int index) {
    AnsiString result="0";
    if ((index>=0) && (index<LAST_RESULTS_COUNT))
        return LAST_RESULTS[index];
    return result;
}

int CAXControl::ExecuteMethod(char *method_name) {
    LAST_RESULTS_COUNT=0;
    int res=0;
    char **parameters=0;
    int param_count=PARAMETERS_COUNT;
    if (param_count) {
        parameters=new char * [param_count];
        for (int i=0;i<param_count;i++)
            parameters[i]=PARAMETERS[i].c_str();
    }
    res=CallFunction(Handle,method_name,parameters,param_count,this,CAXControl::AddResult);
    // executzie metoda ...
    if (!res)
        MessageBox(0,((AnsiString(method_name)+"@")+AnsiString((long)param_count)+AnsiString("\nError code: ")+AnsiString((long)res)).c_str(),"Error calling method",MB_ICONWARNING | MB_OK);

    if ((param_count) && (parameters))
        delete[] parameters;
    // delete-ul se face aici pt ansistring si restul ...
    // golire lista de parametri ...
    PARAMETERS_COUNT=0;
    return res;
}

int CAXControl::AddEventNotify(int event_dispid) {
    int *events_back;
    EVENTS_COUNT++;
    events_back=new int[EVENTS_COUNT];

    if (EVENTS_COUNT>1) {
        memcpy(events_back,EVENTS,sizeof(int)*EVENTS_COUNT-1);
        delete[] EVENTS;
    }
    events_back[EVENTS_COUNT-1]=event_dispid;
    EVENTS=events_back;
    return 1;
}

int CAXControl::ClearEventsData() {
    this->EVENT_PARAMETERS_COUNT=0;
    return 1;
}

int CAXControl::AknowledgeEvent(int parameters) {
    if (parameters>MAX_PARAMS-1) {
        parameters=MAX_PARAMS;
    }
    EVENT_PARAMETERS_COUNT-=parameters;
    int i=0;
    while ((parameters--)>0) {
        EVENT_PARAMETERS[i++]=EVENT_PARAMETERS[i];
    }
    return 1;
}

AnsiString CAXControl::GetEventParameter(int index) {
    return EVENT_PARAMETERS[index];
    //return AnsiString("error: invalid index ")+AnsiString(index)+AnsiString("/")+AnsiString(EVENT_PARAMETERS_COUNT);
}

CAXControl::~CAXControl() {
    if (EVENTS_ID)
        DoneEvents(Handle,EVENTS_ID);
    DestroyWindow(Handle);
    if (this->EVENTS)
        delete[] this->EVENTS;
}
