#include "EventHandler.h"
#include "BasicMessages.h"
#include "GTKControl.h"

#ifdef THIS
    #undef THIS
#endif

GTKControl *GetControlID(long);

ClientEventHandler::ClientEventHandler(long ID, CConceptClient *CC) {
    this->ID=ID;
    this->Client=CC;
    this->drag_set_data_event=0;
    this->popup=0;
    this->button_press_event=0;
    //this->timer_id=0;
    this->is_mainwindow=false;
    this->quit_confirmed=false;
    this->map_delete=false;
}

void ClientEventHandler::AddTimer(int timeout_value) {
    //sigc::slot<bool> my_slot = sigc::bind(sigc::mem_fun(*this, &ClientEventHandler::on_timeout), timer_id++);
    //sigc::connection conn = Glib::signal_timeout().connect(my_slot, timeout_value);
    g_timeout_add(timeout_value, ClientEventHandler::on_timeout, this);
}

void ClientEventHandler::refresh_events(void *DTV, char event) {
    DeturnatedTreeView *DTV_CAST=(DeturnatedTreeView *)DTV;

    DTV_CAST->column_events |= event;
    if (!event)
        event=DTV_CAST->column_events;

    if (!DTV_CAST->EVENT_HANDLER)
        DTV_CAST->EVENT_HANDLER=this;
    
    int index=0;
    for (int i=0;i<DTV_CAST->columns_count;i++) {
        //std::cerr << "Element " << i << " / " << DTV_CAST->columns_count << " events " << (long)DTV_CAST->columns[i].events << " " << (long)DTV_CAST->column_events << "\n";
        if ((DTV_CAST->columns[i].events!=DTV_CAST->column_events) && (DTV_CAST->columns[i].type!=-1)) {
            char dif_events=event;
            /*if (!event)
                event=!DTV_CAST->columns[i].events & DTV_CAST->column_events;*/
            GtkTreeViewColumn *column=DTV_CAST->get_column(index++);
            if (!column)
                continue;

            if (dif_events & COLUMN_LINKED) {
                g_signal_connect(G_OBJECT(column), "clicked",  G_CALLBACK(DeturnatedTreeView::signal_header_clicked), DTV_CAST);
            }

            //GtkCellRenderer *renderer=column->get_first_cell_renderer();
            GList *lst=gtk_tree_view_column_get_cell_renderers(column);
            GtkCellRenderer *renderer=GTK_CELL_RENDERER(lst->data);
            if (lst)
                g_list_free(lst);

            if (!renderer)
                continue;

            DTV_CAST->columns[i].events=DTV_CAST->column_events;

            if (dif_events & START_EDITING) {
                g_signal_connect(G_OBJECT(renderer), "editing-started",  G_CALLBACK(ClientEventHandler::on_editing_started), this);
            }
            if (dif_events & END_EDITING) {
                if ((DTV_CAST->columns[i].type==3) || (DTV_CAST->columns[i].type==4)) {
                    g_signal_connect(G_OBJECT(renderer), "toggled",  G_CALLBACK(ClientEventHandler::on_edited_toggled), this);
                } else
                if (DTV_CAST->columns[i].type==6) { // combo
                    g_signal_connect(G_OBJECT(renderer), "edited",  G_CALLBACK(ClientEventHandler::on_edited), this);
                    //g_signal_connect(G_OBJECT(renderer), "changed",  G_CALLBACK(ClientEventHandler::on_cell_changed), this);
                } else
                if ((DTV_CAST->columns[i].type!=5/*image*/) && (DTV_CAST->columns[i].type!=2/*progress*/)) {
                    g_signal_connect(G_OBJECT(renderer), "edited",  G_CALLBACK(ClientEventHandler::on_edited), this);
                }
            }
            if (dif_events & CANCEL_EDITING) {
                g_signal_connect(G_OBJECT(renderer), "editing-canceled",  G_CALLBACK(ClientEventHandler::on_editing_canceled), this);
                break;
            }
        }
    }
}

gboolean ClientEventHandler::on_link_activated(void *SenderObject, gchar *uri, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CLICKED),AnsiString((char *)uri));
    return TRUE;
}

gboolean ClientEventHandler::on_clicked(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CLICKED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_show(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SHOW),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_hide(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_HIDE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_map(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_MAP),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_unmap(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_UNMAP),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_realize(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_REALIZE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_unrealize(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_UNREALIZE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_size_request(void *SenderObject,GtkRequisition* requisition, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SIZEREQUEST),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_size_allocate(void *SenderObject,GtkAllocation& allocation, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SIZEALLOCATE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_state_changed(void *SenderObject,GtkStateType previous_state, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_STATECHANGED),AnsiString((long)previous_state));
    return FALSE;
}

gboolean ClientEventHandler::on_parent_changed(void *SenderObject,GtkWidget* previous_parent, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PARENTCHANGED),AnsiString(GetControlPtr(previous_parent)));
    return FALSE;
}

gboolean ClientEventHandler::on_hierarchy_changed(void *SenderObject,GtkWidget* previous_toplevel, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_HIERARCHYCHANGED),AnsiString(GetControlPtr(previous_toplevel)));
    return FALSE;
}

gboolean ClientEventHandler::on_style_changed(void *SenderObject,GtkStyle *previous_style, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_STYLECHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_direction_changed(void *SenderObject,GtkTextDirection direction, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DIRECTIONCHANGED),AnsiString((long)direction));
    return FALSE;
}

gboolean ClientEventHandler::on_grab_notify(void *SenderObject,bool was_grabbed, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_GRABNOTIFY),AnsiString((long)was_grabbed));
    return FALSE;
}

gboolean ClientEventHandler::on_child_notify(void *SenderObject,GParamSpec* pspec, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CHILDNOTIFY),AnsiString((char *)pspec->name));
    return FALSE;
}

gboolean ClientEventHandler::on_mnemonic_activate(void *SenderObject,bool group_cycling, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_MNEMONICACTIVATE),AnsiString((long)group_cycling));
    return FALSE;
}

gboolean ClientEventHandler::on_grab_focus(void *SenderObject, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_GRABFOCUS),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_focus(void *SenderObject,GtkDirectionType direction, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_FOCUS),AnsiString((long)direction));
    return FALSE;
}

gboolean ClientEventHandler::on_event(void *SenderObject,GdkEvent* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_EVENT),AnsiString((long)event->type));
    return FALSE;
}

gboolean ClientEventHandler::on_button_press_notify_event(void *SenderObject,GdkEventButton* event, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    if ((event->type == GDK_BUTTON_PRESS) && (event->button == 3) && (THIS->popup)) {
        gtk_menu_popup(GTK_MENU(THIS->popup), 0, 0, 0, 0, event->button, event->time);

    }
    return FALSE;
}

/*bool*/ gboolean ClientEventHandler::on_button_press_event(void *SenderObject,GdkEventButton* event, void *THIS_REF) {
    //bool result=false;
    /*if ((event->type == GDK_BUTTON_PRESS) && (event->button == 3) && (popup)) {
        popup->popup(event->button, event->time);
        result=true;
    }
    if (button_press_event)*/
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_BUTTONPRESS),AnsiString((long)event->button));
    //return result;
    return FALSE;
}

/*bool*/ gboolean ClientEventHandler::on_button_release_event(void *SenderObject,GdkEventButton* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data;
    data=AnsiString((double)event->x);
    data+=(char *)":";
    data+=AnsiString((double)event->y);
    data+=(char *)":";
    data+=AnsiString((long)event->button);
    data+=(char *)":";
    data+=AnsiString((long)event->state);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_BUTTONRELEASE),data);
    //return false;
    return FALSE;
}

gboolean ClientEventHandler::on_scroll_event(void *SenderObject,GdkEventScroll* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data;
    data=AnsiString((double)event->x);
    data+=(char *)":";
    data+=AnsiString((double)event->y);
    data+=(char *)":";
    data+=AnsiString((long)event->direction);
    data+=(char *)":";
    data+=AnsiString((long)event->state);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SCROLL),data);
    return FALSE;
}

gboolean ClientEventHandler::on_motion_notify_event(void *SenderObject,GdkEventMotion* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data;
    data=AnsiString((double)event->x);
    data+=(char *)":";
    data+=AnsiString((double)event->y);
    data+=(char *)":";
    data+=AnsiString((long)event->state);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_MOTIONNOTIFY),data);
    return FALSE;
}

gboolean ClientEventHandler::on_delete_hook(void *SenderObject,GdkEventAny* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    if (THIS->map_delete)
        return ClientEventHandler::on_delete_event(SenderObject, event, THIS_REF);
    else {
        if (THIS->is_mainwindow) {
            gtk_main_quit();
            return FALSE;
        }
    }
    gtk_widget_hide(GTK_WIDGET(SenderObject));
    return TRUE;
}

gboolean ClientEventHandler::on_delete_event(void *SenderObject,GdkEventAny* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    bool res=!THIS->quit_confirmed;
    if (!THIS->quit_confirmed) {
        THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DELETEEVENT),"0");
    } else {
        if (THIS->is_mainwindow)
            gtk_main_quit();
        else {
            gtk_widget_hide(GTK_WIDGET(SenderObject));
            return TRUE;
        }
    }

    THIS->quit_confirmed=false;
    return res;
}

gboolean ClientEventHandler::on_expose_event(void *SenderObject,GdkEventExpose* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_EXPOSEEVENT),"0");
    return FALSE;
}

/*bool*/gboolean ClientEventHandler::on_key_press_event(void *SenderObject,GdkEventKey* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_KEYPRESS),AnsiString((long)event->keyval));
    //return false;
    return FALSE;
}

gboolean ClientEventHandler::on_key_release_event(void *SenderObject,GdkEventKey* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data;
    data=AnsiString((double)event->keyval);
    data+=(char *)":";
    data+=AnsiString((double)event->state);
    data+=(char *)":";
    data+=AnsiString((long)event->hardware_keycode);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_KEYRELEASE),data);
    return FALSE;
}

gboolean ClientEventHandler::on_enter_notify_event(void *SenderObject,GdkEventCrossing* event, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data;
    data=AnsiString((double)event->x);
    data+=(char *)":";
    data+=AnsiString((double)event->y);
    data+=(char *)":";
    data+=AnsiString((long)event->mode);
    data+=(char *)":";
    data+=AnsiString((long)event->detail);
    data+=(char *)":";
    data+=AnsiString((long)event->state);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ENTER),data);
    return FALSE;
}

gboolean ClientEventHandler::on_leave_notify_event(void *SenderObject,GdkEventCrossing* event, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data;
    data=AnsiString((double)event->x);
    data+=(char *)":";
    data+=AnsiString((double)event->y);
    data+=(char *)":";
    data+=AnsiString((long)event->mode);
    data+=(char *)":";
    data+=AnsiString((long)event->detail);
    data+=(char *)":";
    data+=AnsiString((long)event->state);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_LEAVE),data);
    return FALSE;
}

gboolean ClientEventHandler::on_configure_event(void *SenderObject,GdkEventConfigure* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CONFIGURE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_focus_in_event(void *SenderObject,GdkEventFocus* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_FOCUSIN),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_focus_out_event(void *SenderObject,GdkEventFocus* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_FOCUSOUT),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_map_event(void *SenderObject,GdkEventAny* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_MAPEVENT),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_unmap_event(void *SenderObject,GdkEventAny* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_UNMAPEVENT),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_property_notify_event(void *SenderObject,GdkEventProperty* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PROPERTY),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_selection_clear_event(void *SenderObject,GdkEventSelection* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SELECTIONCLEAR),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_selection_request_event(void *SenderObject,GdkEventSelection* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SELECTIONREQUEST),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_selection_notify_event(void *SenderObject,GdkEventSelection* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SELECTIONNOTIFY),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_proximity_in_event(void *SenderObject,GdkEventProximity* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PROXIMITYIN),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_proximity_out_event(void *SenderObject,GdkEventProximity* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PROXIMITYOUT),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_visibility_notify_event(void *SenderObject,GdkEventVisibility* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_VISIBILITY),AnsiString((long)event->state));
    return FALSE;
}

gboolean ClientEventHandler::on_client_event(void *SenderObject,GdkEventClient* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CLIENT),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_no_expose_event(void *SenderObject,GdkEventAny* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_NOEXPOSE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_window_state_event(void *SenderObject,GdkEventWindowState* event, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_WINDOWSTATE),AnsiString((long)event->new_window_state));
    return FALSE;
}

gboolean ClientEventHandler::on_selection_get(void *SenderObject,GtkSelectionData *selection_data, guint info, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SELECTIONGET),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_selection_received(void *SenderObject, GtkSelectionData *selection_data, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SELECTIONRECEIVED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_drag_begin(void *SenderObject, GdkDragContext *context, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGBEGIN),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_drag_end(void *SenderObject,GdkDragContext *context, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGEND),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_drag_data_get(void *SenderObject,GdkDragContext *context, GtkSelectionData *selection_data, guint info, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    // acest eveniment e mapat automat ...
    gtk_selection_data_set(selection_data,
                           gtk_selection_data_get_target(selection_data),
                           8 /* 8 bits format */, 
                           (const guchar*)THIS->DragData.c_str(), 
                           THIS->DragData.Length()
    );
    if (THIS->drag_set_data_event) {
        GTKControl *ctl=GetControlID(THIS->ID.ToInt());
        if ((ctl) && (ctl->type==CLASS_TREEVIEW)) {
            AnsiString temp;
            GtkTreePath *path;
            GtkTreeViewColumn* focus_column;
            gtk_tree_view_get_cursor(MY_TREE_VIEW(ctl->ptr), &path,&focus_column);
            if (path) {
                gchar *ps=gtk_tree_path_to_string(path);
                temp=(char *)ps;
                g_free(ps);
            }
            temp+=(char*)"%";
            temp+=THIS->DragData;
            THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGDATAGET),temp);
        } else
            THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGDATAGET),THIS->DragData);
    }
    return FALSE;
}

gboolean ClientEventHandler::on_drag_data_delete(void *SenderObject,GdkDragContext *context, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGDATADELETE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_drag_leave(void *SenderObject,GdkDragContext *context, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGLEAVE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_drag_motion(void *SenderObject,GdkDragContext *context, int x, int y, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGMOTION),AnsiString((long)x)+":"+AnsiString((long)y));
    return FALSE;
}

gboolean ClientEventHandler::on_drag_drop(void *SenderObject,GdkDragContext *context, int x, int y, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGDROP),AnsiString((long)x)+":"+AnsiString((long)y));
    return FALSE;
}

gboolean ClientEventHandler::on_drag_data_received(void *SenderObject,GdkDragContext *context, int x, int y, GtkSelectionData *selection_data, guint info, guint time, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data="";
    if ((gtk_selection_data_get_length(selection_data) > 0) && (gtk_selection_data_get_format(selection_data) == 8))
        data.LoadBuffer((char*)gtk_selection_data_get_data(selection_data), gtk_selection_data_get_length(selection_data));

    gtk_drag_finish(context, false, false, time);
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DRAGDATARECEIVED),data);
	
	// keep last dropped data for security reasons (when the server is asking for a dropped file
	// only the files in the dropped data are allowed !
	THIS->last_dropped_data=data;
	//====================================//
	/*context->drop_finish(true, time);
	std::list<std::string> uris = selection_data.get_uris();
	std::list<std::string>::iterator uris_iter = uris.begin();
	Beep(1000,1000);
	while (uris_iter != uris.end()) {
		std::string uri=*uris_iter++;
		Beep(1000,1000);
	}*/
    return FALSE;
}

gboolean ClientEventHandler::on_screen_changed(void *SenderObject,GdkScreen *previous_screen, void *THIS_REF) { 
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SCREENCHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_group_changed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_GROUPCHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_toggled(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_TOGGLED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_activate(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ACTIVATE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_enter(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ENTER),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_leave(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_LEAVE),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_pressed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PRESSED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_released(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_RELEASED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_insert_at_cursor(void *SenderObject,char *str, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_INSERTATCURSOR),AnsiString((char*)str));
    return FALSE;
}

gboolean ClientEventHandler::on_populate_popup(void *SenderObject,void* menu, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_POPULATEPOPUP),AnsiString(GetControlPtr(menu)));
    return FALSE;
}

gboolean ClientEventHandler::on_set_anchor(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SETANCHOR),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_set_scroll_adjustments(void *SenderObject,GtkAdjustment* hadjustment, GtkAdjustment* vadjustment, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SETSCROLLADJUSTMENTS),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_input(void *SenderObject,double* new_value, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_INPUT),AnsiString(*new_value));
    return FALSE;
}

gboolean ClientEventHandler::on_output(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_OUTPUT),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_value_changed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_VALUECHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_switch_page(void *SenderObject,void* page, guint page_num, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SWITCHPAGE),AnsiString((long)page_num));
    return FALSE;
}

gboolean ClientEventHandler::on_frame_event(void *SenderObject,GdkEvent* event, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_FRAMEEVENT),AnsiString((long)event->type));
    return FALSE;
}

gboolean ClientEventHandler::on_set_focus(void *SenderObject,GtkWidget* focus, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SETFOCUS),AnsiString(GetControlPtr(focus)));
    return FALSE;
}

gboolean ClientEventHandler::on_changed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    if (!THIS->quit_confirmed)
        THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_activate_item(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ACTIVATEITEM),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_child_detached(void *SenderObject,GtkWidget *w, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CHILDDETACHED),AnsiString(GetControlPtr(w)));
    return FALSE;
}

gboolean ClientEventHandler::on_child_attached(void *SenderObject,GtkWidget *w, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CHILDATTACHED),AnsiString(GetControlPtr(w)));
    return FALSE;
}

gboolean ClientEventHandler::on_orientation_changed(void *SenderObject,GtkOrientation orientation, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ORIENTATIONCHANGED),AnsiString((long)orientation));
    return FALSE;
}

gboolean ClientEventHandler::on_popup_context_menu(void *SenderObject,int x, int y, int button_number, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_POPUPCONTEXTMENU),AnsiString((long)x)+":"+AnsiString((long)y)+":"+AnsiString((long)button_number));
    return FALSE;
}

gboolean ClientEventHandler::on_toolbar_style_changed(void *SenderObject,GtkToolbarStyle style, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_TOOLBARSTYLECHANGED),AnsiString((long)style));
    return FALSE;
}

gboolean ClientEventHandler::on_create_menu_proxy(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CREATEMENUPROXY),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_toolbar_reconfigured(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_TOOLBARRECONFIGURED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_show_menu(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_SHOWMENU),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_columns_changed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_COLUMNSCHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_header_clicked(void *SenderObject, void *THIS_REF) {
    // SenderObject CAN be null when called by my_header_event
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_HEADERCLICKED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_cursor_changed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CURSORCHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_row_activated(void *SenderObject,GtkTreePath *path, GtkTreeViewColumn* column, void *THIS_REF) {
    //GTKControl *ctl=GetControlID(ID.ToInt());
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    gchar *ps=gtk_tree_path_to_string(path);
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ROWACTIVATED),AnsiString((char *)ps));
    g_free(ps);
    return FALSE;
}

gboolean ClientEventHandler::on_item_activated(void *SenderObject,GtkTreePath *path, void *THIS_REF) {
    //GTKControl *ctl=GetControlID(ID.ToInt());
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    gchar *ps=gtk_tree_path_to_string(path);
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ROWACTIVATED),AnsiString((char *)ps));
    g_free(ps);
    return FALSE;
}

gboolean ClientEventHandler::on_row_collapsed(void *SenderObject,GtkTreeIter *iter, GtkTreePath *path, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    gchar *ps=gtk_tree_path_to_string(path);
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ROWCOLLAPSED),AnsiString((char *)ps));
    g_free(ps);
    return FALSE;
}

gboolean ClientEventHandler::on_row_expanded(void *SenderObject,GtkTreeIter *iter, GtkTreePath *path, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    gchar *ps=gtk_tree_path_to_string(path);
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ROWEXPANDED),AnsiString((char *)ps));
    g_free(ps);
    return FALSE;
}

gboolean ClientEventHandler::on_timeout(/*void *SenderObject,int timer_number, */void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_TIMER),AnsiString((long)/*timer_number*/0));
    return FALSE;
}

gboolean ClientEventHandler::on_day_selected(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DAYSELECTED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_day_selected_double_click(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_DAYSELECTEDDBCLICK),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_month_changed(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_MONTHCHANGED),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_next_month(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_NEXTMONTH),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_next_year(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_NEXTYEAR),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_prev_month(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PREVMONTH),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_prev_year(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PREVYEAR),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_editing_started(void *SenderObject,GtkCellEditable* cell, char *str, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    AnsiString data(str);

    gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (SenderObject), "column"));
    data+=(char *)"/";
    GTKControl *ctl=GetControlID(THIS->ID.ToInt());
    if ((ctl) && (ctl->type==CLASS_TREEVIEW)) {
        column=((DeturnatedTreeView *)ctl->ptr)->adjust_column(column);
    }
    data+=AnsiString(column);

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_STARTEDITING),(char *)data.c_str());
    return FALSE;
}

gboolean ClientEventHandler::on_editing_canceled(void *SenderObject, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CANCELEDITING),"0");
    return FALSE;
}

gboolean ClientEventHandler::on_edited(void *SenderObject, char *str1, char *str2, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    GTKControl *ctl=GetControlID(THIS->ID.ToInt());
    if ((ctl) && (ctl->type==CLASS_TREEVIEW)) {
        GtkTreeModel *model = gtk_tree_view_get_model(MY_TREE_VIEW(ctl->ptr));
        GtkTreePath *path = gtk_tree_path_new_from_string(str1);
        GtkTreeIter iter;
        gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (SenderObject), "column"));
        gtk_tree_model_get_iter (model, &iter, path);
        gtk_list_store_set(GTK_LIST_STORE (model), &iter, column, str2, -1);
        gtk_tree_path_free (path);
    }

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ENDEDITING),(char *)str2);
    return FALSE;
}

gboolean ClientEventHandler::on_edited_toggled(void *SenderObject,char *str1, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    GTKControl *ctl=GetControlID(THIS->ID.ToInt());
    AnsiString data(str1);
    if ((ctl) && (ctl->type==CLASS_TREEVIEW)) {
        GtkTreeModel *model = gtk_tree_view_get_model(MY_TREE_VIEW(ctl->ptr));
        GtkTreeIter  iter;
        GtkTreePath *path = gtk_tree_path_new_from_string(str1);
        gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (SenderObject), "column"));
        gboolean fixed;

        data+=(char *)"/";
        data+=AnsiString(((DeturnatedTreeView *)ctl->ptr)->adjust_column(column));
        gtk_tree_model_get_iter (model, &iter, path);
        gtk_tree_model_get (model, &iter, column, &fixed, -1);

        fixed ^= 1;

        gtk_list_store_set (GTK_LIST_STORE (model), &iter, column, fixed, -1);

        gtk_tree_path_free (path);
    }
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_STARTEDITING),(char *)data.c_str());
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ENDEDITING),(char *)str1);
    return FALSE;
}

gboolean ClientEventHandler::on_adjust_bounds(void *SenderObject,double d, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ADJUSTBOUNDS),AnsiString(d));
    return FALSE;
}

gboolean ClientEventHandler::on_change_value(void *SenderObject,GtkScrollType st, double d, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_CHANGEVALUE),AnsiString((long)st)+AnsiString(":")+AnsiString(d));
    return FALSE;
}

gboolean ClientEventHandler::on_move_slider(void *SenderObject,GtkScrollType st, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_MOVESLIDER),AnsiString((long)st));
    return FALSE;
}

#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
gboolean ClientEventHandler::on_icon_press(void *SenderObject,GtkEntryIconPosition eip, const GdkEventButton* btn, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
	THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_PRESSED),AnsiString((long)eip)+":"+AnsiString((long)btn->button));
    return FALSE;
}

gboolean ClientEventHandler::on_icon_release(void *SenderObject,GtkEntryIconPosition eip, const GdkEventButton* btn, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_RELEASED),AnsiString((long)eip)+":"+AnsiString((long)btn->button));
    return FALSE;
}
#endif

gboolean ClientEventHandler::on_cell_changed(void *SenderObject, gchar *new_path, GtkTreeIter *iter, void *THIS_REF) {
    ClientEventHandler *THIS=(ClientEventHandler *)THIS_REF;
    GtkTreeModel *tree_model=0;
    g_object_get(G_OBJECT(SenderObject), "model", &tree_model, NULL);

    GtkTreePath *path=gtk_tree_model_get_path(tree_model, iter);
    gchar *ps=gtk_tree_path_to_string(path);

    /*GTKControl *ctl=GetControlID(THIS->ID.ToInt());
    if ((ctl) && (ctl->type==CLASS_TREEVIEW)) {
        GtkTreeModel *model = gtk_tree_view_get_model(MY_TREE_VIEW(ctl->ptr));
        GtkTreePath *path2 = gtk_tree_path_new_from_string(str1);
        GtkTreeIter iter;
        gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (SenderObject), "column"));
        gtk_tree_model_get_iter (model, &iter, path2);
        gtk_list_store_set(GTK_LIST_STORE (model), &iter, column, str2, -1);
        gtk_tree_path_free (path2);
    }*/

    THIS->Client->SendMessage(THIS->ID.c_str(),MSG_EVENT_FIRED,AnsiString((long)EVENT_ON_ENDEDITING),AnsiString((char *)new_path)+AnsiString((char *)",")+AnsiString(ps));

    if (ps)
        g_free(ps);

    if (path)
        gtk_tree_path_free(path);
    return FALSE;
}
