#ifndef __EVENTHANDLER_H
#define __EVENTHANDLER_H

#include <gtk/gtk.h>

#include "ConceptClient.h"
#include "AnsiString.h"
#include "callback.h"

class ClientEventHandler {
    private:
        AnsiString ID;
		AnsiString last_dropped_data;
        CConceptClient *Client;
        AnsiString DragData;
        char drag_set_data_event;
        char button_press_event;
        bool quit_confirmed;
        GtkMenu *popup;
        //int timer_id;
    public:
        char is_mainwindow;
        char map_delete;

        void ResetDrop() {
			last_dropped_data=(char *)"";
		}

		int FileIsDropped(AnsiString filename) {
			int len=last_dropped_data.Length();
			char *str=last_dropped_data.c_str();
			if (!len)
				return 0;

			AnsiString scanned_file;
			for (int i=0;i<len;i++) {
				char c=str[i];
				if (c=='\r')
					continue;
				if (c=='\n') {
					if ((scanned_file.Length()) && (filename==scanned_file))
						return 1;
					else
						scanned_file=(char *)"";
					continue;
				}
				scanned_file+=c;
			}
			if ((scanned_file.Length()) && (scanned_file==filename))
				return 1;
			return 0;
		}

        void AddTimer(int timeout_value);

        void ConfirmQuit(bool flag=true) {
            quit_confirmed=flag;
        }
        
        void SetDragData(AnsiString data) { DragData=data; }
        void SetDragEvent(char _set_event=1) { drag_set_data_event = _set_event; }
        void SetButtonPressEvent(char _set_event=1) { button_press_event = _set_event; }
        void SetPopup(GtkMenu *menu) { popup=menu; }
        void *GetPopup() { return popup; }
        ClientEventHandler(long, CConceptClient *);
        void refresh_events(void *DTV, char event=0);

        static gboolean on_delete_hook(void *SenderObject,GdkEventAny* event, void *THIS_REF);

        static gboolean on_button_press_notify_event(void *SenderObject, GdkEventButton* event, void *THIS_REF);

        //Default Signal Handlers::
        static gboolean on_show(void *SenderObject,void *THIS_REF);
        static gboolean on_hide(void *SenderObject,void *THIS_REF);
        static gboolean on_map(void *SenderObject,void *THIS_REF);
        static gboolean on_unmap(void *SenderObject,void *THIS_REF);
        static gboolean on_realize(void *SenderObject,void *THIS_REF);
        static gboolean on_unrealize(void *SenderObject,void *THIS_REF);
        static gboolean on_size_request(void *SenderObject,GtkRequisition* requisition, void *THIS_REF);
        static gboolean on_size_allocate(void *SenderObject,GtkAllocation& allocation, void *THIS_REF);
        static gboolean on_state_changed(void *SenderObject,GtkStateType previous_state, void *THIS_REF);
        static gboolean on_parent_changed(void *SenderObject,GtkWidget* previous_parent, void *THIS_REF);
        static gboolean on_hierarchy_changed(void *SenderObject,GtkWidget* previous_toplevel, void *THIS_REF);
        static gboolean on_style_changed(void *SenderObject,GtkStyle *previous_style, void *THIS_REF);
        static gboolean on_direction_changed(void *SenderObject,GtkTextDirection direction, void *THIS_REF);
        static gboolean on_grab_notify(void *SenderObject,bool was_grabbed, void *THIS_REF);
        static gboolean on_child_notify(void *SenderObject,GParamSpec* pspec, void *THIS_REF);
        static gboolean on_mnemonic_activate(void *SenderObject,bool group_cycling, void *THIS_REF);
        static gboolean on_grab_focus(void *SenderObject, void *THIS_REF);
        static gboolean on_focus(void *SenderObject,GtkDirectionType direction, void *THIS_REF);
        static gboolean on_event(void *SenderObject,GdkEvent* event, void *THIS_REF);
        static gboolean on_button_press_event(void *SenderObject,GdkEventButton* event, void *THIS_REF);
        static gboolean on_button_release_event(void *SenderObject,GdkEventButton* event, void *THIS_REF);
        static gboolean on_scroll_event(void *SenderObject,GdkEventScroll* event, void *THIS_REF);
        static gboolean on_motion_notify_event(void *SenderObject,GdkEventMotion* event, void *THIS_REF);
        static gboolean on_delete_event(void *SenderObject,GdkEventAny* event, void *THIS_REF);
        static gboolean on_expose_event(void *SenderObject,GdkEventExpose* event, void *THIS_REF);
        static gboolean on_key_press_event(void *SenderObject,GdkEventKey* event, void *THIS_REF);
        static gboolean on_key_release_event(void *SenderObject,GdkEventKey* event, void *THIS_REF);
        static gboolean on_enter_notify_event(void *SenderObject,GdkEventCrossing* event, void *THIS_REF);
        static gboolean on_leave_notify_event(void *SenderObject,GdkEventCrossing* event, void *THIS_REF);
        static gboolean on_configure_event(void *SenderObject,GdkEventConfigure* event, void *THIS_REF);
        static gboolean on_focus_in_event(void *SenderObject,GdkEventFocus* event, void *THIS_REF);
        static gboolean on_focus_out_event(void *SenderObject,GdkEventFocus* event, void *THIS_REF);
        static gboolean on_map_event(void *SenderObject,GdkEventAny* event, void *THIS_REF);
        static gboolean on_unmap_event(void *SenderObject,GdkEventAny* event, void *THIS_REF);
        static gboolean on_property_notify_event(void *SenderObject,GdkEventProperty* event, void *THIS_REF);
        static gboolean on_selection_clear_event(void *SenderObject,GdkEventSelection* event, void *THIS_REF);
        static gboolean on_selection_request_event(void *SenderObject,GdkEventSelection* event, void *THIS_REF);
        static gboolean on_selection_notify_event(void *SenderObject,GdkEventSelection* event, void *THIS_REF);
        static gboolean on_proximity_in_event(void *SenderObject,GdkEventProximity* event, void *THIS_REF);
        static gboolean on_proximity_out_event(void *SenderObject,GdkEventProximity* event, void *THIS_REF);
        static gboolean on_visibility_notify_event(void *SenderObject,GdkEventVisibility* event, void *THIS_REF);
        static gboolean on_client_event(void *SenderObject,GdkEventClient* event, void *THIS_REF);
        static gboolean on_no_expose_event(void *SenderObject,GdkEventAny* event, void *THIS_REF);
        static gboolean on_window_state_event(void *SenderObject,GdkEventWindowState* event, void *THIS_REF);
        static gboolean on_selection_get(void *SenderObject,GtkSelectionData *selection_data, guint info, guint time, void *THIS_REF);
        static gboolean on_selection_received(void *SenderObject,GtkSelectionData *selection_data, guint time, void *THIS_REF);
        static gboolean on_drag_begin(void *SenderObject,GdkDragContext *context, void *THIS_REF);
        static gboolean on_drag_end(void *SenderObject, GdkDragContext *context, void *THIS_REF);
        static gboolean on_drag_data_get(void *SenderObject,GdkDragContext *context, GtkSelectionData *selection_data, guint info, guint time, void *THIS_REF);
        static gboolean on_drag_data_delete(void *SenderObject,GdkDragContext *context, void *THIS_REF);
        static gboolean on_drag_leave(void *SenderObject,GdkDragContext *context, guint time, void *THIS_REF);
        static gboolean on_drag_motion(void *SenderObject,GdkDragContext *context, int x, int y, guint time, void *THIS_REF);
        static gboolean on_drag_drop(void *SenderObject,GdkDragContext *context, int x, int y, guint time, void *THIS_REF);
        static gboolean on_drag_data_received(void *SenderObject,GdkDragContext *context, int x, int y, GtkSelectionData *selection_data, guint info, guint time, void *THIS_REF);
        static gboolean on_screen_changed(void *SenderObject,GdkScreen *previous_screen, void *THIS_REF);

        static gboolean on_group_changed(void *SenderObject, void *THIS_REF);
        static gboolean on_toggled(void *SenderObject, void *THIS_REF);
        static gboolean on_activate(void *SenderObject, void *THIS_REF); // si la entry si la button, si la menuitem
        static gboolean on_clicked(void *SenderObject, void *THIS_REF);
        static gboolean on_enter(void *SenderObject, void *THIS_REF);
        static gboolean on_leave(void *SenderObject, void *THIS_REF);
        static gboolean on_pressed(void *SenderObject, void *THIS_REF);
        static gboolean on_released(void *SenderObject, void *THIS_REF);
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
		static gboolean on_icon_press(void *SenderObject,GtkEntryIconPosition eip, const GdkEventButton* btn, void *THIS_REF);
		static gboolean on_icon_release(void *SenderObject,GtkEntryIconPosition eip, const GdkEventButton* btn, void *THIS_REF);
#endif

        // edit+textview
        static gboolean on_insert_at_cursor(void *SenderObject,char *str, void *THIS_REF);
        static gboolean on_populate_popup(void *SenderObject,void* menu, void *THIS_REF); // aici era Menu* menu
        static gboolean on_set_anchor(void *SenderObject, void *THIS_REF);
        static gboolean on_set_scroll_adjustments(void *SenderObject,GtkAdjustment* hadjustment, GtkAdjustment* vadjustment, void *THIS_REF);

        // spin
        static int on_input(void *SenderObject,double* new_value, void *THIS_REF);
        static gboolean on_output(void *SenderObject, void *THIS_REF);

        // notebook
        static gboolean on_switch_page(void *SenderObject,void* page, guint page_num, void *THIS_REF); //GtkNotebookPage* page

        // window
        static gboolean on_frame_event(void *SenderObject,GdkEvent* event, void *THIS_REF);
        static gboolean on_set_focus(void *SenderObject,GtkWidget* focus, void *THIS_REF);

        // adjustment
        static gboolean on_changed(void *SenderObject, void *THIS_REF);
        static gboolean on_value_changed(void *SenderObject, void *THIS_REF);
        
        // menuitem
        static gboolean on_activate_item(void *SenderObject, void *THIS_REF);

        // handle box
        static gboolean on_child_detached(void *SenderObject,GtkWidget *, void *THIS_REF);
        static gboolean on_child_attached(void *SenderObject,GtkWidget *, void *THIS_REF);

        // toolbar
        static gboolean on_orientation_changed(void *SenderObject,GtkOrientation orientation, void *THIS_REF);
        static gboolean on_popup_context_menu(void *SenderObject,int x, int y, int button_number, void *THIS_REF);
        static gboolean on_toolbar_style_changed(void *SenderObject,GtkToolbarStyle style, void *THIS_REF);

        // toolbutton
        static gboolean on_create_menu_proxy(void *SenderObject, void *THIS_REF);
        static gboolean on_toolbar_reconfigured(void *SenderObject, void *THIS_REF);

        // menu toolbutton
        static gboolean on_show_menu(void *SenderObject, void *THIS_REF);

        // events
        static gboolean on_columns_changed(void *SenderObject, void *THIS_REF);
        static gboolean on_header_clicked(void *SenderObject, void *THIS_REF);
        static gboolean on_cursor_changed(void *SenderObject, void *THIS_REF);
        static gboolean on_row_activated(void *SenderObject,GtkTreePath *path, GtkTreeViewColumn* column, void *THIS_REF);
        static gboolean on_item_activated(void *SenderObject,GtkTreePath *path, void *THIS_REF);
        static gboolean on_row_collapsed(void *SenderObject,GtkTreeIter *iter, GtkTreePath *path, void *THIS_REF);
        static gboolean on_row_expanded(void *SenderObject,GtkTreeIter *iter, GtkTreePath *path, void *THIS_REF);
        static gboolean on_cell_changed(void *SenderObject,gchar *new_path,GtkTreeIter *iter, void *THIS_REF);
        static gboolean on_editing_started(void *SenderObject,GtkCellEditable* cell, char *str, void *THIS_REF);
        static gboolean on_editing_canceled(void *SenderObject, void *THIS_REF);
        static gboolean on_edited(void *SenderObject,char *str1, char *str2, void *THIS_REF);
        static gboolean on_edited_toggled(void *SenderObject,char *str1, void *THIS_REF);
        //static gboolean on_set_scroll_adjustments(Gtk::Adjustment* hadjustment, Gtk::Adjustment* vadjustment, void *THIS_REF);
        static gboolean on_timeout(/*void *SenderObject,int timer_number, */void *THIS_REF);

        // calendar
        static gboolean on_day_selected(void *SenderObject, void *THIS_REF);
        static gboolean on_day_selected_double_click(void *SenderObject, void *THIS_REF);
        static gboolean on_month_changed(void *SenderObject, void *THIS_REF);
        static gboolean on_next_month(void *SenderObject, void *THIS_REF);
        static gboolean on_next_year(void *SenderObject, void *THIS_REF);
        static gboolean on_prev_month(void *SenderObject, void *THIS_REF); 
        static gboolean on_prev_year(void *SenderObject, void *THIS_REF);

        // range derrived
        static gboolean on_adjust_bounds(void *SenderObject,double d, void *THIS_REF);
        static gboolean on_change_value(void *SenderObject,GtkScrollType st, double d, void *THIS_REF);
        static gboolean on_move_slider(void *SenderObject,GtkScrollType st, void *THIS_REF);

        // label
        static gboolean on_link_activated(void *SenderObject, gchar *uri, void *THIS_REF);
};

#endif //__EVENTHANDLER_H
