#define GTK218
#define _WIN32_IE   0x0500

#include "callback.h" 
#include "ConceptClient.h"
//#include "base64_mime.h"
#include "unzip.h"

#define LATEST_GTK

#include "stock_constants.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
extern "C" {
    #include <gtk/gtk.h>
}
#include <locale.h>
#include "semhh.h"

#ifdef _WIN32
    #ifdef _WIN32_WINNT
        #undef _WIN32_WINNT
    #endif
    #define _WIN32_WINNT 0x0500

    #include <windows.h>
	#include <direct.h>
    #include <process.h>
    #include "AXControl.h"

    #include <gdk/gdkwin32.h>

    HMODULE AX_MODULE=0;
#else
	#include <sys/types.h>
    #include <sys/stat.h>
	#include <sys/wait.h>
	#include <unistd.h>
    #include <dlfcn.h>
    #include <gdk/gdk.h>
#endif
#include "GTKControl.h"
#include "ClientPrinter.h"
#include "login.h"
#include "inputform.h"

#ifndef _S_IFMT
    #define _S_IFMT S_IFMT
#endif

#include <gtk/gtkaccelmap.h>
#include <gtk/gtkbox.h>

#ifdef OFFSET_WINDOWS
extern "C" {
    #include "gtk_mirror_bin.h"
}
#endif

AnsiString lastdir;
AnsiString lastdirsave;
// for console
PRINT_API client_output=0;
UPDATE_CB update_status=0;
HHSEM notify_lock;
LoginDialog *login=0;
InputDialog *inputdialog=0;
AnsiString tmpcookiesdir;
GtkAccelGroup *defacc=0;
GtkWidget *color_dialog=0;
GtkWidget *font_dialog=0;

#define TARGET_STRING   1
static GtkTargetEntry listTargets[] = {
  { "STRING",     0, TARGET_STRING },
  { "text/plain", 0, TARGET_STRING }
  };

static GtkTargetEntry listTargetsFiles[] = {
  { "URI",     0, TARGET_STRING },
  { "text/uri-list", 0, TARGET_STRING }
  };

static GtkTargetEntry listTargetsFull[] = {
  { "STRING",     0, TARGET_STRING },
  { "text/plain", 0, TARGET_STRING },
  { "URI",     0, TARGET_STRING },
  { "text/uri-list", 0, TARGET_STRING }
  };


void SetTempDir(char *dir) {
	tmpcookiesdir=dir;
}

AnsiString SafeFile(AnsiString filename) {
	AnsiString safe_file;
	int len=filename.Length();
	char *s=filename.c_str();
	for (int i=0;i<len;i++) {
		char c=s[i];
		if ((c!='/') && (c!='\\'))
			safe_file+=c;
	}
	return safe_file;
}

void SetPrintCallback(PRINT_API cb) {
    client_output=cb;
}

#ifdef _WIN32
    void EnsureHWNDVisible(HWND hWnd, int x, int y, int w, int h) {
        MoveWindow(hWnd, x, y, w, h, TRUE);
    }

    void PATCH_SetOnTop(void *ptr) {
        if (!ptr)
            return;

        HWND wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(ptr)->window);
        if (!wnd)
            return;

        RECT rect;
        if (GetWindowRect(wnd,&rect)) {
            SetWindowPos(   wnd,       // handle to window
                            HWND_TOPMOST,  // placement-order handle
                            rect.left,     // horizontal position
                            rect.top,      // vertical position
                            rect.right-rect.left,  // width
                            rect.bottom-rect.top, // height
                            SWP_SHOWWINDOW // window-positioning options);
            );
        }
		ptr=0;
    }
#endif

void InitLoginDialog(char *filename) {
	seminit(notify_lock, 1);

    login=new LoginDialog(filename);
#ifdef _WIN32
    gtk_signal_connect_object (GTK_OBJECT(login->handle), "realize", GTK_SIGNAL_FUNC(PATCH_SetOnTop), GTK_OBJECT(login->handle));
#endif
}

void InitInputDialog(char *title) {
	seminit(notify_lock, 1);

    inputdialog=new InputDialog(title);
#ifdef _WIN32
    gtk_signal_connect_object (GTK_OBJECT(inputdialog->handle), "realize", GTK_SIGNAL_FUNC(PATCH_SetOnTop), GTK_OBJECT(inputdialog->handle));
#endif
}

// for printer
PRINT_API client_print=0;

static char WAIT=0;

AnsiList ControlList;

HHSEM sem_lock_app;
int run_app=0;
GtkWindow *mainform=0;
GtkWindow *firstform=0;
GTKControl *POST_OBJECT=0;
AnsiString POST_STRING;
int already_aborted=0;

HMODULE controls[MAX_CONTROLS];
int     controls_count=0;
INVOKER INVOKERS[MAX_CONTROLS];

AnsiString app_path;
AnsiString srv_host;
// called by the control library
CConceptClient *lpClient=0;
AnsiList SelectedObjects(0);


//#define CHECK_OWNER(CONTROL,PACK_TYPE)


#define CHECK_OWNER(CONTROL,PACK_TYPE) \
                                    GTKControl *owner=GetControlID(ct_id);                            \
                                    if ((owner) && (owner->fixed_ptr)) {                              \
                                        gtk_fixed_put(GTK_FIXED(owner->fixed_ptr),CONTROL,0,0);       \
                                    } else                                                            \
                                    if ((owner) && (owner->type!=CLASS_MENUITEM) &&                   \
                                        (owner->type!=CLASS_IMAGEMENUITEM) &&                         \
                                        (owner->type!=CLASS_MENU) &&                                  \
                                        (owner->type!=CLASS_SEPARATORMENUITEM) &&                     \
                                        (owner->type!=CLASS_RADIOMENUITEM) &&                         \
                                        (owner->type!=CLASS_CHECKMENUITEM) &&                         \
                                        (owner->type!=CLASS_TEAROFFMENUITEM)) {                       \
                                        if ((owner->type==CLASS_HPANED) || (owner->type==CLASS_VPANED)) { \
                                            if (!owner->extra_flags) {                                \
                                                switch (owner->pack_type) {                           \
                                                    case 0:                                           \
                                                        gtk_paned_pack1(GTK_PANED(owner->ptr), CONTROL, FALSE, TRUE); \
                                                        break;                                        \
                                                    case 1:                                           \
                                                        gtk_paned_pack1(GTK_PANED(owner->ptr), CONTROL, FALSE, FALSE); \
                                                        break;                                        \
                                                    case 2:                                           \
                                                        gtk_paned_pack1(GTK_PANED(owner->ptr), CONTROL, TRUE, TRUE); \
                                                        break;                                        \
                                                    default:                                          \
                                                        gtk_paned_add1(GTK_PANED(owner->ptr), CONTROL); \
                                                }                                                     \
                                                owner->extra_flags++;                                 \
                                            } else                                                    \
                                            if (owner->extra_flags==1) {                              \
                                                switch (owner->pack_type) {                           \
                                                    case 0:                                           \
                                                        gtk_paned_pack2(GTK_PANED(owner->ptr), CONTROL, FALSE, TRUE); \
                                                        break;                                        \
                                                    case 1:                                           \
                                                        gtk_paned_pack2(GTK_PANED(owner->ptr), CONTROL, FALSE, FALSE); \
                                                        break;                                        \
                                                    case 2:                                           \
                                                        gtk_paned_pack2(GTK_PANED(owner->ptr), CONTROL, TRUE, TRUE); \
                                                        break;                                        \
                                                    default:                                          \
                                                        gtk_paned_add2(GTK_PANED(owner->ptr), CONTROL); \
                                                }                                                     \
                                                owner->extra_flags++;                                 \
                                            }                                                         \
                                        } else                                                        \
                                        if (owner->type==CLASS_NOTEBOOK) {                            \
                                            gtk_notebook_append_page(GTK_NOTEBOOK(owner->ptr), CONTROL, NULL);     \
                                        } else                                                        \
                                        if ((owner->type==CLASS_VBUTTONBOX) ||                        \
                                            (owner->type==CLASS_HBUTTONBOX) ||                        \
                                            (owner->type==CLASS_VBOX) ||                              \
                                            (owner->type==CLASS_HBOX) ||                              \
                                            (owner->type==CLASS_STATUSBAR)) {                         \
                                                int pack_type= (owner->pack_type==-1) ? PACK_TYPE : owner->pack_type;  \
                                                bool expand = (pack_type == MyPACK_EXPAND_PADDING || pack_type == MyPACK_EXPAND_WIDGET);  \
                                                bool fill   = (pack_type == MyPACK_EXPAND_WIDGET); \
                                                gtk_box_pack_start(GTK_BOX(owner->ptr), CONTROL, expand, fill, 0); \
                                            }                                                         \
                                        else                                                          \
                                        if (owner->type==CLASS_TABLE) {                               \
                                            int *extra=(int *)owner->extra_ptr;                       \
                                            gtk_table_attach(GTK_TABLE(owner->ptr), CONTROL, extra[0],extra[1],extra[2],extra[3], (GtkAttachOptions)extra[4],(GtkAttachOptions)extra[5],extra[6],extra[7]); \
                                        } else                                                        \
                                        if (owner->type==CLASS_BUTTON) {                              \
                                           if (gtk_bin_get_child(GTK_BIN(owner->ptr)))                \
                                                gtk_container_remove(GTK_CONTAINER(owner->ptr), gtk_bin_get_child(GTK_BIN(owner->ptr))); \
                                           gtk_container_add(GTK_CONTAINER(owner->ptr), CONTROL);     \
                                        } else                                                        \
                                        if (owner->type==CLASS_TOOLBAR) {                             \
                                           gtk_toolbar_append_widget(GTK_TOOLBAR(owner->ptr), CONTROL, "", "");     \
                                        } else                                                        \
                                        if ((owner->type==CLASS_SCROLLEDWINDOW) && (GTK_WIDGET_GET_CLASS(CONTROL)->set_scroll_adjustments_signal == 0)) {\
                                            gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(owner->ptr), (CONTROL)); \
                                        } else                                                        \
                                        if (owner->type!=CLASS_TEXTVIEW)                              \
                                           gtk_container_add(GTK_CONTAINER(SAFE_WIDGET(owner)/*owner->ptr*/), CONTROL);     \
                                    }
                                    // ^^^ if the parent is a TextView, do not add the control.
                                    // in this case, the control will be added manually




AnsiString GetDirectory() {
#ifdef _WIN32
    char buffer[4096];
    buffer[0]=0;
    GetModuleFileName(NULL,buffer,4096);
    for (int i=strlen(buffer)-1;i>=0;i--) {
        if ((buffer[i]=='/') || (buffer[i]=='\\')) {
            buffer[i+1]=0;
            break;
        }
    }
    return AnsiString(buffer);
#else
    return AnsiString(APP_PATH);
#endif
}

#ifdef _WIN32

#include "resources.h"
AnsiString res_buf;
char *SLimit(char *str, int length) {
    int len=strlen(str);
    if (len<length)
        return str;

    res_buf.LoadBuffer(str, length-1);
    return res_buf.c_str();
}

void WIN32Notify(char *title, char *text) {
    NOTIFYICONDATA m_NotifyIconData_ist;
    // Display the icon in the Tray
    m_NotifyIconData_ist.cbSize=NOTIFYICONDATA_V2_SIZE;
    m_NotifyIconData_ist.uVersion=NOTIFYICON_VERSION;

    Shell_NotifyIcon(NIM_SETVERSION, &m_NotifyIconData_ist);

    m_NotifyIconData_ist.hWnd=NULL;
    m_NotifyIconData_ist.uID=1000;
    m_NotifyIconData_ist.hIcon=LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(AppIcon));
    //(HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(AppIcon), IMAGE_ICON, GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);//LoadIcon(GetModuleHandle(NULL), "icon.ico"/*MAKEINTRESOURCE(32512)*/);
    m_NotifyIconData_ist.uCallbackMessage=1000;
    m_NotifyIconData_ist.uFlags=NIF_ICON | NIF_TIP;

    _tcscpy(m_NotifyIconData_ist.szTip, /*64,*/ _T("concept:// Client Notification"));

    Shell_NotifyIcon(NIM_ADD, &m_NotifyIconData_ist);

    // display balloon with custom icon
    m_NotifyIconData_ist.uFlags=NIF_INFO | NIF_ICON;
    m_NotifyIconData_ist.dwInfoFlags=/*NIIF_USER*/0x04;
    m_NotifyIconData_ist.uTimeout=10000;
    _tcscpy(m_NotifyIconData_ist.szInfo, /*256,*/ _T(SLimit(text,256)));
    _tcscpy(m_NotifyIconData_ist.szInfoTitle, /*64,*/ _T(SLimit(title,64)));

    Shell_NotifyIcon(NIM_MODIFY, &m_NotifyIconData_ist);
}

void GetShell(AnsiString *from, char **file, char **param) {
	*file=from->c_str();
	*param=*file;
	int len=from->Length();
	char in_quotes=false;
	for (int i=0;i<len;i++) {
		if ((*param)[0]==' ') {
			if (!in_quotes) {
				(*param)[0]=0;
				(*param)++;
				return;
			}
		} else
		if ((*param)[0]=='"')
			in_quotes=!in_quotes;
		(*param)++;
	}
	*param=0;
	/**param=strchr(*file, ' ');
	if (*param) {
		(*param)[0]=0;
		(*param)++;
	}*/
	//std::cout << "SHELL: " << *from << " => [" << *file << "] [" << *param << "]\n";
}

int LoadPrint() {
    HINSTANCE hmod=LoadLibrary("client_printer.dll");
    if (hmod) {
        client_print=(PRINT_API)GetProcAddress(hmod,"gedit_print");
        if (!client_print)
            FreeLibrary(hmod);
        else
            return 1;
    }
    return 0;
}
#endif

int MESSAGE_INIT(CConceptClient *CC, char *path, char *host, UPDATE_CB ustatus) {
    lpClient=CC;
    update_status=ustatus;
#ifndef _WIN32
    char flag=0;
    if (strstr(path," ")) {
        flag=1;
        app_path=(char *)"\"";
    }
#endif
    app_path+=path;
#ifndef _WIN32
    if (flag)
        app_path=(char *)"\"";
#else
    //LoadPrint();
    AX_MODULE=CAXControl::LoadAXModule();
    if (!AX_MODULE) {
        std::cerr << "Error loading the ActiveX module\n";
        std::cerr << "                   -> CODE:" << GetLastError() << "\n";
    }
#endif
	seminit(sem_lock_app, 1);
    srv_host=host;
    return 0;
}

GTKControl *last_item=0;

GTKControl *GetControlByPtr(void *ptr) {
    int cnt=ControlList.Count();
    for (int i=0;i<cnt;i++) {
        GTKControl *item=(GTKControl *)ControlList.Item(i);
        if (item->ptr==ptr)
            return item;
    }
    return 0;
}

long GetControlPtr(void *ptr) {
    int cnt=ControlList.Count();
    for (int i=0;i<cnt;i++) {
        GTKControl *item=(GTKControl *)ControlList.Item(i);
        if (item->ptr==ptr)
            return item->ID;
    }
    return -1;
}

long RemovetControlPtr(void *ptr) {
    int cnt=ControlList.Count();
    for (int i=0;i<cnt;i++) {
        GTKControl *item=(GTKControl *)ControlList.Item(i);
        if (item->ptr==ptr) {
            ControlList.Delete(i);
            return i;
        }
    }
    return -1;
}

GTKControl *GetControlID(long id) {
    if ((last_item) && (last_item->ID==id))
        return last_item;
        
    int cnt=ControlList.Count();
    for (int i=0;i<cnt;i++) {
        GTKControl *item=(GTKControl *)ControlList.Item(i);
        if (item->ID==id) {
            last_item=item;
            return item;
        }
    }
    return 0;
}

GtkImage *GetImageID(long id) {
    GTKControl *ctrl=GetControlID(id);
    if ((ctrl) && (ctrl->type==CLASS_IMAGE))
        return GTK_IMAGE(ctrl->ptr);
    return 0;
}

GtkComboBox *GetComboID(long id) {
    GTKControl *ctrl=GetControlID(id);
    if ((ctrl) && ((ctrl->type==CLASS_COMBOBOX) || (ctrl->type==CLASS_COMBOBOXTEXT))) {
        return MY_COMBO_BOX(ctrl->ptr);
    }
    return 0;
}

INVOKER GetRequiredInvoker(int cls_id) {
    for (int i=0;i<controls_count;i++) {
        if (INVOKERS[i](0,INVOKE_QUERYTEST,cls_id)==E_ACCEPTED)
            return INVOKERS[i];
    }
    return 0;
}


void my_header_event(void *EVENT_HANDLER) {
    ((ClientEventHandler *)EVENT_HANDLER)->on_header_clicked(NULL,EVENT_HANDLER);
}

#define SELECTION_NODE_SIZE     8


static gboolean
glade_util_can_draw_nodes (GtkWidget *sel_widget, GdkWindow *sel_win,
			   GdkWindow *expose_win)
{
	GtkWidget *widget, *viewport = NULL;
	GdkWindow *viewport_win = NULL;

	/* Check if the selected widget is inside a viewport. */
	for (widget = sel_widget->parent; widget; widget = widget->parent) {
		if (GTK_IS_VIEWPORT (widget)) {
			viewport = widget;
			viewport_win = GTK_VIEWPORT (widget)->bin_window;
			break;
		}
	}

	/* If there is no viewport-type widget above the selected widget,
	   it is OK to draw the selection anywhere. */
	if (!viewport)
		return TRUE;

	/* If we have a viewport-type widget, check if the expose_win is
	   beneath the viewport. If it is, we can draw in it. If not, we
	   can't.*/
	for (;;) {
		if (expose_win == sel_win)
			return TRUE;
		if (expose_win == viewport_win)
			return FALSE;
		if (gdk_window_get_window_type (expose_win) != GDK_WINDOW_CHILD)
			break;
		expose_win = gdk_window_get_parent (expose_win);
	}

	return FALSE;
}

static GdkWindow*
glade_util_get_window_positioned_in (GtkWidget *widget)
{
	GtkWidget *parent;

	parent = widget->parent;

#ifdef USE_GNOME
	/* BonoboDockItem widgets use a different window when floating.
	   FIXME: I've left this here so we remember to add it when we add
	   GNOME support. */
	if (BONOBO_IS_DOCK_ITEM (widget)
	    && BONOBO_DOCK_ITEM (widget)->is_floating) {
		return BONOBO_DOCK_ITEM (widget)->float_window;
	}

	if (parent && BONOBO_IS_DOCK_ITEM (parent)
	    && BONOBO_DOCK_ITEM (parent)->is_floating) {
		return BONOBO_DOCK_ITEM (parent)->float_window;
	}
#endif

	if (parent)
		return parent->window;

	return widget->window;
}

static void
glade_util_calculate_window_offset (GdkWindow *window,
				    gint *x, gint *y,
				    GdkWindow **toplevel)
{
	gint tmp_x, tmp_y;

	/* Calculate the offset of the window within its toplevel. */
	*x = 0;
	*y = 0;

	for (;;) {
		if (gdk_window_get_window_type (window) != GDK_WINDOW_CHILD)
			break;
		gdk_window_get_position (window, &tmp_x, &tmp_y);
		*x += tmp_x;
		*y += tmp_y;
		window = gdk_window_get_parent (window);
	}

	*toplevel = window;
}

static void
glade_util_draw_nodes (GdkWindow *window, GdkGC *gc,
		       gint x, gint y,
		       gint width, gint height)
{
	if (width > SELECTION_NODE_SIZE && height > SELECTION_NODE_SIZE) {
        //std::cout << "X:" << x << " Y:" << y << "W:" << width << " H:" << height;

		gdk_draw_rectangle (window, gc, TRUE,
				    x, y,
				    SELECTION_NODE_SIZE,
				    SELECTION_NODE_SIZE);
		gdk_draw_rectangle (window, gc, TRUE,
				    x, y + height - SELECTION_NODE_SIZE,
				    SELECTION_NODE_SIZE,
				    SELECTION_NODE_SIZE);
		gdk_draw_rectangle (window, gc, TRUE,
				    x + width - SELECTION_NODE_SIZE, y,
				    SELECTION_NODE_SIZE,
				    SELECTION_NODE_SIZE);
		gdk_draw_rectangle (window, gc, TRUE,
				    x + width - SELECTION_NODE_SIZE,
				    y + height - SELECTION_NODE_SIZE,
				    SELECTION_NODE_SIZE,
				    SELECTION_NODE_SIZE);
	}

	gdk_draw_rectangle (window, gc, FALSE, x, y, width - 1, height - 1);
}

static void draw_nodes(GtkWidget   *sel_widget) {

		GdkWindow *sel_win, *sel_toplevel;
		gint sel_x, sel_y, x, y, w, h;

	    gint expose_win_x, expose_win_y;
	    gint expose_win_w, expose_win_h;
        GdkWindow   *expose_toplevel;
        
        if ((sel_win = glade_util_get_window_positioned_in (sel_widget)) == NULL) {
			return;
        }

        GdkWindow *expose_win=sel_win;
	    gdk_drawable_get_size (expose_win, &expose_win_w, &expose_win_h);

	    glade_util_calculate_window_offset (expose_win,
					        &expose_win_x,
					        &expose_win_y,
					        &expose_toplevel);

        GdkGC *gc = sel_widget->style->black_gc;

		glade_util_calculate_window_offset (sel_win, &sel_x, &sel_y,
						    &sel_toplevel);
		/* We only draw the nodes if the window that got the expose
		event is in the same toplevel as the selected widget. */
		if (expose_toplevel == sel_toplevel
		    && glade_util_can_draw_nodes (sel_widget, sel_win,
						expose_win)) {
			x = sel_x + sel_widget->allocation.x - expose_win_x;
			y = sel_y + sel_widget->allocation.y - expose_win_y;
			w = sel_widget->allocation.width;
			h = sel_widget->allocation.height;

			/* Draw the selection nodes if they intersect the
			expose window bounds. */
			if (x < expose_win_w && x + w >= 0
			    && y < expose_win_h && y + h >= 0) {
				glade_util_draw_nodes (expose_win, gc,
						    x, y, w, h);
			}
		}
}

//-----------------------------------------------------------------------------------------
static GtkWidget *wnd=0; 
static GtkWidget *pb=0;
AnsiString d_data;
static int d_percent=0;
bool have_message=false;

void notify_recv() {
    semp(notify_lock);

	if (!have_message) {
		semv(notify_lock);
        return;
	}

    have_message=false;

    int percent=d_percent;
    AnsiString status=d_data;

	if (!wnd) {
		wnd=gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(wnd), "Data exchange");
		gtk_window_set_resizable(GTK_WINDOW(wnd),FALSE);
		gtk_window_set_decorated(GTK_WINDOW(wnd),FALSE);
		gtk_window_set_position(GTK_WINDOW(wnd),GTK_WIN_POS_CENTER);
		gtk_window_set_modal(GTK_WINDOW(wnd), TRUE);
		pb=gtk_progress_bar_new();
		gtk_container_add(GTK_CONTAINER(wnd), pb);
		gtk_widget_show(GTK_WIDGET(pb));

        if (mainform)
            gtk_window_set_transient_for(GTK_WINDOW(wnd), mainform);

        while (gtk_events_pending())
			gtk_main_iteration();
	}

    if (percent==-2) {

		semv(notify_lock);
        return;
    }
    if (!pb) {
		semv(notify_lock);
        return;
    }

    if (percent==-1) {
        gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pb), (float)0.0);
        //if (!wnd->is_visible())
        //    wnd->show();
	    gtk_widget_show(GTK_WIDGET(wnd));
    } else
    if (percent==101)
	    gtk_widget_hide(GTK_WIDGET(wnd));
    else {
        gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pb), (float)percent/100);
	    gtk_widget_show(GTK_WIDGET(wnd));
    }
    if (status.Length())
        gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pb), status.c_str());

	while (gtk_events_pending())
		gtk_main_iteration();

	semv(notify_lock);
}
//-----------------------------------------------------------------------------------------
void notify_recv_2(int percent, char *status, bool idle_call) {
    semp(notify_lock);
    d_percent=percent;
    if (status)
        d_data=status;
    have_message=true;
    semv(notify_lock);
    if (idle_call)
        notify_recv();
    else {
	    Sleep(5);
    }
}
//-----------------------------------------------------------------------------------------
void LocalIDLE() {
    if (have_message) {
        notify_recv();
    }

    int len=SelectedObjects.Count();
    if (!len)
        return;

    for (int i=0;i<len;i++) {
        GtkWidget   *sel_widget=(GtkWidget *)SelectedObjects.Item(i);
        draw_nodes (sel_widget);
    }
    SelectedObjects.Clear();
}


//static bool selected=false;
static gboolean 
IDE_event (GtkWidget   *sel_widget, GdkEvent    *event) {
	gboolean handled = FALSE;

	g_return_val_if_fail (GTK_IS_WIDGET (sel_widget), FALSE);

    switch (event->type) {
	    case GDK_EXPOSE:
	    case GDK_CONFIGURE:
		    //draw_nodes (/*((GdkEventExpose*) event)->window*/sel_widget);
            SelectedObjects.Add(sel_widget,-1);
            break;
	    /*case GDK_ENTER_NOTIFY:
	    case GDK_MOTION_NOTIFY:
            {
                int x, y;
                gtk_widget_get_pointer (GTK_WIDGET (sel_widget), &x, &y);

                //((Gtk::Window *)item->ptr)->get_position(x,y);
                //((Gtk::Window *)item->ptr)->movev(alue->ToInt(),y);
                std::cout << "X:" << x << " Y:" << y << "\n";
                return true;
            }
            break;
	    case GDK_BUTTON_PRESS:
            if (((GdkEventButton *)event)->button == 1) {
                selected=true;
                std::cout << "selected !\n";
            }
            break;
	    case GDK_BUTTON_RELEASE:
            if (((GdkEventButton *)event)->button == 1) {
                selected=false;
                std::cout << "unselected !\n";
            }
            break;
        default:
            std::cout << event->type << "\n";*/
    }
    return handled;
}


AnsiString GET_STOCK(AnsiString *sid) {
    int id=sid->ToInt();
    switch (id) {
        case __ABOUT:
            return GTK_STOCK_ABOUT;
        case __ADD:
            return GTK_STOCK_ADD;
        case __APPLY:
            return GTK_STOCK_APPLY;
        case __BOLD:
            return GTK_STOCK_BOLD;
        case __CANCEL:
            return GTK_STOCK_CANCEL;
        case __CDROM:
            return GTK_STOCK_CDROM;
        case __CLEAR:
            return GTK_STOCK_CLEAR;
        case __CLOSE:
            return GTK_STOCK_CLOSE;
        case __COLOR_PICKER:
            return GTK_STOCK_COLOR_PICKER;
        case __CONNECT:
            return GTK_STOCK_CONNECT;
        case __CONVERT:
            return GTK_STOCK_CONVERT;
        case __COPY:
            return GTK_STOCK_COPY;
        case __CUT:
            return GTK_STOCK_CUT;
        case __DELETE:
            return GTK_STOCK_DELETE;
        case __DIALOG_AUTHENTICATION:
            return GTK_STOCK_DIALOG_AUTHENTICATION;
        case __DIALOG_ERROR:
            return GTK_STOCK_DIALOG_ERROR;
        case __DIALOG_INFO:
            return GTK_STOCK_DIALOG_INFO;
        case __DIALOG_QUESTION:
            return GTK_STOCK_DIALOG_QUESTION;
        case __DIALOG_WARNING:
            return GTK_STOCK_DIALOG_WARNING;
        case __DIRECTORY:
            return GTK_STOCK_DIRECTORY;
        case __DISCONNECT:
            return GTK_STOCK_DISCONNECT;
        case __DND:
            return GTK_STOCK_DND;
        case __DND_MULTIPLE:
            return GTK_STOCK_DND_MULTIPLE;
        case __EDIT:
            return GTK_STOCK_EDIT;
        case __EXECUTE:
            return GTK_STOCK_EXECUTE;
        case __FILE:
            return GTK_STOCK_FILE;
        case __FIND:
            return GTK_STOCK_FIND;
        case __FIND_AND_REPLACE:
            return GTK_STOCK_FIND_AND_REPLACE;
        case __FLOPPY:
            return GTK_STOCK_FLOPPY;
        case __FULLSCREEN:
            return GTK_STOCK_FULLSCREEN;
        case __GO_BACK:
            return GTK_STOCK_GO_BACK;
        case __GO_DOWN:
            return GTK_STOCK_GO_DOWN;
        case __GO_FORWARD:
            return GTK_STOCK_GO_FORWARD;
        case __GO_UP:
            return GTK_STOCK_GO_UP;
        case __GOTO_BOTTOM:
            return GTK_STOCK_GOTO_BOTTOM;
        case __GOTO_FIRST:
            return GTK_STOCK_GOTO_FIRST;
        case __GOTO_LAST:
            return GTK_STOCK_GOTO_LAST;
        case __GOTO_TOP:
            return GTK_STOCK_GOTO_TOP;
        case __HARDDISK:
            return GTK_STOCK_HARDDISK;
        case __HELP:
            return GTK_STOCK_HELP;
        case __HOME:
            return GTK_STOCK_HOME;
        case __INDENT:
            return GTK_STOCK_INDENT;
        case __INDEX:
            return GTK_STOCK_INDEX;
        case __INFO:
            return GTK_STOCK_INFO;
        case __ITALIC:
            return GTK_STOCK_ITALIC;
        case __JUMP_TO:
            return GTK_STOCK_JUMP_TO;
        case __JUSTIFY_CENTER:
            return GTK_STOCK_JUSTIFY_CENTER;
        case __JUSTIFY_FILL:
            return GTK_STOCK_JUSTIFY_FILL;
        case __JUSTIFY_LEFT:
            return GTK_STOCK_JUSTIFY_LEFT;
        case __JUSTIFY_RIGHT:
            return GTK_STOCK_JUSTIFY_RIGHT;
        case __LEAVE_FULLSCREEN:
            return GTK_STOCK_LEAVE_FULLSCREEN;
        case __MEDIA_FORWARD:
            return GTK_STOCK_MEDIA_FORWARD;
        case __MEDIA_NEXT:
            return GTK_STOCK_MEDIA_NEXT;
        case __MEDIA_PAUSE:
            return GTK_STOCK_MEDIA_PAUSE;
        case __MEDIA_PLAY:
            return GTK_STOCK_MEDIA_PLAY;
        case __MEDIA_PREVIOUS:
            return GTK_STOCK_MEDIA_PREVIOUS;
        case __MEDIA_RECORD:
            return GTK_STOCK_MEDIA_RECORD;
        case __MEDIA_REWIND:
            return GTK_STOCK_MEDIA_REWIND;
        case __MEDIA_STOP:
            return GTK_STOCK_MEDIA_STOP;
        case __MISSING_IMAGE:
            return GTK_STOCK_MISSING_IMAGE;
        case __NETWORK:
            return GTK_STOCK_NETWORK;
        case __NEW:
            return GTK_STOCK_NEW;
        case __NO:
            return GTK_STOCK_NO;
        case __OK:
            return GTK_STOCK_OK;
        case __OPEN:
            return GTK_STOCK_OPEN;
        case __PASTE:
            return GTK_STOCK_PASTE;
        case __PREFERENCES:
            return GTK_STOCK_PREFERENCES;
        case __PRINT:
            return GTK_STOCK_PRINT;
        case __PRINT_PREVIEW:
            return GTK_STOCK_PRINT_PREVIEW;
        case __PROPERTIES:
            return GTK_STOCK_PROPERTIES;
        case __QUIT:
            return GTK_STOCK_QUIT;
        case __REDO:
            return GTK_STOCK_REDO;
        case __REFRESH:
            return GTK_STOCK_REFRESH;
        case __REMOVE:
            return GTK_STOCK_REMOVE;
        case __REVERT_TO_SAVED:
            return GTK_STOCK_REVERT_TO_SAVED;
        case __SAVE:
            return GTK_STOCK_SAVE;
        case __SAVE_AS:
            return GTK_STOCK_SAVE_AS;
        case __SELECT_COLOR:
            return GTK_STOCK_SELECT_COLOR;
        case __SELECT_FONT:
            return GTK_STOCK_SELECT_FONT;
        case __SORT_ASCENDING:
            return GTK_STOCK_SORT_ASCENDING;
        case __SORT_DESCENDING:
            return GTK_STOCK_SORT_DESCENDING;
        case __SPELL_CHECK:
            return GTK_STOCK_SPELL_CHECK;
        case __STOP:
            return GTK_STOCK_STOP;
        case __STRIKETHROUGH:
            return GTK_STOCK_STRIKETHROUGH;
        case __UNDELETE:
            return GTK_STOCK_UNDELETE;
        case __UNDERLINE:
            return GTK_STOCK_UNDERLINE;
        case __UNDO:
            return GTK_STOCK_UNDO;
        case __UNINDENT:
            return GTK_STOCK_UNINDENT;
        case __YES:
            return GTK_STOCK_YES;
        case __ZOOM_100:
            return GTK_STOCK_ZOOM_100;
        case __ZOOM_FIT:
            return GTK_STOCK_ZOOM_FIT;
        case __ZOOM_IN:
            return GTK_STOCK_ZOOM_IN;
        case __ZOOM_OUT:
            return GTK_STOCK_ZOOM_OUT;
    }
    return (char *)"";
}

GdkPixbuf *ForcePixbuf(void *ptr) {
    GtkImageType storage_type=gtk_image_get_storage_type(GTK_IMAGE(ptr));
    if (storage_type==GTK_IMAGE_STOCK) {
        gchar *stock_id;
        GtkIconSize isize;
        gtk_image_get_stock(GTK_IMAGE(ptr), &stock_id, &isize);
        return gtk_widget_render_icon(GTK_WIDGET(ptr), stock_id, isize, NULL);
    }

    if ((storage_type==GTK_IMAGE_PIXBUF) || (storage_type==GTK_IMAGE_EMPTY))
        return gtk_image_get_pixbuf(GTK_IMAGE(ptr));

    return NULL;
}


int SetSugestion(GtkEntry *Entry, GtkTreeModel *m_refListModel, int text_column=0) {
    GtkEntryCompletion *completition=gtk_entry_completion_new();
    gtk_entry_completion_set_model(completition, m_refListModel);
    gtk_entry_set_completion(Entry, completition);
    gtk_entry_completion_set_text_column(completition, text_column);
    g_object_unref(completition);
    return 0;
}

int SetSugestion(GtkEntry *Entry, AnsiString *sugestion) {
    GtkTreeIter iter; 

    GtkEntryCompletion *completition=gtk_entry_completion_new();
    GtkListStore *m_refListModel=gtk_list_store_new(1, G_TYPE_STRING);
    gtk_entry_completion_set_model(completition, GTK_TREE_MODEL(m_refListModel));

    //m_refListModel->set_value(iter, 0, "total");

    AnsiString target=*sugestion;
    AnsiString sep=";";
    int len_sep=sep.Length();

    int pos=target.Pos(sep);
    int index=0;
    int start=0;
    while (pos>0) {
        if (pos>1) {
            target.c_str()[pos-1]=0;
            //Gtk::TreeModel::Row row=*(m_refListModel->append());
            gtk_list_store_append(m_refListModel, &iter);
            gtk_list_store_set(m_refListModel, &iter, 0, target.c_str(), -1);
        }
        AnsiString temp=target;
        target=temp.c_str()+pos+len_sep-1;
        pos=target.Pos(sep);
    }

    if (target.Length()) {
        gtk_list_store_append(m_refListModel, &iter);
        gtk_list_store_set(m_refListModel, &iter, 0, target.c_str(), -1);
    }

    gtk_entry_set_completion(Entry, completition);
    gtk_entry_completion_set_text_column(completition, 0);
    g_object_unref(completition);
    g_object_unref(m_refListModel);

    return 1;
}

Parameters STATIC_PARAMETERS;
int LocalInvoker(void *context,int INVOKE_TYPE,...) {
    va_list arg;
    switch (INVOKE_TYPE) {
        case INVOKE_GETCONTROLPTR:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;

                va_start(arg, INVOKE_TYPE);
                int *control_id  =   va_arg(arg, int*);
                int *cls_id     =   va_arg(arg, int*);
                va_end(arg);

                *control_id=ctx->ID;
                *cls_id=ctx->type;
            }
            break;
        case INVOKE_GETCONTROL:
            {
                va_start(arg, INVOKE_TYPE);
                int control_id  =   va_arg(arg, int);
                void **handler  =   va_arg(arg, void **);
                int *cls_id     =   va_arg(arg, int*);
                va_end(arg);

                GTKControl *ctrl=GetControlID(control_id);
                if (ctrl) {
                    *cls_id=ctrl->type;
                    *handler=SAFE_WIDGET(ctrl);
                } else
                    return E_NOTIMPLEMENTED;
            }
            break;
		case INVOKE_GETHANDLE:
            {
                va_start(arg, INVOKE_TYPE);
                void **ptr  =   va_arg(arg, void **);
                va_end(arg);
				if (context) {
					*ptr=context;//(Gtk::Widget *)Glib::wrap((GtkWidget *)context);
				} else {
					*ptr=0;
				}
                return E_NOERROR;
            }
            break;
		case INVOKE_GETOBJECT:
            {
                va_start(arg, INVOKE_TYPE);
                void **ptr  =   va_arg(arg, void **);
                va_end(arg);
				if (context) {
					*ptr=context;//((Gtk::Widget *)context)->gobj();
				} else {
					*ptr=0;
				}
                return E_NOERROR;
            }
            break;
		case INVOKE_DESTROYHANDLE:
            {
				if (context) {
					//delete (Gtk::Widget *)context;
                    g_object_unref(G_OBJECT(context));
				}
                return E_NOERROR;
            }
            break;
        case INVOKE_GETPOSTSTRING:
            {
                va_start(arg, INVOKE_TYPE);
                char **str  =   va_arg(arg, char **);
                int *len    =   va_arg(arg, int*);
                va_end(arg);
                *str=POST_STRING.c_str();
                *len=POST_STRING.Length();
                return E_NOERROR;
            }
            break;
        case INVOKE_GETPOSTOBJECT:
            {
                va_start(arg, INVOKE_TYPE);
                void **handler  =   va_arg(arg, void **);
                int *cls_id     =   va_arg(arg, int*);
                va_end(arg);
                if (POST_OBJECT) {
                    *handler=SAFE_WIDGET(POST_OBJECT);
                    *cls_id=POST_OBJECT->type;
                } else {
                    *handler=0;
                    *cls_id=-1;
                }
                return E_NOERROR;
            }
            break;
        case INVOKE_GETEXTRAPTR:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;

                va_start(arg, INVOKE_TYPE);
                void **ptr  =   va_arg(arg, void **);
                va_end(arg);
                *ptr=ctx->extra_ptr;
                return E_NOERROR;
            }
            break;
        case INVOKE_SETEXTRAPTR:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;

                va_start(arg, INVOKE_TYPE);
                void *ptr  =   va_arg(arg, void *);
                va_end(arg);
                ctx->extra_ptr=ptr;
                return E_NOERROR;
            }
            break;
        case INVOKE_FIREEVENT:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;
                va_start(arg, INVOKE_TYPE);
                int   event =   va_arg(arg, int);
                char *data  =   va_arg(arg, char *);
                va_end(arg);

                lpClient->SendMessage(AnsiString(ctx->ID),
                                    MSG_EVENT_FIRED,
                                    AnsiString((long)event),
                                    data);
                return E_NOERROR;
            }
            break;
        case INVOKE_FIREEVENT2:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;
                va_start(arg, INVOKE_TYPE);
                int   event =   va_arg(arg, int);
                char *data  =   va_arg(arg, char *);
                int   len   =   va_arg(arg, int);
                va_end(arg);
                AnsiString def;
                def.LoadBuffer(data, len);

                lpClient->SendBigMessage(AnsiString(ctx->ID),
                                    MSG_EVENT_FIRED,
                                    AnsiString((long)event),
                                    &def);
                return E_NOERROR;
            }
            break;
		case INVOKE_WAITMESSAGE:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;

                va_start(arg, INVOKE_TYPE);
                int   msg_id=   va_arg(arg, int);

				char **Sender=va_arg(arg, char **);
                char **target=   va_arg(arg, char **);
                int *target_len=   va_arg(arg, int *);
                char **value =   va_arg(arg, char **);
                int *value_len=   va_arg(arg, int *);
                va_end(arg);

				std::cerr << lpClient << ": IN\n";;
                int res=lpClient->WaitMessage(msg_id, &STATIC_PARAMETERS);
				std::cerr << lpClient << ": Out !\n";;
				if (res>=0) {
					*Sender=STATIC_PARAMETERS.Sender.c_str();
					*target=STATIC_PARAMETERS.Target.c_str();
					*target_len=STATIC_PARAMETERS.Target.Length();
					*value=STATIC_PARAMETERS.Value.c_str();
					*value_len=STATIC_PARAMETERS.Value.Length();
				} else {
					return E_NOTIMPLEMENTED;
				}
                return E_NOERROR;
            }
            break;
		case INVOKE_GETTMPCOOKIES:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;

                va_start(arg, INVOKE_TYPE);
				char **tmpdir=va_arg(arg, char **);
				*tmpdir=tmpcookiesdir.c_str();
                return E_NOERROR;
			}
            break;
        case INVOKE_SENDMESSAGE:
            {
                GTKControl *ctx=GetControlByPtr(context);
                if (!ctx)
                    return E_NOTIMPLEMENTED;

                va_start(arg, INVOKE_TYPE);
                int   msg     =   va_arg(arg, int);
                char *target  =   va_arg(arg, char *);
                int  t_len    =   va_arg(arg, int);
                char *data    =   va_arg(arg, char *);
                int  d_len    =   va_arg(arg, int);
                va_end(arg);

                lpClient->SendMessage(AnsiString(ctx->ID),
                                    msg,
                                    target,
                                    data);
                return E_NOERROR;
            }
            break;
    }
    return E_NOERROR;
}

void LoadControls(char *dir) {
    DIR *dr=opendir(dir);
    struct dirent   *dit;
    controls_count=0;
    if (dr) {
        while ((dit = readdir(dr)) != NULL) {
	        struct stat buf;
	        stat(dit->d_name, &buf);
            AnsiString fname=dit->d_name;
            int valid=fname.Pos(".cl");
            if (/*((buf.st_mode) & _S_IFMT) &&*/ (valid==fname.Length()-2) && (valid>0)) {
#ifdef PRINT_STATUS
                std::cerr << "\r[][][][][][][][]:: Loading " << dit->d_name << "...                            ";
#endif
                fname=dir;
                fname+=dit->d_name;
#ifdef _WIN32
                controls[controls_count]=LoadLibrary(fname.c_str());
#else
                controls[controls_count]=dlopen(fname.c_str(), RTLD_LAZY);
#endif
                if (!controls[controls_count]) {
                    std::cerr << "Error loading library " << fname.c_str() << "\n";
#ifndef _WIN32
                    std::cerr << "                   -> " << dlerror() << "\n";
#else
                    std::cerr << "                   -> CODE:" << GetLastError() << "\n";
#endif
                }
                if (controls[controls_count]) {
#ifdef _WIN32
                    INVOKERS[controls_count]=(INVOKER)GetProcAddress(controls[controls_count],"Invoke");
#else
                    INVOKERS[controls_count]=(INVOKER)dlsym(controls[controls_count],"Invoke");
#endif
                    if (!INVOKERS[controls_count])
#ifdef _WIN32
                        INVOKERS[controls_count]=(INVOKER)GetProcAddress(controls[controls_count],"_Invoke");
#else
                        INVOKERS[controls_count]=(INVOKER)dlsym(controls[controls_count],"_Invoke");
#endif

                    if (INVOKERS[controls_count]) {
                        INVOKERS[controls_count](0,INVOKE_INITLIBRARY,LocalInvoker);
                        controls_count++;
                    } else
#ifdef _WIN32
                        FreeLibrary(controls[controls_count]);
#else
                        dlclose(controls[controls_count]);
#endif
                }
            }
        }
        closedir(dr);
    }
}

void UnloadControls() {
    for (int i=0;i<controls_count;i++) {
        INVOKERS[i](0,INVOKE_DONELIBRARY);
        //FreeLibrary(controls[i]);
    }
#ifdef _WIN32
    if (AX_MODULE) {
        CAXControl::FreeAXModule(AX_MODULE);
        AX_MODULE=0;
    }
#endif
    controls_count=0;
}

int RunApplication() {
	semp(sem_lock_app);
	int res=run_app;
	semv(sem_lock_app);
    return res;
}

//#define SYNCRONIZE_APP if(Gtk::Main::events_pending()) Gtk::Main::iteration();

#define REPAINT(ctl)                                                                                        \
if (ctl) {                                                                                                  \
    GdkWindow *win=gtk_widget_get_window(ctl);                                                              \
    if (win) {                                                                                              \
        GdkRectangle r;                                                                                     \
        r.x=0;                                                                                              \
        r.y=0;                                                                                              \
        r.width=ctl->allocation.width;                                                                      \
        r.height=ctl->allocation.height;                                                                    \
        gdk_window_invalidate_rect(win, &r, FALSE);                                                         \
	    gtk_widget_queue_draw (GTK_WIDGET(ctl->parent) ? GTK_WIDGET(ctl->parent) : GTK_WIDGET(ctl));        \
    }                                                                                                       \
}

GtkWindow *AppWindow() {
    return GTK_WINDOW(mainform);
}

int SetCustomEvent(GTKControl *item, int event_id, AnsiString *value) {
    INVOKER Invoke=GetRequiredInvoker(item->type);
    if (!Invoke)
        return 0;

    return IS_OK(Invoke(SAFE_WIDGET2(item), INVOKE_SETEVENT, item->type, event_id, value->c_str(), (int)value->Length()));
}

int ConfirmEvent(long owner, int event_id, AnsiString *value, CConceptClient *Owner) {
    GTKControl *item=GetControlID(owner);
    if ((!item) || (!item->event_handler))
        return 0;
    switch (event_id) {
        case EVENT_ON_DELETEEVENT:
            ((ClientEventHandler *)item->event_handler)->ConfirmQuit(value->ToInt());
            break;
    }
    return 1;
}

/// TRANSPARENT !
#ifdef _WIN32

#ifdef WS_EX_LAYERED
    #undef WS_EX_LAYERED
#endif
#define WS_EX_LAYERED           0x00080000    

#define LWA_COLORKEY            0x00000001
#define LWA_ALPHA               0x00000002

typedef DWORD (WINAPI *PSLWA)(HWND, DWORD, BYTE, DWORD);

static PSLWA pSetLayeredWindowAttributes = NULL;
static BOOL initialized = FALSE;


BOOL MakeWindowTransparent(HWND hWnd, unsigned char factor)
{
   /* First, see if we can get the API call we need. If we've tried
    * once, we don't need to try again. */
   if (!initialized)
   {
      HMODULE hDLL = LoadLibrary ("user32");

      pSetLayeredWindowAttributes = 
         (PSLWA) GetProcAddress(hDLL, "SetLayeredWindowAttributes");

      initialized = TRUE;
   }

   if (pSetLayeredWindowAttributes == NULL) 
      return FALSE;

   /* Windows need to be layered to be made transparent. This is done
    * by modifying the extended style bits to contain WS_EX_LAYARED. */
   SetLastError(0);

   SetWindowLong(hWnd, 
                 GWL_EXSTYLE , 
                 GetWindowLong(hWnd, GWL_EXSTYLE) | WS_EX_LAYERED);

   if (GetLastError())
      return FALSE;

   /* Now, we need to set the 'layered window attributes'. This
    * is where the alpha values get set. */
   return pSetLayeredWindowAttributes (hWnd, 
                                       RGB(255,255,255), 
                                       factor,
                                       LWA_COLORKEY|LWA_ALPHA);
}
#endif


int SetEvent(long owner, int event_id, AnsiString *value, CConceptClient *Owner) {
    GTKControl *item=GetControlID(owner);
    if (!item) {
        std::cerr << "Error mapping event: Invalid RID in owner\n";
        return 0;
    }
    if (!item->event_handler) {
        item->event_handler=new ClientEventHandler(owner,Owner);
        //((Gtk::Widget *)item->ptr)->set_events(Gdk::ALL_EVENTS_MASK);
    }

    char event_set=0;
    ClientEventHandler *HANDLER=(ClientEventHandler *)item->event_handler;
    switch (event_id) {
        case EVENT_ON_TIMER:
                HANDLER->AddTimer(value->ToInt());
                event_set=1;
                break;
        case EVENT_ON_SHOW:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "show", 
                           G_CALLBACK(ClientEventHandler::on_show), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_show().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_show));
                event_set=1;
                break;
        case EVENT_ON_HIDE:
                g_signal_connect(
                           SAFE_WIDGET(item), 
                           "hide", 
                           G_CALLBACK(ClientEventHandler::on_hide), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_hide().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_hide));
                event_set=1;
                break;
        case EVENT_ON_MAP:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "map", 
                           G_CALLBACK(ClientEventHandler::on_map), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_map().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_map));
                event_set=1;
                break;
        case EVENT_ON_UNMAP:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "unmap", 
                           G_CALLBACK(ClientEventHandler::on_unmap), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_unmap().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_unmap));
                event_set=1;
                break;
        case EVENT_ON_REALIZE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "realize", 
                           G_CALLBACK(ClientEventHandler::on_realize), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_realize().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_realize));
                event_set=1;
                break;
        case EVENT_ON_UNREALIZE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "unrealize", 
                           G_CALLBACK(ClientEventHandler::on_unrealize), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_unrealize().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_unrealize));
                event_set=1;
                break;
        case EVENT_ON_SIZEREQUEST:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "size-request", 
                           G_CALLBACK(ClientEventHandler::on_size_request), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_size_request().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_size_request));
                event_set=1;
                break;
        case EVENT_ON_SIZEALLOCATE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "size-allocate", 
                           G_CALLBACK(ClientEventHandler::on_size_allocate), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_size_allocate().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_size_allocate));
                event_set=1;
                break;
        case EVENT_ON_STATECHANGED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "state-changed", 
                           G_CALLBACK(ClientEventHandler::on_state_changed), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_state_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_state_changed));
                event_set=1;
                break;
        case EVENT_ON_PARENTCHANGED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "parent-changed", 
                           G_CALLBACK(ClientEventHandler::on_parent_changed), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_parent_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_parent_changed));
                event_set=1;
                break;
        case EVENT_ON_HIERARCHYCHANGED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "hierarchy-changed", 
                           G_CALLBACK(ClientEventHandler::on_hierarchy_changed), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_hierarchy_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_hierarchy_changed));
                event_set=1;
                break;
        case EVENT_ON_STYLECHANGED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "style-changed", 
                           G_CALLBACK(ClientEventHandler::on_style_changed), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_style_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_style_changed));
                event_set=1;
                break;
        case EVENT_ON_DIRECTIONCHANGED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "direction-changed", 
                           G_CALLBACK(ClientEventHandler::on_direction_changed), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_direction_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_direction_changed));
                event_set=1;
                break;
        case EVENT_ON_GRABNOTIFY:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "grab-notify", 
                           G_CALLBACK(ClientEventHandler::on_grab_notify), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_grab_notify().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_grab_notify));
                event_set=1;
                break;
        case EVENT_ON_CHILDNOTIFY:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "child-notify", 
                           G_CALLBACK(ClientEventHandler::on_child_notify), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_child_notify().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_child_notify));
                event_set=1;
                break;
        case EVENT_ON_MNEMONICACTIVATE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "mnemonic-activate", 
                           G_CALLBACK(ClientEventHandler::on_mnemonic_activate), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_mnemonic_activate().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_mnemonic_activate));
                event_set=1;
                break;
        case EVENT_ON_GRABFOCUS:
                /*if (item->type==CLASS_COMBOBOXTEXT)
                    ((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_grab_focus().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_grab_focus));*/
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "grab-focus", 
                           G_CALLBACK(ClientEventHandler::on_grab_focus), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_grab_focus().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_grab_focus));
                event_set=1;
                break;
        case EVENT_ON_FOCUS:
                /*if (item->type==CLASS_COMBOBOXTEXT)
                    ((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_focus().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_focus));*/
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "focus", 
                           G_CALLBACK(ClientEventHandler::on_focus), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_focus().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_focus));
                event_set=1;
                break;
        case EVENT_ON_EVENT:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "event", 
                               G_CALLBACK(ClientEventHandler::on_event), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "event", 
                           G_CALLBACK(ClientEventHandler::on_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_event));
                event_set=1;
                break;
        case EVENT_ON_BUTTONPRESS:
                HANDLER->SetButtonPressEvent(1);
                event_set=1;
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "button-press-event", 
                               G_CALLBACK(ClientEventHandler::on_button_press_event), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "button-press-event", 
                           G_CALLBACK(ClientEventHandler::on_button_press_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_button_press_event().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_button_press_event));
                //if (!HANDLER->GetPopup()) {
                    //((Gtk::Widget *)item->ptr)->signal_button_press_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_button_press_event));
                //}
                break;
        case EVENT_ON_BUTTONRELEASE:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "button-release-event", 
                               G_CALLBACK(ClientEventHandler::on_button_release_event), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "button-release-event", 
                           G_CALLBACK(ClientEventHandler::on_button_release_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_button_release_event().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_button_release_event));
                event_set=1;
                break;
        case EVENT_ON_SCROLL:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "scroll-event", 
                               G_CALLBACK(ClientEventHandler::on_scroll_event), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "scroll-event", 
                           G_CALLBACK(ClientEventHandler::on_scroll_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_scroll_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_scroll_event));
                event_set=1;
                break;
        case EVENT_ON_MOTIONNOTIFY:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "motion-notify-event", 
                               G_CALLBACK(ClientEventHandler::on_motion_notify_event), 
                               HANDLER);
                }
                //((Gtk::Widget *)item->ptr)->signal_motion_notify_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_motion_notify_event));
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "motion-notify-event", 
                           G_CALLBACK(ClientEventHandler::on_motion_notify_event), 
                           HANDLER
                );
                event_set=1;
                break;
        case EVENT_ON_DELETEEVENT:
                if (item->type==CLASS_FORM) {
                    HANDLER->map_delete=true;
                } else {
                    g_signal_connect(
                               G_OBJECT(SAFE_WIDGET(item)), 
                               "delete-event", 
                               G_CALLBACK(ClientEventHandler::on_delete_event), 
                               HANDLER
                    );
                }
                if (item->ptr==mainform)
                    HANDLER->is_mainwindow=true;
                //((Gtk::Widget *)item->ptr)->signal_delete_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_delete_event));
                event_set=1;
                break;
        case EVENT_ON_EXPOSEEVENT:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "expose-event", 
                           G_CALLBACK(ClientEventHandler::on_expose_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_expose_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_expose_event));
                event_set=1;
                break;
        case EVENT_ON_KEYPRESS:
                //((Gtk::Widget *)item->ptr)->signal_key_press_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_key_press_event));
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "key-press-event", 
                               G_CALLBACK(ClientEventHandler::on_key_press_event), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "key-press-event", 
                           G_CALLBACK(ClientEventHandler::on_key_press_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_key_press_event().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_key_press_event));
                event_set=1;
                break;
        case EVENT_ON_KEYRELEASE:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "key-release-event", 
                               G_CALLBACK(ClientEventHandler::on_key_release_event), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "key-release-event", 
                           G_CALLBACK(ClientEventHandler::on_key_release_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_key_release_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_key_release_event));
                event_set=1;
                break;
        case EVENT_ON_ENTERNOTIFY:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "enter-notify-event", 
                               G_CALLBACK(ClientEventHandler::on_enter_notify_event), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "enter-notify-event", 
                           G_CALLBACK(ClientEventHandler::on_enter_notify_event), 
                           HANDLER
                );

                //((Gtk::Widget *)item->ptr)->signal_enter_notify_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_enter_notify_event));
                event_set=1;
                break;
        case EVENT_ON_LEAVENOTIFY:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "leave-notify-event", 
                               G_CALLBACK(ClientEventHandler::on_leave_notify_event), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "leave-notify-event", 
                           G_CALLBACK(ClientEventHandler::on_leave_notify_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_leave_notify_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_leave_notify_event));
                event_set=1;
                break;
        case EVENT_ON_CONFIGURE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "configure-event", 
                           G_CALLBACK(ClientEventHandler::on_configure_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_configure_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_configure_event));
                event_set=1;
                break;
        case EVENT_ON_FOCUSIN:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "focus-in-event", 
                               G_CALLBACK(ClientEventHandler::on_focus_in_event), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "focus-in-event", 
                           G_CALLBACK(ClientEventHandler::on_focus_in_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_focus_in_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_focus_in_event));
                event_set=1;
                break;
        case EVENT_ON_FOCUSOUT:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_focus_out_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_focus_out_event));
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "focus-out-event", 
                               G_CALLBACK(ClientEventHandler::on_focus_out_event), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "focus-out-event", 
                           G_CALLBACK(ClientEventHandler::on_focus_out_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_focus_out_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_focus_out_event));
                event_set=1;
                break;
        case EVENT_ON_MAPEVENT:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "map-event", 
                           G_CALLBACK(ClientEventHandler::on_map_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_map_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_map_event));
                event_set=1;
                break;
        case EVENT_ON_UNMAPEVENT:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "unmap-event", 
                           G_CALLBACK(ClientEventHandler::on_unmap_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_unmap_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_unmap_event));
                event_set=1;
                break;
        case EVENT_ON_PROPERTY:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "property-notify-event", 
                           G_CALLBACK(ClientEventHandler::on_property_notify_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_property_notify_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_property_notify_event));
                event_set=1;
                break;
        case EVENT_ON_SELECTIONCLEAR:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "selection-clear-event", 
                           G_CALLBACK(ClientEventHandler::on_selection_clear_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_selection_clear_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_selection_clear_event));
                event_set=1;
                break;
        case EVENT_ON_SELECTIONREQUEST:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "selection-request-event", 
                           G_CALLBACK(ClientEventHandler::on_selection_request_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_selection_request_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_selection_request_event));
                event_set=1;
                break;
        case EVENT_ON_SELECTIONNOTIFY:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "selection-notify-event", 
                           G_CALLBACK(ClientEventHandler::on_selection_notify_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_selection_notify_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_selection_notify_event));
                event_set=1;
                break;
        case EVENT_ON_PROXIMITYIN:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "proximity-in-event", 
                           G_CALLBACK(ClientEventHandler::on_proximity_in_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_proximity_in_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_proximity_in_event));
                event_set=1;
                break;
        case EVENT_ON_PROXIMITYOUT:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "proximity-out-event", 
                           G_CALLBACK(ClientEventHandler::on_proximity_out_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_proximity_out_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_proximity_out_event));
                event_set=1;
                break;
        case EVENT_ON_VISIBILITY:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "visibility-notify-event", 
                           G_CALLBACK(ClientEventHandler::on_visibility_notify_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_visibility_notify_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_visibility_notify_event));
                event_set=1;
                break;
        case EVENT_ON_CLIENT:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "client-event", 
                           G_CALLBACK(ClientEventHandler::on_client_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_client_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_client_event));
                event_set=1;
                break;
        case EVENT_ON_NOEXPOSE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "no-expose-event", 
                           G_CALLBACK(ClientEventHandler::on_no_expose_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_no_expose_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_no_expose_event));
                event_set=1;
                break;
        case EVENT_ON_WINDOWSTATE:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "window-state-event", 
                           G_CALLBACK(ClientEventHandler::on_window_state_event), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_window_state_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_window_state_event));
                event_set=1;
                break;
        case EVENT_ON_SELECTIONGET:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "selection-get", 
                           G_CALLBACK(ClientEventHandler::on_selection_get), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_selection_get().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_selection_get));
                event_set=1;
                break;
        case EVENT_ON_SELECTIONRECEIVED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "selection-received", 
                           G_CALLBACK(ClientEventHandler::on_selection_received), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_selection_received().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_selection_received));
                event_set=1;
                break;
        case EVENT_ON_DRAGBEGIN:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-begin", 
                               G_CALLBACK(ClientEventHandler::on_drag_begin), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-begin", 
                           G_CALLBACK(ClientEventHandler::on_drag_begin), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_begin().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_begin));
                event_set=1;
                break;
        case EVENT_ON_DRAGEND:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-end", 
                               G_CALLBACK(ClientEventHandler::on_drag_end), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-end", 
                           G_CALLBACK(ClientEventHandler::on_drag_end), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_end().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_end));
                event_set=1;
                break;
        case EVENT_ON_DRAGDATAGET:
                HANDLER->SetDragEvent();
                event_set=1;
                //((Gtk::Widget *)item->ptr)->signal_drag_data_get().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_data_get));
                break;
        case EVENT_ON_DRAGDATADELETE:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-data-delete", 
                               G_CALLBACK(ClientEventHandler::on_drag_data_delete), 
                               HANDLER);
                }

                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-data-delete", 
                           G_CALLBACK(ClientEventHandler::on_drag_data_delete), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_data_delete().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_data_delete));
                event_set=1;
                break;
        case EVENT_ON_DRAGLEAVE:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-leave", 
                               G_CALLBACK(ClientEventHandler::on_drag_leave), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-leave", 
                           G_CALLBACK(ClientEventHandler::on_drag_leave), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_leave().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_leave));
                event_set=1;
                break;
        case EVENT_ON_DRAGMOTION:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-motion", 
                               G_CALLBACK(ClientEventHandler::on_drag_motion), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-motion", 
                           G_CALLBACK(ClientEventHandler::on_drag_motion), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_motion().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_motion));
                event_set=1;
                break;
        case EVENT_ON_DRAGDROP:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-drop", 
                               G_CALLBACK(ClientEventHandler::on_drag_drop), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-drop", 
                           G_CALLBACK(ClientEventHandler::on_drag_drop), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_drop().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_drop));
                event_set=1;
                break;
        case EVENT_ON_DRAGDATARECEIVED:
                if (item->type==CLASS_COMBOBOXTEXT) {
                    g_signal_connect(
                               G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                               "drag-data-received", 
                               G_CALLBACK(ClientEventHandler::on_drag_data_received), 
                               HANDLER);
                }
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "drag-data-received", 
                           G_CALLBACK(ClientEventHandler::on_drag_data_received), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_drag_data_received().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_data_received));
                event_set=1;
                break;
        case EVENT_ON_SCREENCHANGED:
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)), 
                           "screen-changed", 
                           G_CALLBACK(ClientEventHandler::on_screen_changed), 
                           HANDLER
                );
                //((Gtk::Widget *)item->ptr)->signal_screen_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_screen_changed));
                event_set=1;
                break;
        case EVENT_ON_CLICKED:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        /*((Gtk::Button *)item->ptr)->signal_clicked().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_clicked));
                        event_set=1;
                        break;*/
                    case CLASS_TOOLBUTTON:
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "clicked", 
                                   G_CALLBACK(ClientEventHandler::on_clicked), 
                                   HANDLER
                        );
                        //((Gtk::ToolButton *)item->ptr)->signal_clicked().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_clicked));
                        event_set=1;
                        break;
                    case CLASS_LABEL:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "activate-link", 
                                   G_CALLBACK(ClientEventHandler::on_link_activated), 
                                   HANDLER
                        );
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_TOGGLED:
            {
                switch (item->type) {
                    case CLASS_RADIOBUTTON:
                    case CLASS_CHECKBUTTON:
                        /*((Gtk::ToggleButton *)item->ptr)->signal_toggled().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_toggled));
                        event_set=1;
                        break;*/
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "toggled", 
                                   G_CALLBACK(ClientEventHandler::on_toggled), 
                                   HANDLER
                        );
                        //((Gtk::ToggleToolButton *)item->ptr)->signal_toggled().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_toggled));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_GROUPCHANGED:
            {
                switch (item->type) {
                    case CLASS_RADIOBUTTON:
                        /*((Gtk::RadioButton *)item->ptr)->signal_group_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_group_changed));
                        event_set=1;
                        break;*/
                    case CLASS_RADIOMENUITEM:
                        //((Gtk::RadioMenuItem *)item->ptr)->signal_group_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_group_changed));
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "group-changed", 
                                   G_CALLBACK(ClientEventHandler::on_group_changed), 
                                   HANDLER
                        );
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_ACTIVATE:
            {
                switch (item->type) {
                    case CLASS_COMBOBOXTEXT:
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_activate().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_activate));
                        g_signal_connect(
                                   G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                                   "activate", 
                                   G_CALLBACK(ClientEventHandler::on_activate), 
                                   HANDLER
                        );
                        event_set=1;
                        break;
                    case CLASS_BUTTON:
                        /*((Gtk::Button *)item->ptr)->signal_activate().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_activate));
                        event_set=1;
                        break;*/
                    case CLASS_EDIT:
                        /*((Gtk::Entry *)item->ptr)->signal_activate().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_activate));
                        event_set=1;
                        break;*/
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_SEPARATORMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_TEAROFFMENUITEM:
                    case CLASS_MENUITEM:
                    case CLASS_RADIOMENUITEM:
                        //((Gtk::MenuItem *)item->ptr)->signal_activate().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_activate));
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "activate", 
                                   G_CALLBACK(ClientEventHandler::on_activate), 
                                   HANDLER
                        );
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_ACTIVATEITEM:
            {
                switch (item->type) {
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_SEPARATORMENUITEM:
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_TEAROFFMENUITEM:
                    case CLASS_MENUITEM:
                        //((Gtk::MenuItem *)item->ptr)->signal_activate_item().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_activate_item));
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "activate-item", 
                                   G_CALLBACK(ClientEventHandler::on_activate_item), 
                                   HANDLER
                        );
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_PRESSED:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "pressed", 
                                   G_CALLBACK(ClientEventHandler::on_pressed), 
                                   HANDLER
                        );
                        //((Gtk::Button *)item->ptr)->signal_pressed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_pressed));
                        event_set=1;
                        break;
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
					case CLASS_EDIT:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "icon-press", 
                                   G_CALLBACK(ClientEventHandler::on_icon_press), 
                                   HANDLER
                        );
                        //((Gtk::Entry *)item->ptr)->signal_icon_press().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_icon_press));
                        event_set=1;
						break;
					case CLASS_COMBOBOXTEXT:
                        g_signal_connect(
                                   G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                                   "icon-press", 
                                   G_CALLBACK(ClientEventHandler::on_icon_press), 
                                   HANDLER
                        );
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_icon_press().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_icon_press));
                        event_set=1;
						break;
#endif
                }
            }
            break;
        case EVENT_ON_RELEASED:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        event_set=1;
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "released", 
                                   G_CALLBACK(ClientEventHandler::on_released), 
                                   HANDLER
                        );
                        //((Gtk::Button *)item->ptr)->signal_released().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_released));
                        break;
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
					case CLASS_EDIT:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "icon-release", 
                                   G_CALLBACK(ClientEventHandler::on_icon_release), 
                                   HANDLER
                        );
                        //((Gtk::Entry *)item->ptr)->signal_icon_release().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_icon_release));
                        event_set=1;
						break;
					case CLASS_COMBOBOXTEXT:
                        g_signal_connect(
                                   G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                                   "icon-release", 
                                   G_CALLBACK(ClientEventHandler::on_icon_release), 
                                   HANDLER
                        );
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_icon_release().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_icon_release));
                        event_set=1;
						break;
#endif
                }
            }
            break;
        case EVENT_ON_ENTER:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "enter", 
                                   G_CALLBACK(ClientEventHandler::on_enter), 
                                   HANDLER
                        );
                        //((Gtk::Button *)item->ptr)->signal_enter().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_enter));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_LEAVE:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "leave", 
                                   G_CALLBACK(ClientEventHandler::on_leave), 
                                   HANDLER
                        );
                        //((Gtk::Button *)item->ptr)->signal_leave().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_leave));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_INSERTATCURSOR:
            {
                switch (item->type) {
                    case CLASS_COMBOBOXTEXT:
                        g_signal_connect(
                                   G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                                   "insert-at-cursor", 
                                   G_CALLBACK(ClientEventHandler::on_insert_at_cursor), 
                                   HANDLER
                        );
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_insert_at_cursor().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_insert_at_cursor));
                        event_set=1;
                        break;
                    case CLASS_EDIT:
                        /*((Gtk::Entry *)item->ptr)->signal_insert_at_cursor().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_insert_at_cursor));
                        event_set=1;
                        break;*/
                    case CLASS_TEXTVIEW:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "insert-at-cursor", 
                                   G_CALLBACK(ClientEventHandler::on_insert_at_cursor), 
                                   HANDLER
                        );
                        //((Gtk::TextView *)item->ptr)->signal_insert_at_cursor().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_insert_at_cursor));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_POPULATEPOPUP:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        /*((Gtk::Entry *)item->ptr)->signal_populate_popup().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_populate_popup));
                        event_set=1;
                        break;*/
                    case CLASS_TEXTVIEW:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "populate-popup", 
                                   G_CALLBACK(ClientEventHandler::on_populate_popup), 
                                   HANDLER
                        );
                        //((Gtk::TextView *)item->ptr)->signal_populate_popup().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_populate_popup));
                        event_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        g_signal_connect(
                                   G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), 
                                   "populate-popup", 
                                   G_CALLBACK(ClientEventHandler::on_populate_popup), 
                                   HANDLER
                        );
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->signal_populate_popup().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_populate_popup));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_SETANCHOR:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "set-anchor", 
                                   G_CALLBACK(ClientEventHandler::on_set_anchor), 
                                   HANDLER
                        );
                        //((Gtk::TextView *)item->ptr)->signal_set_anchor().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_set_anchor));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_SETSCROLLADJUSTMENTS:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        /*((Gtk::TextView *)item->ptr)->signal_set_scroll_adjustments().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_set_scroll_adjustments));
                        event_set=1;
                        break;*/
                    case CLASS_VIEWPORT:
                        /*((Gtk::Viewport *)item->ptr)->signal_set_scroll_adjustments().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_set_scroll_adjustments));
                        event_set=1;
                        break;*/
                    case CLASS_TREEVIEW:
                        /*((Gtk::TreeView *)item->ptr)->signal_set_scroll_adjustments().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_set_scroll_adjustments));
                        event_set=1;
                        break;*/
                    case CLASS_ICONVIEW:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "set-scroll-adjustments", 
                                   G_CALLBACK(ClientEventHandler::on_set_scroll_adjustments), 
                                   HANDLER
                        );
                        //((Gtk::IconView *)item->ptr)->signal_set_scroll_adjustments().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_set_scroll_adjustments));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_INPUT:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "input", 
                                   G_CALLBACK(ClientEventHandler::on_input), 
                                   HANDLER
                        );
                        //((Gtk::SpinButton *)item->ptr)->signal_input().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_input));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_OUTPUT:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "output", 
                                   G_CALLBACK(ClientEventHandler::on_output), 
                                   HANDLER
                        );
                        //((Gtk::SpinButton *)item->ptr)->signal_output().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_output));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_VALUECHANGED:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        /*((Gtk::SpinButton *)item->ptr)->signal_value_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_value_changed));
                        event_set=1;
                        break;*/
                    case CLASS_ADJUSTMENT:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "value-changed", 
                                   G_CALLBACK(ClientEventHandler::on_value_changed), 
                                   HANDLER
                        );
                        //((Gtk::Adjustment *)item->ptr)->signal_value_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_value_changed));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_FRAMEEVENT:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "frame-event", 
                                   G_CALLBACK(ClientEventHandler::on_frame_event), 
                                   HANDLER
                        );
                        //((Gtk::Window *)item->ptr)->signal_frame_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_frame_event));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_SETFOCUS:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "set-focus", 
                                   G_CALLBACK(ClientEventHandler::on_set_focus), 
                                   HANDLER
                        );
                        //((Gtk::Window *)item->ptr)->signal_set_focus().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_set_focus));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_SWITCHPAGE:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "switch-page", 
                                   G_CALLBACK(ClientEventHandler::on_switch_page), 
                                   HANDLER
                        );
                        //((Gtk::Notebook *)item->ptr)->signal_switch_page().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_switch_page));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_CHANGED:
            {
                switch (item->type) {
                    case CLASS_ICONVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedComboBox *)item->ptr)->handle), 
                                   "selection-changed", 
                                   G_CALLBACK(ClientEventHandler::on_changed), 
                                   HANDLER
                        );
                        //((DeturnatedIconView *)item->ptr)->signal_selection_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_changed));
                        event_set=1;
                        break;
                    case CLASS_ADJUSTMENT:
                        /*((Gtk::Adjustment *)item->ptr)->signal_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_changed));
                        event_set=1;
                        break;*/
                    case CLASS_COMBOBOXTEXT:
                    case CLASS_COMBOBOX:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "changed", 
                                   G_CALLBACK(ClientEventHandler::on_changed), 
                                   HANDLER
                        );
                        //((Gtk::ComboBox *)item->ptr)->signal_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_changed));
                        event_set=1;
                        break;
                    case CLASS_PROPERTIESBOX:
                        ((PropertiesPanel *)item->extra_ptr)->MapOnChangeEvent(Owner,owner);
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_CHILDATTACHED:
            {
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "child-attached", 
                                   G_CALLBACK(ClientEventHandler::on_child_attached), 
                                   HANDLER
                        );
                        //((Gtk::HandleBox *)item->ptr)->signal_child_attached().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_child_attached));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_CHILDDETACHED:
            {
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "child-detached", 
                                   G_CALLBACK(ClientEventHandler::on_child_detached), 
                                   HANDLER
                        );
                        //((Gtk::HandleBox *)item->ptr)->signal_child_detached().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_child_detached));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_ORIENTATIONCHANGED:
            {
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "orientation-changed", 
                                   G_CALLBACK(ClientEventHandler::on_orientation_changed), 
                                   HANDLER
                        );
                        //((Gtk::Toolbar *)item->ptr)->signal_orientation_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_orientation_changed));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_POPUPCONTEXTMENU:
            {
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "popup-context-menu", 
                                   G_CALLBACK(ClientEventHandler::on_popup_context_menu), 
                                   HANDLER
                        );
                        //((Gtk::Toolbar *)item->ptr)->signal_popup_context_menu().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_popup_context_menu));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_TOOLBARSTYLECHANGED:
            {
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "toolbar-style-changed", 
                                   G_CALLBACK(ClientEventHandler::on_toolbar_style_changed), 
                                   HANDLER
                        );
                        //((Gtk::Toolbar *)item->ptr)->signal_toolbar_style_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_toolbar_style_changed));
                        event_set=1;
                        break;
                }
            }
            break;
        case EVENT_ON_CREATEMENUPROXY:
                switch (item->type) {
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "create-menu-proxy", 
                                   G_CALLBACK(ClientEventHandler::on_create_menu_proxy), 
                                   HANDLER
                        );
                        //((Gtk::ToolButton *)item->ptr)->signal_create_menu_proxy().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_create_menu_proxy));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_TOOLBARRECONFIGURED:
                switch (item->type) {
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "toolbar-reconfigured", 
                                   G_CALLBACK(ClientEventHandler::on_toolbar_reconfigured), 
                                   HANDLER
                        );
                        //((Gtk::ToolButton *)item->ptr)->signal_toolbar_reconfigured().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_toolbar_reconfigured));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_SHOWMENU:
                switch (item->type) {
                    case CLASS_MENUTOOLBUTTON:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "show-menu", 
                                   G_CALLBACK(ClientEventHandler::on_show_menu), 
                                   HANDLER
                        );
                        //((Gtk::MenuToolButton *)item->ptr)->signal_show_menu().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_show_menu));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_COLUMNSCHANGED:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedTreeView *)item->ptr)->handle), 
                                   "columns-changed", 
                                   G_CALLBACK(ClientEventHandler::on_columns_changed), 
                                   HANDLER
                        );
                        //((Gtk::TreeView *)item->ptr)->signal_columns_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_columns_changed));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_CURSORCHANGED:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedTreeView *)item->ptr)->handle), 
                                   "cursor-changed", 
                                   G_CALLBACK(ClientEventHandler::on_cursor_changed), 
                                   HANDLER
                        );
                        //((Gtk::TreeView *)item->ptr)->signal_cursor_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_cursor_changed));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_ROWACTIVATED:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedTreeView *)item->ptr)->handle), 
                                   "row-activated", 
                                   G_CALLBACK(ClientEventHandler::on_row_activated), 
                                   HANDLER
                        );
                        //((Gtk::TreeView *)item->ptr)->signal_row_activated().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_row_activated));
                        event_set=1;
                        break;
                    case CLASS_ICONVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedTreeView *)item->ptr)->handle), 
                                   "item-activated", 
                                   G_CALLBACK(ClientEventHandler::on_item_activated), 
                                   HANDLER
                        );
                        //((Gtk::IconView *)item->ptr)->signal_item_activated().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_item_activated));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_HEADERCLICKED :
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        HANDLER->refresh_events(item->ptr,COLUMN_LINKED);
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_ROWCOLLAPSED:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedTreeView *)item->ptr)->handle), 
                                   "row-collapsed", 
                                   G_CALLBACK(ClientEventHandler::on_row_collapsed), 
                                   HANDLER
                        );
                        //((Gtk::TreeView *)item->ptr)->signal_row_collapsed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_row_collapsed));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_ROWEXPANDED:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        g_signal_connect(
                                   G_OBJECT(((DeturnatedTreeView *)item->ptr)->handle), 
                                   "row-expanded", 
                                   G_CALLBACK(ClientEventHandler::on_row_expanded), 
                                   HANDLER
                        );
                        //((Gtk::TreeView *)item->ptr)->signal_row_expanded().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_row_expanded));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_STARTEDITING:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        HANDLER->refresh_events(item->ptr,START_EDITING);
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_CANCELEDITING:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        HANDLER->refresh_events(item->ptr,CANCEL_EDITING);
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_ENDEDITING:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        HANDLER->refresh_events(item->ptr, END_EDITING);
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_DAYSELECTED:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "day-selected", 
                                   G_CALLBACK(ClientEventHandler::on_day_selected), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_day_selected().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_day_selected));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_DAYSELECTEDDBCLICK:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "day-selected-double-click", 
                                   G_CALLBACK(ClientEventHandler::on_day_selected_double_click), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_day_selected_double_click().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_day_selected_double_click));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_MONTHCHANGED:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "month-changed", 
                                   G_CALLBACK(ClientEventHandler::on_month_changed), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_month_changed().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_month_changed));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_NEXTMONTH:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "next-month", 
                                   G_CALLBACK(ClientEventHandler::on_next_month), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_next_month().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_next_month));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_NEXTYEAR:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "next-year", 
                                   G_CALLBACK(ClientEventHandler::on_next_year), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_next_year().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_next_year));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_PREVMONTH:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "prev-month", 
                                   G_CALLBACK(ClientEventHandler::on_prev_month), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_prev_month().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_prev_month));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_PREVYEAR:
                switch (item->type) {
                    case CLASS_CALENDAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "prev-year", 
                                   G_CALLBACK(ClientEventHandler::on_prev_year), 
                                   HANDLER
                        );
                        //((Gtk::Calendar *)item->ptr)->signal_prev_year().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_prev_year));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_ADJUSTBOUNDS:
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                    case CLASS_VSCROLLBAR:
                    case CLASS_HSCROLLBAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "adjust-bounds", 
                                   G_CALLBACK(ClientEventHandler::on_adjust_bounds), 
                                   HANDLER
                        );
                        //((Gtk::Range *)item->ptr)->signal_adjust_bounds().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_adjust_bounds));
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_CHANGEVALUE:
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                    case CLASS_VSCROLLBAR:
                    case CLASS_HSCROLLBAR:
                        //((Gtk::Range *)item->ptr)->signal_change_value().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_change_value));
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "change-value", 
                                   G_CALLBACK(ClientEventHandler::on_change_value), 
                                   HANDLER
                        );
                        event_set=1;
                        break;
                }
                break;
        case EVENT_ON_MOVESLIDER:
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                    case CLASS_VSCROLLBAR:
                    case CLASS_HSCROLLBAR:
                        g_signal_connect(
                                   G_OBJECT(SAFE_WIDGET(item)), 
                                   "move-slider", 
                                   G_CALLBACK(ClientEventHandler::on_move_slider), 
                                   HANDLER
                        );
                        //((Gtk::Range *)item->ptr)->signal_move_slider().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_move_slider));
                        event_set=1;
                        break;
                }
                break;
        default:
                SetCustomEvent(item, event_id, value);
                event_set=1;
                break;
    }
    if (!event_set)
        SetCustomEvent(item, event_id, value);
    return 0;
}

int SetCustomProperty(GTKControl *item, int prop_id, AnsiString *value) {
    INVOKER Invoke=GetRequiredInvoker(item->type);
    if (!Invoke)
        return 0;

    return IS_OK(Invoke(item->ptr, INVOKE_SETPROPERTY, (int)item->type, (int)prop_id, value->c_str(), (int)value->Length()));
}

int SetProperty(long owner, int prop_id, AnsiString *value, CConceptClient *Owner) {
    GTKControl *item=GetControlID(owner);
    if (!item) {
        std::cerr << "Error setting property: Invalid RID in owner\n";
        return 0;
    }
    char property_set=0;

    switch (prop_id) {
        case P_FIXED:
            {
                switch (item->type) {
                    case CLASS_FORM               :
                    case CLASS_HBOX               :
                    case CLASS_VBOX               :
                    case CLASS_HBUTTONBOX         :
                    case CLASS_VBUTTONBOX         :
                    case CLASS_FRAME              :
                    case CLASS_ASPECTFRAME        :
                    case CLASS_HPANED             :
                    case CLASS_VPANED             :
                    case CLASS_SCROLLEDWINDOW     :
                    case CLASS_EVENTBOX           :
                    case CLASS_EXPANDER           :
                    case CLASS_VIEWPORT           :
                    case CLASS_HANDLEBOX          :
                    case CLASS_STATUSBAR          :
                    {
                        if (!item->fixed_ptr) {
                            GtkWidget *box=gtk_fixed_new();
                            if ((item->type==CLASS_SCROLLEDWINDOW) && (GTK_WIDGET_GET_CLASS(box)->set_scroll_adjustments_signal == 0))
                                gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(item->ptr), box);
                            else
                                gtk_container_add(GTK_CONTAINER(item->ptr), box);
                            item->fixed_ptr=box;
                            gtk_widget_show(box);
                        }
                        property_set=1;
                    }
                }
            }
            break;
        case P_PACKTYPE:
            item->pack_type=(char)value->ToInt();
            property_set=1;
            break;
        case P_FOCUS:
            if (value->ToInt())
                gtk_widget_grab_focus(SAFE_WIDGET(item));
            property_set=1;
            break;
        case P_POPUPMENU:
            {
                switch (item->type) {
                    case CLASS_EVENTBOX:
                    default:
                        {
                            GTKControl *item2=GetControlID(value->ToInt());
                            if ((!item2) || (item2->type!=CLASS_MENU))
                                break;

                            //Targets:
                            if (!item->event_handler) {
                                item->event_handler=new ClientEventHandler(owner,Owner);
                                //((Gtk::Widget *)item->ptr)->set_events(Gdk::ALL_EVENTS_MASK);
                            }

                            ClientEventHandler *HANDLER=(ClientEventHandler *)item->event_handler;
                            HANDLER->SetPopup((GtkMenu *)item2->ptr);
                                         //((Gtk::Widget *)item->ptr)->signal_button_press_event().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_button_press_event));
                            //((Gtk::Widget *)item->ptr)->signal_button_press_event().connect_notify(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_button_press_notify_event));

                            g_signal_connect(
                                       G_OBJECT(SAFE_WIDGET(item)),
                                       "button-press-event", 
                                       G_CALLBACK(ClientEventHandler::on_button_press_notify_event), 
                                       HANDLER
                            );
                            
                            property_set=1;
                        }
                        break;
                }
            }
            break;
        case P_DRAGDATA:
            {
                //Targets:
                if (!item->event_handler)
                    item->event_handler=new ClientEventHandler(owner,Owner);
                
                ClientEventHandler *HANDLER=(ClientEventHandler *)item->event_handler;
                HANDLER->SetDragData(*value);
                property_set=1;
            }
            break;
        case P_DRAGOBJECT:
            {
                property_set=1;
                //Targets:
                if (value->ToInt()) {
                    //((Gtk::Widget *)item->ptr)->drag_source_set(listTargets);
                    gtk_drag_source_set(SAFE_WIDGET(item), GDK_BUTTON1_MASK, listTargets, sizeof (listTargets) / sizeof (listTargets[0]), GDK_ACTION_COPY);
                    gtk_drag_source_add_text_targets(SAFE_WIDGET(item));
                } else {
                    gtk_drag_source_unset(SAFE_WIDGET(item));
                    break;
                }

                // evenimentul in care setez data_get
                if (!item->event_handler)
                    item->event_handler=new ClientEventHandler(owner,Owner);
                
                ClientEventHandler *HANDLER=(ClientEventHandler *)item->event_handler;
                //((Gtk::Widget *)item->ptr)->signal_drag_data_get().connect(sigc::mem_fun(*HANDLER, &ClientEventHandler::on_drag_data_get));
                g_signal_connect(
                           G_OBJECT(SAFE_WIDGET(item)),
                           "drag-data-get", 
                           G_CALLBACK(ClientEventHandler::on_drag_data_get), 
                           HANDLER
                );
            }
            break;
        case P_DRAGICON:
            {
                property_set=1;
                GTKControl *item2=GetControlID(value->ToInt());
                GdkPixbuf *pbuf=0;
                if ((!item2) || (item2->type!=CLASS_IMAGE)) {
                    /*int dwidth, dheight;
                    GdkWindow *backwindow=gtk_widget_get_window(SAFE_WIDGET(item2));
                    if (backwindow) {
                        gdk_drawable_get_size(backwindow,&dwidth, &dheight);
                        pbuf = gdk_pixbuf_get_from_drawable (NULL,  
                                                                backwindow,
                                                                NULL,  
                                                                0, 0, 
                                                                0, 0, 
                                                                dwidth, dheight); 
                    }*/
                    GdkPixmap *tmp_map = gtk_widget_get_snapshot(SAFE_WIDGET(item2), NULL);
                    if (tmp_map)
                        pbuf = gdk_pixbuf_get_from_drawable(NULL, tmp_map, NULL,  0, 0, 0, 0, -1, -1); 
                } else
                    pbuf=ForcePixbuf(item2->ptr);
                if (pbuf)
                    gtk_drag_source_set_icon_pixbuf(SAFE_WIDGET(item), pbuf/*((Gtk::Image *)item2->ptr)->property_pixbuf()*/);
            }
            break;
        case P_DROPSITE:
            {
                //Targets:
                property_set=1;
				switch(value->ToInt()) {
					case 0:
                        gtk_drag_dest_unset(SAFE_WIDGET(item));
						break;
					case 2:
                        //gtk_drag_dest_set(SAFE_WIDGET(item), GTK_DEST_DEFAULT_ALL,targets,n_targets,GDK_ACTION_DEFAULT);
                        gtk_drag_dest_set(SAFE_WIDGET(item), GTK_DEST_DEFAULT_ALL, listTargetsFiles, sizeof (listTargetsFiles) / sizeof (listTargetsFiles[0]), GDK_ACTION_COPY);
						//((Gtk::Widget *)item->ptr)->drag_dest_set(listTargetsFiles);
                        gtk_drag_dest_add_uri_targets(SAFE_WIDGET(item));
						break;
					case 3:
                        gtk_drag_dest_set(SAFE_WIDGET(item), GTK_DEST_DEFAULT_ALL, listTargetsFull, sizeof (listTargetsFull) / sizeof (listTargetsFull[0]), GDK_ACTION_COPY);
                        gtk_drag_dest_add_uri_targets(SAFE_WIDGET(item));
                        gtk_drag_dest_add_text_targets(SAFE_WIDGET(item));
						//((Gtk::Widget *)item->ptr)->drag_dest_set(listTargetsFull);
						break;
					case 1:
					default:
                        gtk_drag_dest_set(SAFE_WIDGET(item), GTK_DEST_DEFAULT_ALL, listTargets, sizeof (listTargets) / sizeof (listTargets[0]), GDK_ACTION_COPY);
						//((Gtk::Widget *)item->ptr)->drag_dest_set(listTargets);
                        gtk_drag_dest_add_text_targets(SAFE_WIDGET(item));
						break;
				}
            }
            break;
        case P_ENABLED:
            gtk_widget_set_sensitive(SAFE_WIDGET(item), value->ToInt());
            property_set=1;
            break;
#ifdef LATEST_GTK
        case P_ICONSIZE:
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        if ((GtkIconSize)value->ToInt()!=GTK_ICON_SIZE_INVALID)
                            gtk_toolbar_set_icon_size(GTK_TOOLBAR(item->ptr), (GtkIconSize)value->ToInt());
						property_set=1;
                        break;
                }
                break;
		case P_TOOLTIPMARKUP:
			//((Gtk::Widget *)item->ptr)->set_tooltip_markup(value->c_str());
            gtk_widget_set_tooltip_markup(SAFE_WIDGET(item), value->c_str());
            property_set=1;
			break;
		case P_TOOLTIPWINDOW:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                if ((!item2) || (item2->type!=CLASS_FORM))
                    break;
                property_set=1;
                gtk_widget_set_tooltip_markup(SAFE_WIDGET(item), (char *)"");
                gtk_widget_set_tooltip_window(SAFE_WIDGET(item), GTK_WINDOW(item2->ptr));
            }
			break;
		case P_SHOWTOOLTIP:
            if (value->ToInt())
                gtk_widget_trigger_tooltip_query(SAFE_WIDGET(item));
            property_set=1;
            break;
		case P_FORMMASK:
            {
                property_set=1;
                if (!value->ToInt()) {
				    gtk_widget_shape_combine_mask(SAFE_WIDGET(item), 0, 0, 0);
                    break;
                }
                GTKControl *item2=GetControlID(value->ToInt());
                if ((!item2) || (item2->type!=CLASS_IMAGE)) {
				    gtk_widget_shape_combine_mask(SAFE_WIDGET(item), 0, 0, 0);
                    break;
                }

                //GdkBitmap *shape_mask = my_gdk_bitmap_new_from_pixbuf_non_alpha(GDK_DRAWABLE(SAFE_WIDGET(item2)), ForcePixbuf(item2->ptr));
				GdkColor *transparent = &gtk_widget_get_default_style()->bg[GTK_STATE_NORMAL];

                GdkPixbuf *pbuf=ForcePixbuf(item2->ptr);
				GdkBitmap *shape_mask = 0;
                if (pbuf) {
                    gchar *data;
                    data = (gchar *)g_new0(guchar, gdk_pixbuf_get_width (pbuf) * gdk_pixbuf_get_height(pbuf)); 
                    shape_mask = gdk_bitmap_create_from_data(gtk_widget_get_window(SAFE_WIDGET(item2)), data, gdk_pixbuf_get_width(pbuf), gdk_pixbuf_get_height (pbuf)); 

                    gdk_pixbuf_render_threshold_alpha(pbuf, shape_mask, 0, 0, 0, 0, -1, -1, 1);
                }
				gtk_widget_shape_combine_mask(SAFE_WIDGET(item), shape_mask, 0, 0);
            }
			break;
#endif
        case P_TOOLTIP:
            {
                property_set=1;
                if ((item->type==CLASS_TOOLBUTTON) ||
                    (item->type==CLASS_TOOLSEPARATOR) ||
                    (item->type==CLASS_MENUTOOLBUTTON) ||
                    (item->type==CLASS_TOGGLETOOLBUTTON)) {

                    gtk_tool_item_set_tooltip_text(GTK_TOOL_ITEM(item->ptr), value->c_str());
                } else {
#ifdef LATEST_GTK
                    gtk_widget_set_tooltip_text(SAFE_WIDGET(item), value->c_str());
#else
                    if (item->tip) {
                        gtk_tool_tips_disable(GTK_TOOLTIPS(item->tip));
                        gtk_tool_tips_unset_tip(GTK_TOOLTIPS(item->tip), SAFE_WIDGET(item->ptr));
                        g_object_unref(G_OBJECT(item->tip));
                        
                        item->tip=0;
                    }
                    if (*value!=(char*)"") {
                        GtkTooltips *tip=gtk_tooltips_new();
                        gtk_tool_tips_set_tip(GTK_TOOLTIPS(item->tip), SAFE_WIDGET(item->ptr), value->c_str());
                        gtk_tool_tips_enable(GTK_TOOLTIPS(item->tip));
                        item->tip=tip;
                    }
#endif
                }
            }
            break;
        case P_ADDTEXT:
            {
                GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                GtkTextIter iter;
                gtk_text_buffer_get_end_iter(refTextBuffer, &iter);
                int len=value->Length();
                char *s=value->c_str();
                if ((len>0) && (s) && (s[len-1]==0)) {
                    len--;
                }
                gtk_text_buffer_insert(refTextBuffer, &iter, s, len);
                property_set=1;
            }
            break;
        case P_MENUOBJECT:
            {
                switch (item->type) {
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_MENUITEM:
                        {
                            GTKControl *item2=GetControlID(value->ToInt());
                            if (!item2)
                                break;

                            GtkWidget *wgt=gtk_bin_get_child(GTK_BIN(item->ptr));

                            if (wgt)
                                gtk_container_remove(GTK_CONTAINER(item->ptr), wgt);
                            
                            gtk_container_add(GTK_CONTAINER(item->ptr), SAFE_WIDGET(item2));
                            property_set=1;
                        }
                        break;
                }
            }
            break;
        case P_CAPTION:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        property_set=1;
                        //((Gtk::Window *)item->ptr)->set_title(value->c_str());
                        //g_object_set(G_OBJECT(SAFE_WIDGET(item)), "title", value->c_str(), NULL);
                        gtk_window_set_title(GTK_WINDOW(item->ptr), value->c_str());
                        break;
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        //((Gtk::Button *)item->ptr)->set_label(value->c_str());
                        if (value->Length())
                            gtk_button_set_label(GTK_BUTTON(item->ptr), value->c_str());
                        else
                            gtk_button_set_label(GTK_BUTTON(item->ptr), "");
                        property_set=1;
                        break;
                    case CLASS_EDIT:
                        //((Gtk::Entry *)item->ptr)->set_text(value->c_str());
                        if (value->Length())
                            gtk_entry_set_text(GTK_ENTRY(item->ptr), value->c_str());
                        else
                            gtk_entry_set_text(GTK_ENTRY(item->ptr), "");
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        if (value->Length())
                            gtk_entry_set_text(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(MY_COMBO_BOX(item->ptr)))), value->c_str());
                        else
                            gtk_entry_set_text(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(MY_COMBO_BOX(item->ptr)))), "");
                        property_set=1;
                        break;
                    case CLASS_LABEL:
                        if (gtk_label_get_use_markup(GTK_LABEL(item->ptr)))
                           gtk_label_set_markup(GTK_LABEL(item->ptr), value->c_str());
                        else
                           gtk_label_set_text(GTK_LABEL(item->ptr), value->c_str());
                        property_set=1;
                        break;
                    case CLASS_FRAME:
                    case CLASS_ASPECTFRAME:
                        {
                            GtkWidget *label=gtk_frame_get_label_widget(GTK_FRAME(item->ptr));
                            if ((label) && (gtk_label_get_use_markup(GTK_LABEL(label))))
                               gtk_label_set_markup(GTK_LABEL(label), value->c_str());
                            else
                               gtk_label_set_text(GTK_LABEL(label), value->c_str());
                        }
                        property_set=1;
                        break;
                    case CLASS_PROGRESSBAR:
                        if (value->Length())
                            gtk_progress_bar_set_text(GTK_PROGRESS_BAR(item->ptr), value->c_str());
                        else
                            gtk_progress_bar_set_text(GTK_PROGRESS_BAR(item->ptr), "");
                        property_set=1;
                        break;
                    case CLASS_TEXTVIEW:
                        {
                            GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));                            
                            int len=value->Length();
                            char *s=value->c_str();
                            if ((len>0) && (s) && (s[len-1]==0)) {
                                len--;
                            }
                            gtk_text_buffer_set_text(refTextBuffer, s, len);
                        }
                        property_set=1;
                        break;
                    case CLASS_MENU:
                        gtk_menu_set_title(GTK_MENU(item->ptr), value->c_str());
                        property_set=1;
                        break;
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_MENUITEM:
                        {
                            GtkLabel *lab = GTK_LABEL(gtk_bin_get_child(GTK_BIN(item->ptr)));
                            if ( lab )
                                gtk_label_set_text(lab, value->c_str() );
                            property_set=1;
                        }
                        break;
                    case CLASS_EXPANDER:
                        {
                            GtkLabel *label=GTK_LABEL(gtk_expander_get_label_widget(GTK_EXPANDER(item->ptr)));
                            if ((label) && (gtk_label_get_use_markup(label)))
                               gtk_label_set_markup(label, value->c_str());
                            else
                               gtk_label_set_text(label, value->c_str());
                        }
                        property_set=1;
                        break;
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                        gtk_tool_button_set_label(GTK_TOOL_BUTTON(item->ptr), value->c_str());
                        property_set=1;
                        break;
                    case CLASS_STATUSBAR:
                        gtk_statusbar_push(GTK_STATUSBAR(item->ptr), 0, value->c_str());
                        property_set=1;
                    /*case CLASS_COMBOBOX:
                        ((Gtk::ComboBox *)item->ptr)->set_title(value->c_str());
                        break;*/
                    /*case CLASS_HTML:
                        ((Gtk::HTML *)item->ptr)->load_from_string(value->c_str());
                        break;*/
                }
            }
            break;
        case P_DECORATIONS:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            GdkWindow *wnd=gtk_widget_get_window(SAFE_WIDGET(item));
                            if (wnd)
                                gdk_window_set_decorations(wnd, (GdkWMDecoration)value->ToInt());

                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_SKIPTASKBAR:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            gtk_window_set_skip_taskbar_hint(GTK_WINDOW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_KEEPABOVE:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            gtk_window_set_keep_above(GTK_WINDOW(item->ptr),value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_KEEPBELOW:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            gtk_window_set_keep_below(GTK_WINDOW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_SKIPPAGER:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            gtk_window_set_skip_pager_hint(GTK_WINDOW(item->ptr),value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_RESIZABLE:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            gtk_window_set_resizable(GTK_WINDOW(item->ptr),value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_HEIGHT:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_size(GTK_WINDOW(item->ptr),&x,&y);
                            gtk_window_resize(GTK_WINDOW(item->ptr),x,value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_WIDTH:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_size(GTK_WINDOW(item->ptr),&x,&y);
                            gtk_window_resize(GTK_WINDOW(item->ptr),value->ToInt(),y);
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_LEFT:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_position(GTK_WINDOW(item->ptr),&x,&y);
                            gtk_window_move(GTK_WINDOW(item->ptr),value->ToInt(),y);
                            property_set=1;
                            break;
                        }
                    default:
                        {
                            GTKControl *parent=GetControlID(item->parent_id);
                            if ((parent) && (parent->fixed_ptr)) {
                                item->x=value->ToInt();
                                gtk_fixed_move(GTK_FIXED(parent->fixed_ptr), SAFE_WIDGET(item),item->x,item->y);
                            }
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_TOP:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_position(GTK_WINDOW(item->ptr),&x,&y);
                            gtk_window_move(GTK_WINDOW(item->ptr),x,value->ToInt());
                            property_set=1;
                        }
                        break;
                    default:
                        {
                            GTKControl *parent=GetControlID(item->parent_id);
                            if ((parent) && (parent->fixed_ptr)) {
                                item->y=value->ToInt();
                                gtk_fixed_move(GTK_FIXED(parent->fixed_ptr), SAFE_WIDGET(item),item->x,item->y);
                            }
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_MODAL:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            gtk_window_set_modal(GTK_WINDOW(item->ptr),value->ToInt());
                            property_set=1;
                            break;
                        }
                }
            }
            break;
        case P_MAXIMIZED:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            property_set=1;
                            if (value->ToInt())
                                gtk_window_maximize(GTK_WINDOW(item->ptr));
                            else
                                gtk_window_unmaximize(GTK_WINDOW(item->ptr));
                            break;
                        }
                    case CLASS_SCROLLEDWINDOW:
						{
                            //GtkAllocation allocation;
                            //gtk_widget_get_allocation(GTK_SCROLLED_WINDOW(item->ptr), &allocation);

							int orig_width=GTK_WIDGET(item->ptr)->allocation.width;
							int orig_height=GTK_WIDGET(item->ptr)->allocation.height;
							int swwidth = -1;
							int swheight = -1;
							gtk_widget_get_size_request(GTK_WIDGET(item->ptr), &swwidth, &swheight);
							int init_swwidth=swwidth;
							int init_swheight=swheight;
							int swtype=value->ToInt();


							GdkScreen *screen=gtk_widget_get_screen(SAFE_WIDGET(item));
							// horizontal
							if ((swtype==0) || (swtype==3)) { // vadjustment ??
								GtkAdjustment* swha=gtk_scrolled_window_get_hadjustment(GTK_SCROLLED_WINDOW(item->ptr));
								if (swha) {
									int scr_width=-1;
									if (screen)
										scr_width=gdk_screen_get_width(screen)-10;
									swwidth=(int)gtk_adjustment_get_upper(swha);
									if (swwidth>scr_width)
										swwidth=scr_width;
								}
							}
							// vertical
							if ((swtype==1) || (swtype==3)) {
								GtkAdjustment* swva=gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(item->ptr));
								if (swva) {
									int scr_height=-1;
									if (screen)
										scr_height=gdk_screen_get_height(screen)-200;
									swheight=(int)gtk_adjustment_get_upper(swva);
									if (swheight>scr_height)
										swheight=scr_height;
								}
							}

							gtk_widget_set_size_request(SAFE_WIDGET(item), swwidth, swheight);

                            while (gtk_events_pending())
                                   gtk_main_iteration();
							gtk_widget_set_size_request(SAFE_WIDGET(item), init_swwidth, init_swheight);
							property_set=1;
							break;
						}
                }
            }
            break;
        case P_MINIMIZED:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            property_set=1;
                            if (value->ToInt())
                                gtk_window_iconify(GTK_WINDOW(item->ptr));
                            else
                                gtk_window_deiconify(GTK_WINDOW(item->ptr));
                            break;
                        }
                }
            }
            break;
        case P_FULLSCREEN:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            property_set=1;
                            if (value->ToInt())
                                gtk_window_fullscreen(GTK_WINDOW(item->ptr));
                            else
                                gtk_window_unfullscreen(GTK_WINDOW(item->ptr));
                            break;
                        }
                }
            }
            break;
        case P_TITLEBAR:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            property_set=1;
                            gtk_window_set_decorated(GTK_WINDOW(item->ptr), value->ToInt());
                            break;
                        }
                }
            }
            break;
        case P_NORMAL_BG_COLOR:
            {
                int color=value->ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                GdkColor uset_color;
                uset_color.red=((unsigned short)red*0xFF);
                uset_color.green=((unsigned short)green*0xFF);
                uset_color.blue=((unsigned short)blue*0xFF);
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        {
                            GtkWidget *ptr=gtk_bin_get_child(GTK_BIN(item->ptr));
                            if (ptr) {
                                gtk_widget_modify_bg(GTK_WIDGET(ptr),GTK_STATE_NORMAL,&uset_color);
                                gtk_widget_modify_base(GTK_WIDGET(ptr),GTK_STATE_NORMAL,&uset_color);
                            }
                        }
                        break;
                }
                gtk_widget_modify_bg(SAFE_WIDGET(item),GTK_STATE_NORMAL,&uset_color);
                gtk_widget_modify_base(SAFE_WIDGET(item),GTK_STATE_NORMAL,&uset_color);
                property_set=1;
            }
            break;
        case P_INACTIVE_BG_COLOR:
            {
                int color=value->ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                GdkColor uset_color;
                uset_color.red=((unsigned short)red*0xFF);
                uset_color.green=((unsigned short)green*0xFF);
                uset_color.blue=((unsigned short)blue*0xFF);
                gtk_widget_modify_bg(SAFE_WIDGET(item),GTK_STATE_INSENSITIVE,&uset_color);
                gtk_widget_modify_base(SAFE_WIDGET(item),GTK_STATE_INSENSITIVE,&uset_color);

                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        {
                            GtkWidget *ptr=gtk_bin_get_child(GTK_BIN(item->ptr));
                            if (ptr) {
                                gtk_widget_modify_bg(GTK_WIDGET(ptr),GTK_STATE_INSENSITIVE,&uset_color);
                                gtk_widget_modify_base(GTK_WIDGET(ptr),GTK_STATE_INSENSITIVE,&uset_color);
                            }
                        }
                        break;
                }
                property_set=1;
            }
            break;
        case P_SELECTED_BG_COLOR:
            {
                int color=value->ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                GdkColor uset_color;
                uset_color.red=((unsigned short)red*0xFF);
                uset_color.green=((unsigned short)green*0xFF);
                uset_color.blue=((unsigned short)blue*0xFF);
                gtk_widget_modify_bg(SAFE_WIDGET(item),GTK_STATE_SELECTED,&uset_color);
                gtk_widget_modify_base(SAFE_WIDGET(item),GTK_STATE_SELECTED,&uset_color);
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        {
                            GtkWidget *ptr=gtk_bin_get_child(GTK_BIN(item->ptr));
                            if (ptr) {
                                gtk_widget_modify_bg(GTK_WIDGET(ptr),GTK_STATE_SELECTED,&uset_color);
                                gtk_widget_modify_base(GTK_WIDGET(ptr),GTK_STATE_SELECTED,&uset_color);
                            }
                        }
                        break;
                }
                property_set=1;
            }
            break;
        case P_NORMAL_FG_COLOR:
            {
                int color=value->ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                GdkColor uset_color;
                uset_color.red=((unsigned short)red*0xFF);
                uset_color.green=((unsigned short)green*0xFF);
                uset_color.blue=((unsigned short)blue*0xFF);
                gtk_widget_modify_text(SAFE_WIDGET(item),GTK_STATE_NORMAL,&uset_color);
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        {
                            GtkWidget *ptr=gtk_bin_get_child(GTK_BIN(item->ptr));
                            if (ptr) {
                                gtk_widget_modify_fg(GTK_WIDGET(ptr),GTK_STATE_NORMAL,&uset_color);
                                gtk_widget_modify_text(GTK_WIDGET(ptr),GTK_STATE_NORMAL,&uset_color);
                            }
                        }
                        break;
                }
                property_set=1;
            }
            break;
        case P_INACTIVE_FG_COLOR:
            {
                int color=value->ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                GdkColor uset_color;
                uset_color.red=((unsigned short)red*0xFF);
                uset_color.green=((unsigned short)green*0xFF);
                uset_color.blue=((unsigned short)blue*0xFF);
                gtk_widget_modify_text(SAFE_WIDGET(item),GTK_STATE_INSENSITIVE,&uset_color);
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        {
                            GtkWidget *ptr=gtk_bin_get_child(GTK_BIN(item->ptr));
                            if (ptr) {
                                gtk_widget_modify_fg(GTK_WIDGET(ptr),GTK_STATE_INSENSITIVE,&uset_color);
                                gtk_widget_modify_text(GTK_WIDGET(ptr),GTK_STATE_INSENSITIVE,&uset_color);
                            }
                        }
                        break;
                }
                property_set=1;
            }
            break;
        case P_SELECTED_FG_COLOR:
            {
                int color=value->ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                GdkColor uset_color;
                uset_color.red=((unsigned short)red*0xFF);
                uset_color.green=((unsigned short)green*0xFF);
                uset_color.blue=((unsigned short)blue*0xFF);
                gtk_widget_modify_text(SAFE_WIDGET(item),GTK_STATE_SELECTED,&uset_color);
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        {
                            GtkWidget *ptr=gtk_bin_get_child(GTK_BIN(item->ptr));
                            if (ptr) {
                                gtk_widget_modify_fg(GTK_WIDGET(ptr),GTK_STATE_SELECTED,&uset_color);
                                gtk_widget_modify_text(GTK_WIDGET(ptr),GTK_STATE_SELECTED,&uset_color);
                            }
                        }
                        break;
                }
                property_set=1;
            }
            break;
        case P_DEFAULTCONTROL:
            {
                GTKControl *control=GetControlID(value->ToInt());
                switch (item->type) {
                    case CLASS_FORM:
                            property_set=1;
                            if (control) {
                                GTK_WIDGET_SET_FLAGS(SAFE_WIDGET(item), GTK_RECEIVES_DEFAULT);
                                GTK_WIDGET_SET_FLAGS(GTK_WIDGET(control->ptr), GTK_CAN_DEFAULT);
                                gtk_window_set_default(GTK_WINDOW(item->ptr), GTK_WIDGET(control->ptr));
                            }
                            break;
                }
            }
            break;
        case P_BORDERWIDTH:
            {
                switch (item->type) {
                    case CLASS_FORM:
                    case CLASS_NOTEBOOK:
                    case CLASS_VBOX:
                    case CLASS_HBOX:
                    case CLASS_VBUTTONBOX:
                    case CLASS_HBUTTONBOX:
                    case CLASS_ALIGNMENT:
                    case CLASS_BUTTON:
                    case CLASS_FRAME:
                    case CLASS_ASPECTFRAME:
                    case CLASS_SCROLLEDWINDOW:
                    case CLASS_VPANED:
                    case CLASS_HPANED:
                    case CLASS_TEXTVIEW:
                    case CLASS_STATUSBAR:
                            gtk_container_set_border_width(GTK_CONTAINER(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                }
            }
            break;
        case P_RELIEFSTYLE:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        gtk_button_set_relief(GTK_BUTTON(item->ptr), (GtkReliefStyle)value->ToInt());
                        property_set=1;
                        break;
                    /*case CLASS_TOOLBUTTON:
                        ((Gtk::ToolButton *)item->ptr)->set_relief_style((Gtk::ReliefStyle)value->ToInt());
                        break;*/
                }
            }
            break;
        case P_USESTOCK:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        gtk_button_set_use_stock(GTK_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                        AnsiString sid=GET_STOCK(value);
                        if (sid.Length())
                            gtk_tool_button_set_stock_id(GTK_TOOL_BUTTON(item->ptr), sid.c_str());
                        else {
                            gtk_tool_button_set_stock_id(GTK_TOOL_BUTTON(item->ptr), value->c_str());
                        }
                        property_set=1;
                        break;
                }
            }
            break;
        case P_IMAGEPOSITION:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        gtk_button_set_image_position(GTK_BUTTON(item->ptr), (GtkPositionType)value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_IMAGECOLUMN:
            {
                switch (item->type) {
                    case CLASS_ICONVIEW:
                        ((DeturnatedIconView *)item->ptr)->create_if_not_created();
                        gtk_icon_view_set_pixbuf_column(MY_ICON_VIEW(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_MARKUPCOLUMN:
            {
                switch (item->type) {
                    case CLASS_ICONVIEW:
                        ((DeturnatedIconView *)item->ptr)->create_if_not_created();
                        gtk_icon_view_set_markup_column(MY_ICON_VIEW(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        /*case P_TOOLTIPCOLUMN:
            {
                switch (item->type) {
                    case CLASS_ICONVIEW:
                        ((DeturnatedIconView *)item->ptr)->create_if_not_created();
                        ((Gtk::IconView *)item->ptr)->set_tooltip_column(value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;*/
        case P_ITEMWIDTH:
            {
                switch (item->type) {
                    case CLASS_ICONVIEW:
                        gtk_icon_view_set_item_width(MY_ICON_VIEW(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_LAYOUT:
            {
                switch (item->type) {
                    case CLASS_VBUTTONBOX:
                    case CLASS_HBUTTONBOX:
                        gtk_button_box_set_layout(GTK_BUTTON_BOX(item->ptr), (GtkButtonBoxStyle)value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_IMAGE:
            {
                property_set=1;
                GTKControl *item2=GetControlID(value->ToInt());
                if (!item2)
                    break;
                switch (item->type) {
                    case CLASS_BUTTON:
                        gtk_button_set_image(GTK_BUTTON(item->ptr), SAFE_WIDGET(item2));
                        break;
                    case CLASS_IMAGEMENUITEM:
                        gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item->ptr), SAFE_WIDGET(item2));
                        break;
                    case CLASS_IMAGE:
                        //((Gtk::Image*)item->ptr)->set(((Gtk::Image*)item2->ptr)->get_pixbuf());
                        {
                            GdkImage *img=0;
                            GdkBitmap *mask=0;
                            GdkPixbuf *pixbuf=0;
                            GtkImageType storage_type=gtk_image_get_storage_type(GTK_IMAGE(SAFE_WIDGET(item2)));
                            gtk_image_get_image(GTK_IMAGE(SAFE_WIDGET(item2)), &img, &mask);
                            if (img) {
                                gtk_image_set_from_image(GTK_IMAGE(item->ptr), img, mask);
                            } else {
                                if (storage_type==GTK_IMAGE_STOCK) {
                                    gchar *stock_id;
                                    GtkIconSize isize;
                                    gtk_image_get_stock(GTK_IMAGE(SAFE_WIDGET(item2)), &stock_id, &isize);
                                    gtk_image_set_from_stock (GTK_IMAGE(SAFE_WIDGET(item2)), stock_id, isize);
                                } else {
                                    if ((storage_type==GTK_IMAGE_PIXBUF) || (storage_type==GTK_IMAGE_EMPTY))
                                        pixbuf=gtk_image_get_pixbuf(GTK_IMAGE(SAFE_WIDGET(item2)));//((Gtk::Image*)item2->ptr)->get_pixbuf();
                                    if (pixbuf) {
                                        gtk_image_set_from_pixbuf(GTK_IMAGE(item->ptr), pixbuf);
                                    } else
                                        gtk_image_set_from_animation(GTK_IMAGE(item->ptr), gtk_image_get_animation(GTK_IMAGE(SAFE_WIDGET(item2))));
                                }
                            }
                        }
                        break;
                }
            }
            break;
        case P_VISIBLE:
            {
                property_set=1;
                switch (item->type) {
                    case CLASS_TEXTTAG:
                        g_object_set(G_OBJECT(item->ptr), "invisible-set", (gboolean)TRUE, NULL);
                        g_object_set(G_OBJECT(item->ptr), "invisible", (gboolean)!value->ToInt(), NULL);
                        break;
                    default:
                        if (value->ToInt())
                            gtk_widget_show(SAFE_WIDGET(item));
                        else {
                            gtk_widget_hide(SAFE_WIDGET(item));

                            if (item->ptr==mainform) {
                                run_app=-1;
                                update_status(false);
                            }
                        }
                        break;
                }
            }
            break;
        case P_SPACING:
            {
                switch (item->type) {
                    case CLASS_HBOX:
                    case CLASS_VBOX:
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                    case CLASS_STATUSBAR:
                        property_set=1;
                        gtk_box_set_spacing(GTK_BOX(item->ptr), value->ToInt());
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter *)item->ptr)->spacing=value->ToInt();
                        property_set=1;
                        break;
                    case CLASS_ICONVIEW:
                        gtk_icon_view_set_spacing(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_HOMOGENEOUS:
            {
                switch (item->type) {
                    case CLASS_HBOX:
                    case CLASS_VBOX:
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                    case CLASS_STATUSBAR:
                        gtk_box_set_homogeneous(GTK_BOX(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                        gtk_tool_item_set_homogeneous(GTK_TOOL_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TABLE:
                        gtk_table_set_homogeneous(GTK_TABLE(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_XPADDING:
            {
                int val=value->ToInt();
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        {
                            gint ipad_x;
                            gint ipad_y;
                            gtk_button_box_get_child_ipadding(GTK_BUTTON_BOX(item->ptr), &ipad_x, &ipad_y);
                            gtk_button_box_set_child_ipadding(GTK_BUTTON_BOX(item->ptr), val, ipad_y);
                        }
                        property_set=1;
                        break;
                    case CLASS_LABEL:
                    case CLASS_IMAGE:
                        {
                            gint ipad_x;
                            gint ipad_y;

                            gtk_misc_get_padding(GTK_MISC(item->type), &ipad_x, &ipad_y);
                            gtk_misc_set_padding(GTK_MISC(item->type), val, ipad_y);
                        }
                        property_set=1;
                        break;
                }
            }
            break;
        case P_YPADDING:
            {
                int val=value->ToInt();
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        {
                            gint ipad_x;
                            gint ipad_y;
                            gtk_button_box_get_child_ipadding(GTK_BUTTON_BOX(item->ptr), &ipad_x, &ipad_y);
                            gtk_button_box_set_child_ipadding(GTK_BUTTON_BOX(item->ptr), ipad_x, val);
                        }
                        property_set=1;
                        break;
                    case CLASS_LABEL:
                    case CLASS_IMAGE:
                        {
                            gint ipad_x;
                            gint ipad_y;

                            gtk_misc_get_padding(GTK_MISC(item->type), &ipad_x, &ipad_y);
                            gtk_misc_set_padding(GTK_MISC(item->type), ipad_x, val);
                        }
                        property_set=1;
                        break;
                }
            }
            break;
        case P_MINHEIGHT:
            {
                int val=value->ToInt();
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        {
                            property_set=1;
                            g_object_set(G_OBJECT(SAFE_WIDGET(item)), "child-min-height", val, NULL);
                        }
                        break;
                    default:
                        {
                            int x,y;
                            gtk_widget_get_size_request(SAFE_WIDGET(item),&x,&y);
                            gtk_widget_set_size_request(SAFE_WIDGET(item),x,value->ToInt());
                            property_set=1;
                        }
                }
            }
            break;
        case P_MINWIDTH:
            {
                int val=value->ToInt();
                property_set=1;
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "child-min-width", val, NULL);
                        break;
                    default:
                        {
                            int x,y;
                            gtk_widget_get_size_request(SAFE_WIDGET(item),&x,&y);
                            gtk_widget_set_size_request(SAFE_WIDGET(item),value->ToInt(),y);
                        }
                }
            }
            break;
        case P_MASKEDCHAR:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_invisible_char(GTK_ENTRY(item->ptr), *value[0]);
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_invisible_char(*value[0]);
                        gtk_entry_set_invisible_char(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), *value[0]);
                        property_set=1;
                        break;
                }
            }
            break;
		case P_CAPSWARNING:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                switch (item->type) {
                    case CLASS_EDIT:
                        g_object_set(G_OBJECT(item->ptr), "caps-lock-warning", (gboolean)value->ToInt(), NULL);
                        //((Gtk::Entry *)item->ptr)->property_caps_lock_warning()=(bool)value->ToInt();
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        g_object_set(G_OBJECT(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle)))), "caps-lock-warning", (gboolean)value->ToInt(), NULL);
                        property_set=1;
                        break;
				}
#endif
			}
			break;
        case P_MASKED:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_visibility(GTK_ENTRY(item->ptr), !value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_visibility(!value->ToInt());
                        gtk_entry_set_visibility(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), !value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
		case P_PRIMARYICONNAME:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                switch (item->type) {
                    case CLASS_EDIT:
                        //((Gtk::Entry *)item->ptr)->set_icon_from_icon_name(value->c_str(), Gtk::ENTRY_ICON_PRIMARY);
                        gtk_entry_set_icon_from_stock(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_PRIMARY, value->c_str());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_icon_from_stock(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_PRIMARY, value->c_str());
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_icon_from_icon_name(value->c_str(), Gtk::ENTRY_ICON_PRIMARY);
                        property_set=1;
                        break;
                }
#endif
            }
            break;
        case P_SECONDARYICONNAME:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                switch (item->type) {
                    case CLASS_EDIT:
                        /*gtk_entry_set_icon_from_icon_name*/
                        gtk_entry_set_icon_from_stock(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_SECONDARY, value->c_str());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        /*gtk_entry_set_icon_from_icon_name*/
                        gtk_entry_set_icon_from_stock(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_SECONDARY, value->c_str());
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_icon_from_icon_name(value->c_str(), Gtk::ENTRY_ICON_SECONDARY);
                        property_set=1;
                        break;
                }
#endif
            }
            break;
        case P_PRIMARYICON:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                GTKControl *item2=GetControlID(value->ToInt());

				if ((!item2) || (item2->type=CLASS_IMAGE))
                    break;

                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_icon_from_pixbuf(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_PRIMARY, ForcePixbuf(item2->ptr));
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_icon_from_pixbuf(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_PRIMARY, ForcePixbuf(item2->ptr));
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_icon_from_pixbuf(ForcePixbuf(item2->ptr), Gtk::ENTRY_ICON_PRIMARY);
                        property_set=1;
                        break;
                }
#endif
            }
            break;
        case P_SECONDARYICON:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                GTKControl *item2=GetControlID(value->ToInt());

				if ((!item2) || (item2->type=CLASS_IMAGE))
                    break;

                switch (item->type) {
                    case CLASS_EDIT:
                        //((Gtk::Entry *)item->ptr)->set_icon_from_pixbuf(ForcePixbuf(item2->ptr), Gtk::ENTRY_ICON_SECONDARY);
                        gtk_entry_set_icon_from_pixbuf(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_SECONDARY, ForcePixbuf(item2->ptr));
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_icon_from_pixbuf(ForcePixbuf(item2->ptr), Gtk::ENTRY_ICON_SECONDARY);
                        gtk_entry_set_icon_from_pixbuf(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_SECONDARY, ForcePixbuf(item2->ptr));
                        property_set=1;
                        break;
                }
#endif
            }
            break;
        case P_PRIMARYACTIVABLE:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_icon_activatable(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_PRIMARY, (bool)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_icon_activatable(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_PRIMARY, (bool)value->ToInt());
                        property_set=1;
                        break;
                }
#endif
            }
            break;
        case P_SECONDARYACTIVABLE:
            {
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_icon_activatable(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_SECONDARY, (bool)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_icon_activatable(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_SECONDARY, (bool)value->ToInt());
                        property_set=1;
                        break;
                }
#endif
            }
            break;
        case P_PRIMARYTOOLTIP:
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_icon_tooltip_markup(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_PRIMARY, value->c_str());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_icon_tooltip_markup(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_PRIMARY, value->c_str());
                        property_set=1;
                        break;
                }
            }
#endif
            break;
        case P_SECONDARYTOOLTIP:
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_icon_tooltip_markup(GTK_ENTRY(item->ptr), GTK_ENTRY_ICON_SECONDARY, value->c_str());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_icon_tooltip_markup(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), GTK_ENTRY_ICON_SECONDARY, value->c_str());
                        property_set=1;
                        break;
                }
            }
#endif
            break;
        case P_SUGESTION:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        SetSugestion(GTK_ENTRY(item->ptr),value);
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        SetSugestion(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))),value);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SUGESTIONMODEL:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                if (!item2)
                    break;

                GtkTreeModel *my_model;

                switch (item2->type) {
                    case CLASS_TREEVIEW:
                        my_model=gtk_tree_view_get_model(MY_TREE_VIEW(item2->ptr));
                        break;
                    case CLASS_COMBOBOX:
                    case CLASS_COMBOBOXTEXT:
                        my_model=gtk_combo_box_get_model(MY_COMBO_BOX(item2->ptr));
                        //my_model=((Gtk::ComboBox*)item2->ptr)->get_model();
                        break;
                }

                if (my_model) {
                    switch (item->type) {
                        case CLASS_EDIT:
                            SetSugestion(GTK_ENTRY(item->ptr), my_model, POST_STRING.ToInt());
                            property_set=1;
                            break;
                        case CLASS_COMBOBOXTEXT:
                            SetSugestion(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))),my_model, POST_STRING.ToInt());
                            property_set=1;
                            break;
                    }
                }
            }
            break;
        case P_READONLY:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_editable(GTK_ENTRY(item->ptr), !value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_editable(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), !value->ToInt());
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_editable(!value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_editable(GTK_TEXT_VIEW(item->ptr), !value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr, "editable-set", gboolean, TRUE);
                        SET_GPROP(item->ptr, "editable", gboolean, TRUE);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_MAXLEN:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_max_length(GTK_ENTRY(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_max_length(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), value->ToInt());
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_max_length(value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_ACTIVATEDEFAULT:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_activates_default(GTK_ENTRY(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_activates_default(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), value->ToInt());
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_activates_default(value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_BORDER:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        gtk_entry_set_has_frame(GTK_ENTRY(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        //((Gtk::ComboBoxEntry *)item->ptr)->get_entry()->set_has_frame(value->ToInt());
                        gtk_entry_set_has_frame(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), (bool)value->ToInt());
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "has-frame", (bool)value->ToInt(), NULL);
                        //gtk_combo_box_set_has_frame(GTK_COMBO_BOX(item->ptr), (bool)value->ToInt());
                        //((Gtk::ComboBox *)item->ptr)->property_has_frame()=(bool)value->ToInt();
                        property_set=1;
                        break;
                    case CLASS_COMBOBOX:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "has-frame", (bool)value->ToInt(), NULL);
                        //((Gtk::ComboBox *)item->ptr)->property_has_frame()=(bool)value->ToInt();
                        property_set=1;
                        break;
                    case CLASS_ICONVIEW:
                        gtk_icon_view_set_margin(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_CHECKED:
            {
                switch (item->type) {
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                        gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                        gtk_toggle_tool_button_set_active(GTK_TOGGLE_TOOL_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_INCONSISTENT:
            {
                switch (item->type) {
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                        gtk_check_menu_item_set_inconsistent(GTK_CHECK_MENU_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_GROUP:
            {
                switch (item->type) {
                    case CLASS_RADIOBUTTON:
                        {
                            GTKControl *item2=GetControlID(value->ToInt());
                            if ((item2) && (item2->type==CLASS_RADIOBUTTON) && (item!=item2)) {
                                GSList *grup=gtk_radio_button_get_group(GTK_RADIO_BUTTON(item2->ptr));
                                gtk_radio_button_set_group(GTK_RADIO_BUTTON(item->ptr), grup);
                            } else
                                gtk_radio_button_set_group(GTK_RADIO_BUTTON(item->ptr),0);
                            property_set=1;
                        }
                        break;
                    case CLASS_RADIOMENUITEM:
                        {
                            GTKControl *item2=GetControlID(value->ToInt());
                            if ((item2) && (item2->type==CLASS_RADIOMENUITEM) && (item!=item2)) {
                                gtk_radio_menu_item_set_group(GTK_RADIO_MENU_ITEM(item->ptr),0);
                                GSList *grup=gtk_radio_menu_item_get_group(GTK_RADIO_MENU_ITEM(item2->ptr));
                                gtk_radio_menu_item_set_group(GTK_RADIO_MENU_ITEM(item->ptr), grup);
                            } else
                                gtk_radio_menu_item_set_group(GTK_RADIO_MENU_ITEM(item->ptr),0);
                            property_set=1;
                        }
                        break;
                    case CLASS_RADIOTOOLBUTTON:
                        {
                            GTKControl *item2=GetControlID(value->ToInt());
                            if ((item2) && (item2->type==CLASS_RADIOTOOLBUTTON) && (item!=item2)) {
                                GSList *grup=gtk_radio_tool_button_get_group(GTK_RADIO_TOOL_BUTTON(item2->ptr));
                                gtk_radio_tool_button_set_group(GTK_RADIO_TOOL_BUTTON(item->ptr), grup);
                            }
                            property_set=1;
                        }
                        break;
                }
            }
            break;
        case P_SELECTABLE:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_selectable(GTK_LABEL(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_USEUNDERLINE:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_use_underline(GTK_LABEL(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_WRAP:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_line_wrap(GTK_LABEL(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_SPINBUTTON:
                        gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(item->ptr), (GtkWrapMode)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"wrap-mode-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"wrap-mode",GtkWrapMode,value->ToInt())
                        property_set=1;
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter *)item->ptr)->wrapmode=value->ToInt();
                        property_set=1;
                        break;
                }
            }
            break;
        case P_ANGLE:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_angle(GTK_LABEL(item->ptr), value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_JUSTIFY:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_justify(GTK_LABEL(item->ptr), (GtkJustification)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_justification(GTK_TEXT_VIEW(item->ptr), (GtkJustification)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"justification",GtkJustification,value->ToInt())
                        SET_GPROP(item->ptr,"justification-set",gboolean,TRUE)
                        property_set=1;
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter *)item->ptr)->justify=value->ToInt();
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PATTERN:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_pattern(GTK_LABEL(item->ptr), value->c_str());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_MARKUP:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        gtk_label_set_use_markup(GTK_LABEL(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_FRAME:
                        gtk_label_set_use_markup(GTK_LABEL(gtk_frame_get_label_widget(GTK_FRAME(item->ptr))), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_EXPANDER:
                        gtk_expander_set_use_markup(GTK_EXPANDER(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SHADOWTYPE:
            {
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        property_set=1;
                        gtk_frame_set_shadow_type(GTK_FRAME(item->ptr), (GtkShadowType)value->ToInt());
                        break;
                    case CLASS_SCROLLEDWINDOW:
                        gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(item->ptr), (GtkShadowType)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_VIEWPORT:
                        gtk_viewport_set_shadow_type(GTK_VIEWPORT(item->ptr), (GtkShadowType)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_HANDLEBOX:
                        gtk_handle_box_set_shadow_type(GTK_HANDLE_BOX(item->ptr), (GtkShadowType)value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_HTEXTALIGN:
            {
                float x;
                float y;
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        gtk_frame_get_label_align(GTK_FRAME(item->ptr),&x,&y);
                        gtk_frame_set_label_align(GTK_FRAME(item->ptr),x,(float)value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_VTEXTALIGN:
            {
                float x;
                float y;
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        gtk_frame_get_label_align(GTK_FRAME(item->ptr),&x,&y);
                        gtk_frame_set_label_align(GTK_FRAME(item->ptr),(float)value->ToFloat(),y);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_FRACTION:
            {
                switch (item->type) {
                    case CLASS_PROGRESSBAR:
                        gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(item->ptr), value->ToFloat());
                        property_set=1;
                        break;
					case CLASS_EDIT:
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                        gtk_entry_set_progress_fraction(GTK_ENTRY(item->ptr), value->ToFloat());
                        property_set=1;
#endif
                        break;
                    case CLASS_COMBOBOXTEXT:
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                        gtk_entry_set_progress_fraction(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), value->ToFloat());
#endif
                        property_set=1;
                        break;
                }
            }
            break;
        case P_ORIENTATION:
            {
                switch (item->type) {
                    case CLASS_PROGRESSBAR:
                        gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(item->ptr), (GtkProgressBarOrientation)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TOOLBAR:
                        gtk_toolbar_set_orientation(GTK_TOOLBAR(item->ptr), (GtkOrientation)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_PRINTER:
                        if (((ClientPrinter *)item->ptr)->initialized)
                            gtk_page_setup_set_orientation(((ClientPrinter *)item->ptr)->PageSetup, (GtkPageOrientation)value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_ICONVIEW:
                        gtk_icon_view_set_orientation(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), (GtkOrientation)value->ToInt()); 
                        //((DeturnatedIconView *)item->ptr)->set_orientation((Gtk::Orientation)value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_STEP:
            {
                switch (item->type) {
                    case CLASS_PROGRESSBAR:
                        gtk_progress_bar_set_pulse_step(GTK_PROGRESS_BAR(item->ptr), value->ToFloat());
                        property_set=1;
                        break;
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
					case CLASS_EDIT:
                        gtk_entry_set_progress_pulse_step(GTK_ENTRY(item->ptr), value->ToFloat());
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        gtk_entry_set_progress_pulse_step(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), value->ToFloat());
                        property_set=1;
                        break;
#endif
                }
            }
            break;
        case P_POSITION:
            {
                switch (item->type) {
                    case CLASS_VPANED:
                    case CLASS_HPANED:
                        property_set=1;
                        gtk_paned_set_position(GTK_PANED(item->ptr), value->ToInt());
                        break;
                    case CLASS_FORM:
                        property_set=1;
                        gtk_window_set_position(GTK_WINDOW(item->ptr), (GtkWindowPosition)value->ToInt());
                        break;
                }
            }
            break;
        case P_TYPE:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        property_set=1;
                        gtk_window_set_type_hint(GTK_WINDOW(item->ptr), (GdkWindowTypeHint)value->ToInt());
                        break;
                }
            }
            break;
        case P_OPACITY:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        property_set=1;
#ifdef LATEST_GTK
                        gtk_window_set_opacity(GTK_WINDOW(item->ptr), value->ToFloat());
#else
	#ifdef _WIN32
                        unsigned char factor=(char)(value->ToFloat()*0xFF);
                        HWND wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(item->ptr)->window);
                        MakeWindowTransparent(wnd, factor);
	#else
                        //((Gtk::Window *)item->ptr)->set_opacity(value->ToFloat());
	#endif
#endif
                        break;
                }
            }
            break;
        case P_CLOSEABLE:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        property_set=1;
                        gtk_window_set_deletable(GTK_WINDOW(item->ptr), (bool)value->ToInt());
                        break;
                }
            }
            break;
        case P_URGENT:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        property_set=1;
                        gtk_window_set_urgency_hint(GTK_WINDOW(item->ptr), (bool)value->ToInt());
                        break;
                }
            }
            break;
        case P_LOWER:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        gtk_adjustment_set_lower(GTK_ADJUSTMENT(item->ptr), value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_UPPER:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        gtk_adjustment_set_upper(GTK_ADJUSTMENT(item->ptr),value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_VALUE:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        gtk_adjustment_set_value(GTK_ADJUSTMENT(item->ptr),value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_INCREMENT:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        gtk_adjustment_set_step_increment(GTK_ADJUSTMENT(item->ptr),value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PAGEINCREMENT:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        gtk_adjustment_set_page_increment(GTK_ADJUSTMENT(item->ptr),value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PAGESIZE:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        gtk_adjustment_set_page_size(GTK_ADJUSTMENT(item->ptr),value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_DIGITS:
            {
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                        gtk_scale_set_digits(GTK_SCALE(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_SPINBUTTON:
                        gtk_spin_button_set_digits(GTK_SPIN_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_DRAWVALUE:
            {
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                        gtk_scale_set_draw_value(GTK_SCALE(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_VALUEPOS:
            {
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                        gtk_scale_set_value_pos(GTK_SCALE(item->ptr),(GtkPositionType)value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_INVERTED:
            {
                switch (item->type) {
                    case CLASS_VSCROLLBAR:
                    case CLASS_HSCROLLBAR:
                        gtk_range_set_inverted(GTK_RANGE(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SNAPTOTICKS:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        gtk_spin_button_set_snap_to_ticks(GTK_SPIN_BUTTON(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_NUMERIC:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        property_set=1;
                        gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(item->ptr),value->ToInt());
                        break;
                }
            }
            break;
        case P_ACCEPTTAB:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        property_set=1;
                        gtk_text_view_set_accepts_tab(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        break;
                }
            }
            break;
        case P_PRINT:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        if (client_print)
                            client_print(GTK_TEXT_VIEW(item->ptr));
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SELECTIONSTART:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                        int pos=value->ToInt();
                        GtkTextIter iter;
                        gtk_text_buffer_get_iter_at_offset(refTextBuffer, &iter, pos);
                        gtk_text_buffer_select_range(refTextBuffer, &iter, &iter);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SELECTIONLENGTH:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                        GtkTextMark *marker=gtk_text_buffer_get_insert(refTextBuffer);
                        GtkTextIter iter;
                        GtkTextIter iter2;
                        gtk_text_buffer_get_iter_at_mark(refTextBuffer, &iter, marker);
                        int offset=gtk_text_iter_get_offset(&iter);
                        gtk_text_buffer_get_iter_at_offset(refTextBuffer, &iter2, offset+value->ToInt());
                        gtk_text_buffer_select_range(refTextBuffer,&iter,&iter2);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_CURSORVISIBLE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_INDENT:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_indent(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"indent-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"indent",gint,value->ToInt())
                        property_set=1;
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter *)item->ptr)->indent=value->ToInt();
                        property_set=1;
                        break;
                }
            }
            break;
        case P_LEFTMARGIN:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_left_margin(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"left-margin-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"left-margin",gint,value->ToInt())
                        property_set=1;
                        break;
                    case CLASS_PRINTER:
                        if (((ClientPrinter *)item->ptr)->initialized)
                            gtk_page_setup_set_left_margin(((ClientPrinter *)item->ptr)->PageSetup, value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_RIGHTMARGIN:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_right_margin(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"right-margin-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"right-margin",gint,value->ToInt())
                        property_set=1;
                        break;
                    case CLASS_PRINTER:
                        if (((ClientPrinter *)item->ptr)->initialized)
                            gtk_page_setup_set_right_margin(((ClientPrinter *)item->ptr)->PageSetup, value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_OVERWRITE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_overwrite(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PIXELSABOVE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_pixels_above_lines(GTK_TEXT_VIEW(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"pixels-above-lines-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"pixels-above-lines",gint,value->ToInt())
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PIXELSBELOW:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_pixels_below_lines(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"pixels-below-lines-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"pixels-below-lines",gint,value->ToInt())
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PIXELSINSIDE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        gtk_text_view_set_pixels_inside_wrap(GTK_TEXT_VIEW(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                    case CLASS_TEXTTAG:
                        SET_GPROP(item->ptr,"pixels-inside-wrap-set",gboolean,TRUE)
                        SET_GPROP(item->ptr,"pixels-inside-wrap",gint,value->ToInt())
                        property_set=1;
                        break;
                }
            }
            break;
        case P_XSCALE:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        property_set=1;
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "xscale", (float)value->ToFloat(), NULL);
                        break;
                }
            }
            break;
        case P_YSCALE:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        property_set=1;
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "yscale", (float)value->ToFloat(), NULL);
                        break;
                }
            }
            break;
        case P_XALIGN:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "xalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                    case CLASS_ASPECTFRAME:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "xalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                    case CLASS_LABEL:
                    case CLASS_IMAGE:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "xalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                    case CLASS_EDIT:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "xalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        //g_object_set(G_OBJECT(gtk_bin_get_child(GTK_BIN(SAFE_WIDGET(item)))), "xalign", (float)value->ToFloat(), NULL);
                        gtk_entry_set_alignment(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))), (float)value->ToFloat());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_YALIGN:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "yalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                    case CLASS_ASPECTFRAME:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "yalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                    case CLASS_LABEL:
                    case CLASS_IMAGE:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "yalign", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_TOPPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "top-padding", value->ToInt(), NULL);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_LEFTPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "left-padding", value->ToInt(), NULL);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_RIGHTPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        property_set=1;
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "right-padding", value->ToInt(), NULL);
                        break;
                }
            }
            break;
        case P_BOTTOMPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "bottom-padding", value->ToInt(), NULL);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PAGE:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        gtk_notebook_set_page(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SCROLLABLE:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        gtk_notebook_set_scrollable(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SHOWBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        gtk_notebook_set_show_border(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_SHOWTABS:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        property_set=1;
                        gtk_notebook_set_show_tabs(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        break;
                }
            }
            break;
        case P_TABBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        property_set=1;
                        gtk_notebook_set_tab_border(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        break;
                }
            }
            break;
        case P_TABPOS:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        gtk_notebook_set_tab_pos(GTK_NOTEBOOK(item->ptr),(GtkPositionType)value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_VERTICALBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        gtk_notebook_set_tab_vborder(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_HORIZONTALBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        gtk_notebook_set_tab_hborder(GTK_NOTEBOOK(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
#ifdef LATEST_GTK
        case P_ACTIONWIDGETEND:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        if (item2)
                            gtk_notebook_set_action_widget(GTK_NOTEBOOK(item->ptr),SAFE_WIDGET(item2),GTK_PACK_END);
                        else
                            gtk_notebook_set_action_widget(GTK_NOTEBOOK(item->ptr),0,GTK_PACK_START);
                        property_set=1;
                        break;
                }
            }
            break;
        case P_ACTIONWIDGETSTART:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        if (item2)
                            gtk_notebook_set_action_widget(GTK_NOTEBOOK(item->ptr),SAFE_WIDGET(item2),GTK_PACK_START);
                        else
                            gtk_notebook_set_action_widget(GTK_NOTEBOOK(item->ptr),0,GTK_PACK_START);
                        property_set=1;
                        break;
                }
            }
            break;
#endif
        case P_HADJUSTMENT:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                if ((!item2) || (item2->type!=CLASS_ADJUSTMENT))
                    break;
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        gtk_scrolled_window_set_hadjustment(GTK_SCROLLED_WINDOW(item->ptr), GTK_ADJUSTMENT(item2->ptr));
                        property_set=1;
                        break;
                    case CLASS_VIEWPORT:
                        gtk_viewport_set_hadjustment(GTK_VIEWPORT(item->ptr), GTK_ADJUSTMENT(item2->ptr));
                        property_set=1;
                        break;
                    case CLASS_TREEVIEW:
                        property_set=1;
                        gtk_tree_view_set_hadjustment(MY_TREE_VIEW(item->ptr), GTK_ADJUSTMENT(item2->ptr));
                        break;
                }
            }
            break;
        case P_VADJUSTMENT:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                if ((!item2) || (item2->type!=CLASS_ADJUSTMENT))
                    break;
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        gtk_scrolled_window_set_vadjustment(GTK_SCROLLED_WINDOW(item->ptr), GTK_ADJUSTMENT(item2->ptr));
                        property_set=1;
                        break;
                    case CLASS_VIEWPORT:
                        gtk_viewport_set_hadjustment(GTK_VIEWPORT(item->ptr), GTK_ADJUSTMENT(item2->ptr));
                        property_set=1;
                        break;
                    case CLASS_TREEVIEW:
                        gtk_tree_view_set_vadjustment(MY_TREE_VIEW(item->ptr), GTK_ADJUSTMENT(item2->ptr));
                        property_set=1;
                        break;
                }
            }
            break;
        case P_PLACEMENT:
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(item->ptr), (GtkCornerType)value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_HSCROLLBARPOLICY:
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "hscrollbar-policy", (GtkPolicyType)value->ToInt(), NULL);
                        property_set=1;
                        break;
                }
                break;
        case P_VSCROLLBARPOLICY:
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "vscrollbar-policy", (GtkPolicyType)value->ToInt(), NULL);
                        property_set=1;
                        break;
                }
                break;
        case P_OBEYCHILD:
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                        //gtk_aspect_frame_set_obey_child(GTK_ASPECT_FRAME(item->ptr), value->ToInt());
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "obey-child", (gboolean)value->ToInt(), NULL);
                        property_set=1;
                        break;
                }
                break;
        case P_RATIO:
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                        g_object_set(G_OBJECT(SAFE_WIDGET(item)), "ratio", (float)value->ToFloat(), NULL);
                        property_set=1;
                        break;
                }
                break;
        case P_SUBMENU:
            {
                GTKControl *item2=GetControlID(value->ToInt());
                switch (item->type) {
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_SEPARATORMENUITEM:
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_TEAROFFMENUITEM:
                    case CLASS_MENUITEM:
                        if ((!item2) || (item2->type!=CLASS_MENU))
                            gtk_menu_item_set_submenu(GTK_MENU_ITEM(item->ptr), SAFE_WIDGET(item2));
                        else
                            gtk_menu_item_remove_submenu(GTK_MENU_ITEM(item->ptr));
                        property_set=1;
                        break;
                }
            }
            break;
        case P_ACCELKEY:
            {
                switch (item->type) {
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_SEPARATORMENUITEM:
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_TEAROFFMENUITEM:
                    case CLASS_MENUITEM:
                        GtkAccelKey key;
                        GdkModifierType mods;
                        gtk_accelerator_parse(value->c_str(), &key.accel_key, &key.accel_mods);
                            //(value->c_str());
                        AnsiString cap="<app";
                        cap+=">/";
                        cap+=AnsiString((long)item->ptr);

                        if (gtk_accel_map_lookup_entry(cap.c_str(),&key))
		                        gtk_accel_map_change_entry(cap.c_str(), key.accel_key, key.accel_mods,true);
	                    else
                                gtk_accel_map_add_entry(cap.c_str(), key.accel_key, key.accel_mods);

                        gtk_menu_item_set_accel_path(GTK_MENU_ITEM(item->ptr), cap.c_str());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_RIGHTJUSTIFIED:
            {
                switch (item->type) {
                    case CLASS_IMAGEMENUITEM:
                    case CLASS_SEPARATORMENUITEM:
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                    case CLASS_TEAROFFMENUITEM:
                    case CLASS_MENUITEM:
                        gtk_menu_item_set_right_justified(GTK_MENU_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_DRAWASRADIO:
            {
                switch (item->type) {
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                        gtk_check_menu_item_set_draw_as_radio(GTK_CHECK_MENU_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
            }
            break;
        case P_EXPANDED:
                switch (item->type) {
                    case CLASS_EXPANDER:
                        gtk_expander_set_expanded(GTK_EXPANDER(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_HANDLEPOSITION:
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        gtk_handle_box_set_handle_position(GTK_HANDLE_BOX(item->ptr), (GtkPositionType)value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_SNAPEDGE:
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        gtk_handle_box_set_snap_edge(GTK_HANDLE_BOX(item->ptr), (GtkPositionType)value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_SHOWARROW:
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        gtk_toolbar_set_show_arrow(GTK_TOOLBAR(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_TOOLBARSTYLE:
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        gtk_toolbar_set_style(GTK_TOOLBAR(item->ptr), (GtkToolbarStyle)value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_TOOLTIPS:
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        gtk_toolbar_set_tooltips(GTK_TOOLBAR(item->ptr),value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_ISIMPORTANT:
                switch (item->type) {
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                    case CLASS_MENUTOOLBUTTON:
                        gtk_tool_item_set_is_important(GTK_TOOL_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_VISIBLEVERTICAL:
                switch (item->type) {
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_MENUTOOLBUTTON:
                        gtk_tool_item_set_visible_vertical(GTK_TOOL_ITEM(item->ptr), value->ToInt());
                        property_set=1;
                        break;
                }
                break;
        case P_VISIBLEHORIZONTAL:
                switch (item->type) {
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                    case CLASS_MENUTOOLBUTTON:
                        property_set=1;
                        gtk_tool_item_set_visible_horizontal(GTK_TOOL_ITEM(item->ptr), value->ToInt());
                        break;
                }
                break;
        case P_ICON:
                {
                    GTKControl *item2=GetControlID(value->ToInt());
                    if (!item2)
                        break;
                    switch (item->type) {
                        case CLASS_RADIOTOOLBUTTON:
                        case CLASS_TOGGLETOOLBUTTON:
                        case CLASS_TOOLBUTTON:
                        case CLASS_MENUTOOLBUTTON:
                            gtk_tool_button_set_icon_widget(GTK_TOOL_BUTTON(item->ptr), SAFE_WIDGET(item2));
                            property_set=1;
                            break;
                        case CLASS_FORM:
                            gtk_window_set_icon(GTK_WINDOW(item->ptr), ForcePixbuf(item2->ptr)/*((Gtk::Image *)item2->ptr)->property_pixbuf()*/);
                            property_set=1;
                            break;
                    }
                    break;
                }
        case P_EXPAND:
                switch (item->type) {
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                    case CLASS_MENUTOOLBUTTON:
                        property_set=1;
                        gtk_tool_item_set_expand(GTK_TOOL_ITEM(item->ptr), value->ToInt());
                        break;
                }
                break;
        case P_MENU:
                {
                    GTKControl *item2=GetControlID(value->ToInt());
                    if ((!item2) || (item2->type!=CLASS_MENU))
                        break;
                    switch (item->type) {
                        case CLASS_MENUTOOLBUTTON:
                            gtk_menu_tool_button_set_menu(GTK_MENU_TOOL_BUTTON(item->ptr), SAFE_WIDGET(item2));
                            property_set=1;
                            break;
                    }
                    break;
                }
        case P_ENABLESEARCH:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            //((Gtk::TreeView *)item->ptr)->set_enable_search(value->ToInt());
                            gtk_tree_view_set_enable_search(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        /*case P_EXPANDERCOLUMN:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            ((Gtk::TreeView *)item->ptr)->set_expander_column(value->ToInt());
                            break;
                    }
                }
                break;*/
        case P_FIXEDHEIGHTMODE:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            //((Gtk::TreeView *)item->ptr)->set_fixed_height_mode(value->ToInt());
                            gtk_tree_view_set_fixed_height_mode(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_HEADERSCLICKABLE:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            //((Gtk::TreeView *)item->ptr)->set_headers_clickable(value->ToInt());
                            gtk_tree_view_set_headers_clickable(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_HEADERSVISIBLE:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_headers_visible(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_HOVEREXPAND:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_hover_expand(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_HOVERSELECTION:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_hover_selection(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_MODEL:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            ((DeturnatedTreeView *)item->ptr)->deturnated_set_model((char)value->ToInt());
                            property_set=1;
                            break;
                        case CLASS_COMBOBOX:
                        case CLASS_COMBOBOXTEXT:
                            {
                                GTKControl *item2=GetControlID(value->ToInt());
                                if (!item2)
                                    break;

                                GtkTreeModel *my_model;

                                switch (item2->type) {
                                    case CLASS_TREEVIEW:
                                        my_model=gtk_tree_view_get_model(MY_TREE_VIEW(item2->ptr));
                                        break;
                                    case CLASS_COMBOBOX:
                                    case CLASS_COMBOBOXTEXT:
                                        my_model=gtk_combo_box_get_model(MY_COMBO_BOX(item2->ptr));
                                        break;
                                }

                                if (my_model) {
                                    //((Gtk::ComboBox *)item->ptr)->set_model(my_model);
                                    gtk_combo_box_set_model(MY_COMBO_BOX(item->ptr), my_model);
                                }
                            }
                            break;
                    }
                }
                break;
        case P_REORDABLE:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_reorderable(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
                            //((DeturnatedIconView *)item->ptr)->set_reorderable(value->ToInt());
                            gtk_icon_view_set_reorderable(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), value->ToInt()); 
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_RULESHINT:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_rules_hint(MY_TREE_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_SEARCHCOLUMN:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_search_column(MY_TREE_VIEW(item->ptr), value->ToInt());
                            GtkEntry *ent=gtk_tree_view_get_search_entry(MY_TREE_VIEW(item->ptr));
                            if (ent)
                                gtk_entry_set_max_length(GTK_ENTRY(ent),0);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_GRIDLINES:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_grid_lines(MY_TREE_VIEW(item->ptr),(GtkTreeViewGridLines)value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_TREELINES:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_enable_tree_lines(MY_TREE_VIEW(item->ptr),(bool)value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_LEVELIDENTATION:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_level_indentation(MY_TREE_VIEW(item->ptr),(bool)value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_SHOWEXPANDERS:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_show_expanders(MY_TREE_VIEW(item->ptr),(bool)value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_MULTIPLESELECTION:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_rubber_banding(MY_TREE_VIEW(item->ptr),(bool)value->ToInt());
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
                            //((DeturnatedIconView *)item->ptr)->set_selection_mode((Gtk::SelectionMode)value->ToInt());
                            gtk_icon_view_set_selection_mode(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), (GtkSelectionMode)value->ToInt()); 
                            property_set=1;
                            break;

                    }
                }
                break;
        case P_SEARCHENTRY:
                {
                    GTKControl *item2=GetControlID(value->ToInt());
                    if ((!item2) || (item2->type!=CLASS_EDIT))
                        break;
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_set_search_entry(MY_TREE_VIEW(item->ptr),GTK_ENTRY(item2->ptr));
                            break;
                    }
                }
                break;
        case P_SCROLLTOROW:
                {
                    GtkTreePath *path=gtk_tree_path_new_from_string(value->c_str());
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(((DeturnatedIconView *)item->ptr)->handle), path, 0, FALSE, 0, 0);
                            //((Gtk::TreeView *)item->ptr)->scroll_to_row(path);
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
                            //((DeturnatedIconView *)item->ptr)->scroll_to_path(path, false, 0, 0);
                            gtk_icon_view_scroll_to_path(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), path, FALSE, 0, 0);
                            property_set=1;
                            break;
                    }
                    gtk_tree_path_free(path);
                }
                break;
        case P_SCROLLTOCOLUMN:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            GtkTreeViewColumn *column=((DeturnatedTreeView *)item->ptr)->GetColumn(value->ToInt());
                            if (column) {
                                //((Gtk::TreeView *)item->ptr)->scroll_to_column(*column);
                                gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(((DeturnatedIconView *)item->ptr)->handle), 0, column, FALSE, 0, 0);
                            }
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_SELECTEDCOLUMN:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            {
                                GtkTreePath *path=0;
                                GtkTreeViewColumn *focus_column=0;

                                gtk_tree_view_get_cursor(MY_TREE_VIEW(item->ptr), &path, &focus_column);
                                focus_column=gtk_tree_view_get_column(MY_TREE_VIEW(item->ptr), value->ToInt());
                                if (focus_column) {
                                    gchar *pstr=gtk_tree_path_to_string(path);
                                    if ((path) && (pstr) && (pstr[0])) {
                                        gtk_tree_view_set_cursor(MY_TREE_VIEW(item->ptr), path, focus_column, FALSE);
                                        g_free(pstr);
                                    } else
                                        g_signal_emit_by_name(G_OBJECT(focus_column), "clicked");
                                }
                                property_set=1;

                            }
                            break;
                    }
                }
                break;
        case P_CURSOR:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            {
                                GtkTreePath *path=gtk_tree_path_new_from_string(value->c_str());
                                gtk_tree_view_set_cursor(MY_TREE_VIEW(item->ptr),path,NULL,FALSE);
                                gtk_tree_path_free(path);
                                property_set=1;
                            }
                            break;
                        case CLASS_COMBOBOXTEXT:
                        case CLASS_COMBOBOX:
                            gtk_combo_box_set_active(MY_COMBO_BOX(item->ptr), (int)value->ToInt());
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
							{
                                GtkTreePath *path=gtk_tree_path_new_from_string(value->c_str());
								gtk_icon_view_item_activated(MY_ICON_VIEW(item->ptr), path);
                                gtk_tree_path_free(path);
							}
							property_set=1;
                            break;
						case CLASS_SCROLLEDWINDOW:
							{
		                        while (gtk_events_pending())
			                        gtk_main_iteration();

								GtkAdjustment* swha=gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(item->ptr));//((Gtk::ScrolledWindow *)item->ptr)->get_vadjustment();
								if (swha)
                                    gtk_adjustment_set_value(swha, gtk_adjustment_get_upper(swha) - gtk_adjustment_get_page_size(swha));
							}
							property_set=1;
							break;
                    }
                }
                break;
        case P_ADDTEAROFFS:
                {
                    switch (item->type) {
                        case CLASS_COMBOBOXTEXT:
                        case CLASS_COMBOBOX:
                            gtk_combo_box_set_add_tearoffs(MY_COMBO_BOX(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_FOCUSONCLICK:
                {
                    switch (item->type) {
                        case CLASS_COMBOBOXTEXT:
                        case CLASS_COMBOBOX:
                            gtk_combo_box_set_focus_on_click(MY_COMBO_BOX(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_WRAPWIDTH:
                {
                    switch (item->type) {
                        case CLASS_COMBOBOXTEXT:
                        case CLASS_COMBOBOX:
                            gtk_combo_box_set_wrap_width(MY_COMBO_BOX(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ROWSPANCOLUMN:
                {
                    switch (item->type) {
                        case CLASS_COMBOBOXTEXT:
                        case CLASS_COMBOBOX:
                            gtk_combo_box_set_row_span_column(MY_COMBO_BOX(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_TEXTCOLUMN:
                {
                    switch (item->type) {
                        case CLASS_COMBOBOXTEXT:
                            ((DeturnatedComboBox *)item->ptr)->create_if_not_created();
                            //((DeturnatedComboBoxEntry *)item->ptr)->set_text_col(value->ToInt());
                            ((DeturnatedComboBox *)item->ptr)->set_text_col(value->ToInt());
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
                            ((DeturnatedIconView *)item->ptr)->create_if_not_created();
                            gtk_icon_view_set_text_column(MY_ICON_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_DAY:
                {
                    switch (item->type) {
                        case CLASS_CALENDAR:
                            gtk_calendar_select_day(GTK_CALENDAR(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_MONTH:
                {
                    switch (item->type) {
                        case CLASS_CALENDAR:
                            {
                                guint year, month, day;
                                gtk_calendar_get_date(GTK_CALENDAR(item->ptr),&year,&month,&day);
                                gtk_calendar_select_month(GTK_CALENDAR(item->ptr),value->ToInt()-1,year);
                                property_set=1;
                                break;
                            }
                    }
                }
                break;
        case P_YEAR:
                {
                    switch (item->type) {
                        case CLASS_CALENDAR:
                            {
                                guint year, month, day;
                                gtk_calendar_get_date(GTK_CALENDAR(item->ptr),&year,&month,&day);
                                gtk_calendar_select_month(GTK_CALENDAR(item->ptr),month, value->ToInt());
                                //((Gtk::Calendar *)item->ptr)->select_month(month,value->ToInt());
                                property_set=1;
                                break;
                            }
                    }
                }
                break;
        case P_FONTNAME:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"font",gchar *,value->c_str())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_from_string(value->c_str());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_FONTFAMILY:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"family-set",gboolean,TRUE)
                            SET_GPROP(item->ptr,"family",gchar *,value->c_str())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_new();
                            pango_font_description_set_family(font, value->c_str());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_FONTSTYLE:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"style-set",gboolean,TRUE)
                            SET_GPROP(item->ptr,"style",PangoStyle,value->ToInt())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_new();
                            pango_font_description_set_style(font, (PangoStyle)value->ToInt());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_FONTVARIANT:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"variant-set",gboolean,TRUE)
                            SET_GPROP(item->ptr,"variant",PangoVariant,value->ToInt())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_new();
                            pango_font_description_set_variant(font, (PangoVariant)value->ToInt());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_FONTWEIGHT:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"weight-set",gboolean,TRUE)
                            SET_GPROP(item->ptr,"weight",gint,value->ToInt())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_new();
                            pango_font_description_set_weight(font, (PangoWeight)value->ToInt());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_FONTSTRETCH:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"stretch-set",gboolean,TRUE)
                            SET_GPROP(item->ptr,"stretch",PangoStretch,value->ToInt())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_new();
                            pango_font_description_set_stretch(font, (PangoStretch)value->ToInt());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_FONTSIZE:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"size-set",gboolean,TRUE)
                            SET_GPROP(item->ptr,"size",gint,value->ToInt())
                            property_set=1;
                            break;
                        default:
                            PangoFontDescription *font;
                            font=pango_font_description_new();
                            pango_font_description_set_size(font, value->ToInt());
                            gtk_widget_modify_font(SAFE_WIDGET(item), font);
                            //g_object_unref(font);
                            property_set=1;
                    }
                }
                break;
        case P_PRIORITY:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            gtk_text_tag_set_priority(GTK_TEXT_TAG(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_UNDERLINE:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"underline-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"underline",PangoUnderline,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_STRIKEOUT:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"strikethrough-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"strikethrough",gboolean,TRUE);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_STRETCH:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"stretch-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"stretch",PangoStretch,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_SCALE:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"scale-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"scale",gdouble,value->ToFloat());
                            property_set=1;
                            break;
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_scale(((ClientPrinter *)item->ptr)->Settings, value->ToFloat()); 
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_RISE:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"rise-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"rise",gint,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_LANGUAGE:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"language-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"language",gchar*,value->c_str());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_BACKGROUNDFULL:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"background-full-height-set",gboolean,TRUE);
                            SET_GPROP(item->ptr,"background-full-height ",gboolean,value->ToInt());
                            property_set=1;
                            break;
                        case CLASS_PRINTER:
                            GTKControl *item2=GetControlID(value->ToInt());
                            if (item2) {
                                GdkWindow *wnd=gtk_widget_get_window(SAFE_WIDGET(item2));
                                ((ClientPrinter *)item->ptr)->SetBackground(wnd);
                            }
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_FORECOLOR:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            {
                                int color=value->ToInt();
                                int red=color/0x10000;
                                color%=0x10000;
                                int green=color/0x100;
                                color%=0x100;
                                int blue=color;
                                GdkColor uset_color;
                                uset_color.red=((unsigned short)red*0xFF);
                                uset_color.green=((unsigned short)green*0xFF);
                                uset_color.blue=((unsigned short)blue*0xFF);

                                SET_GPROP(item->ptr,"foreground-set",gboolean,TRUE);
                                SET_GPROP(item->ptr,"foreground-gdk",GdkColor*,&uset_color);
                                property_set=1;
                            }
                            break;
                    }
                }
                break;
        case P_BACKCOLOR:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            {
                                int color=value->ToInt();
                                int red=color/0x10000;
                                color%=0x10000;
                                int green=color/0x100;
                                color%=0x100;
                                int blue=color;
                                GdkColor uset_color;
                                uset_color.red=((unsigned short)red*0xFF);
                                uset_color.green=((unsigned short)green*0xFF);
                                uset_color.blue=((unsigned short)blue*0xFF);

                                SET_GPROP(item->ptr,"background-set",gboolean,TRUE);
                                SET_GPROP(item->ptr,"background-gdk",GdkColor*,&uset_color);
                                property_set=1;
                            }
                            break;
                    }
                }
                break;
        case P_DIRECTION:
                {
                    switch (item->type) {
                        case CLASS_TEXTTAG:
                            SET_GPROP(item->ptr,"direction",GtkTextDirection,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_DISPOSE:
                {
                    GtkContainer *container=GTK_CONTAINER((GTK_WIDGET(item->ptr))->parent);
                    if (container) {
                        GTKControl *temp=GetControlByPtr(container);
                        if ((temp) && (temp->type==CLASS_NOTEBOOK)) { 
                            gtk_notebook_remove_page(GTK_NOTEBOOK(temp->ptr), gtk_notebook_page_num(GTK_NOTEBOOK(temp->ptr), GTK_WIDGET(item->ptr)));
                        } else
                            gtk_container_remove(GTK_CONTAINER(item->ptr), GTK_WIDGET(item->ptr));
                        RemovetControlPtr(item->ptr);
                    }
                    property_set=1;
                }
                break;
        case P_COLUMNS:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            //gtk_table_set_n_columns(GTK_TABLE(item->ptr), value->ToInt());
                            g_object_set(G_OBJECT(SAFE_WIDGET(item)), "n-columns", value->ToInt(), NULL);
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
                            gtk_icon_view_set_columns(MY_ICON_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ROWS:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            g_object_set(G_OBJECT(SAFE_WIDGET(item)), "n-rows", value->ToInt(), NULL);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ROWSPACING:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            g_object_set(G_OBJECT(SAFE_WIDGET(item)), "row-spacing", value->ToInt(), NULL);
                            property_set=1;
                            break;
                        case CLASS_ICONVIEW:
                            gtk_icon_view_set_row_spacing(MY_ICON_VIEW(item->ptr), value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_COLUMNSPACING:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            g_object_set(G_OBJECT(SAFE_WIDGET(item)), "column-spacing", value->ToInt(), NULL);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTLEFT:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[0]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTRIGHT:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[1]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTTOP:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[2]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTBOTTOM:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[3]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTHOPT:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[4]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTVOPT:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[5]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTHSPACING:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[6]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ATTVSPACING:
                {
                    switch (item->type) {
                        case CLASS_TABLE:
                            int *extra=(int *)item->extra_ptr;
                            extra[7]=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PROPERTIES:
                {
                    switch (item->type) {
                        case CLASS_PROPERTIESBOX:
                            ((PropertiesPanel *)item->extra_ptr)->SetProperties(*value);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PACKING:
                {
                    GtkContainer *container=GTK_CONTAINER((SAFE_WIDGET(item))->parent);
                    if (container) {
                        GTKControl *temp=GetControlByPtr(container);
                        if (!temp)
                            temp=GetControlByPtr(GTK_WIDGET(container)->parent);
                        if (temp) {
                            switch (temp->type) {
                                case CLASS_VBOX:
                                case CLASS_HBOX:
                                case CLASS_HBUTTONBOX:
                                case CLASS_VBUTTONBOX:
                                case CLASS_STATUSBAR:
                                //case CLASS_TABLE:
                                    {
                                        //Gtk::PackOptions po=(Gtk::PackOptions)value->ToInt();
                                        int po=value->ToInt();
                                        bool expand = (po == MyPACK_EXPAND_PADDING || po == MyPACK_EXPAND_WIDGET);
                                        bool fill   = (po == MyPACK_EXPAND_WIDGET);
                                        gtk_box_set_child_packing(  GTK_BOX(temp->ptr),
                                                                    SAFE_WIDGET(item),
                                                                    expand,
                                                                    fill,
                                                                    0,
                                                                    GTK_PACK_START
                                        );
                                    }
                                    break;
                            }
                        }
                    }
                    property_set=1;
                }
                break;
        case P_PARENT:
                {
                    GtkWidget *container=gtk_widget_get_parent(SAFE_WIDGET(item));
                    if (container) {
                        GTKControl *temp=GetControlByPtr(container);
                        GTKControl *ctrl=GetControlID(value->ToInt());
                        if ((temp) && (ctrl)) {
                            gtk_container_remove(GTK_CONTAINER(container), SAFE_WIDGET(item));
                            int/*Gtk::PackOptions*/ pt=0;//MyPACK_SHRINK;
                            switch (item->type) {
                                    case CLASS_FIXED:
                                    case CLASS_TREEVIEW:
                                    case CLASS_VIEWPORT:
                                    case CLASS_HANDLEBOX:
                                    case CLASS_EXPANDER:
                                    case CLASS_NOTEBOOK:
                                    case CLASS_ALIGNMENT:
                                    case CLASS_TEXTVIEW:
                                    case CLASS_VSCROLLBAR:
                                    case CLASS_HSCROLLBAR:
                                    case CLASS_HSCALE:
                                    case CLASS_VSCALE:
                                    case CLASS_IMAGE:
                                    case CLASS_SCROLLEDWINDOW:
                                    case CLASS_HPANED:
                                    case CLASS_VPANED:
                                    case CLASS_ASPECTFRAME:
                                    case CLASS_FRAME:
                                    case CLASS_VSEPARATOR:
                                    case CLASS_HSEPARATOR:
                                    case CLASS_HBUTTONBOX:
                                    case CLASS_VBUTTONBOX:
                                    case CLASS_EVENTBOX:
                                    case CLASS_VBOX:
                                    case CLASS_HBOX:
                                    case CLASS_EDIT:
                                    case CLASS_RADIOBUTTON:
                                    case CLASS_CHECKBUTTON:
                                    case CLASS_BUTTON:
                                        pt=2;//MyPACK_EXPAND_WIDGET;
                                        break;
                            }

                            int ct_id=ctrl->ID;
                            item->parent_id=ct_id;
                            CHECK_OWNER(SAFE_WIDGET(item),pt);

                            property_set=1;
                        } else 
                            std::cerr << "Error in changing parent\n";
                    }
                }
                break;
        case P_MOUSECURSOR:
                {
                    GdkWindow *wnd=gtk_widget_get_window(SAFE_WIDGET(item));
                    if (!wnd)
                        break;

                    int cursor_val=value->ToInt();
                    GdkCursor *cursor=gdk_cursor_new((GdkCursorType)(cursor_val*2));
                    gdk_window_set_cursor(wnd, cursor);
                    property_set=1;
                }
                break;
        case P_MOUSECURSORIMAGE:
                {
                    GTKControl *item2=GetControlID(value->ToInt());
                    if ((!item2) || (item2->type!=CLASS_IMAGE))
                        break;

                    GdkWindow *wnd=gtk_widget_get_window(SAFE_WIDGET(item));
                    if (!wnd)
                        break;

                    GdkDisplay *display=gdk_display_get_default();

                    GdkCursor *cursor=gdk_cursor_new_from_pixbuf(display, ForcePixbuf(item2->ptr)/*((Gtk::Image*)item2->ptr)->get_pixbuf()*/, 0, 0);

                    gdk_window_set_cursor(wnd, cursor);
                    property_set=1;
                    break;
                }
                break;
        case P_USERRESIZABLE:
            {
                GtkWidget *sel_widget=SAFE_WIDGET(item);
                if (sel_widget) {
                    if (value->ToInt()) {
		                g_signal_connect (G_OBJECT (sel_widget), "event", G_CALLBACK (IDE_event), NULL);
                        //g_signal_connect (G_OBJECT (gtk_widget_get_parent(sel_widget)), "event", G_CALLBACK (IDE_event), NULL);
		                /*g_signal_connect (G_OBJECT (sel_widget), "button-release-event", G_CALLBACK (IDE_event), NULL);
		                g_signal_connect (G_OBJECT (sel_widget), "enter-notify-event", G_CALLBACK (IDE_event), NULL);
		                g_signal_connect (G_OBJECT (sel_widget), "button-press-event", G_CALLBACK (IDE_event), NULL);
		                g_signal_connect (G_OBJECT (sel_widget), "motion-notify-event", G_CALLBACK (IDE_event), NULL);*/
		                draw_nodes (/*((GdkEventExpose*) event)->window*/sel_widget);
                    } else {
                        g_signal_handlers_disconnect_by_func(G_OBJECT (sel_widget), (void *)G_CALLBACK (IDE_event), (void *)NULL);
                        SelectedObjects.Clear();
                        REPAINT((SAFE_WIDGET(item)));
                    }

                    property_set=1;
                }
                
            }
            break;
        case P_UNIT:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            ((ClientPrinter *)item->ptr)->Unit=(GtkUnit)value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_BOTTOMMARGIN:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_page_setup_set_bottom_margin(((ClientPrinter *)item->ptr)->PageSetup, value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;

        case P_TOPMARGIN:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_page_setup_set_top_margin(((ClientPrinter *)item->ptr)->PageSetup, value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;
        /*case P_PAGEHEIGHT:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                ((ClientPrinter *)item->ptr)->PageSetup->set_page_height(value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAGEWIDTH:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                ((ClientPrinter *)item->ptr)->PageSetup->set_page_width(value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAPERHEIGHT:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                ((ClientPrinter *)item->ptr)->PageSetup->set_paper_height(value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAPERWIDTH:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                ((ClientPrinter *)item->ptr)->PageSetup->set_paper_width(value->ToFloat(), ((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;*/
        case P_PAPERSIZE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized) {
                                GtkPaperSize *ps=gtk_paper_size_new(value->c_str());
                                gtk_page_setup_set_paper_size(((ClientPrinter *)item->ptr)->PageSetup, ps);
                                gtk_paper_size_free(ps);
                            }
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_COLLATE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_collate(((ClientPrinter *)item->ptr)->Settings,value->ToInt());

                            property_set=1;
                            break;
                    }
                }
                break;
        case P_DITHER:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_dither(((ClientPrinter *)item->ptr)->Settings,value->c_str());

                            property_set=1;
                            break;
                    }
                }
                break;
        case P_DUPLEX:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_duplex(((ClientPrinter *)item->ptr)->Settings,(GtkPrintDuplex)value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_FINISHINGS:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                 gtk_print_settings_set_finishings(((ClientPrinter *)item->ptr)->Settings,value->c_str());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_MEDIATYPE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_media_type(((ClientPrinter *)item->ptr)->Settings,value->c_str());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_COPIES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_n_copies(((ClientPrinter *)item->ptr)->Settings,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_NUMBERUP:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_number_up(((ClientPrinter *)item->ptr)->Settings,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_ORIENTATION_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_orientation(((ClientPrinter *)item->ptr)->Settings,(GtkPageOrientation)value->ToInt());

                            property_set=1;
                            break;
                    }
                }
                break;
        case P_OUTPUTBIN:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_output_bin(((ClientPrinter *)item->ptr)->Settings,value->c_str());

                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAGERANGES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            /*if (((ClientPrinter *)item->ptr)->initialized) {
                                std::vector<Gtk::PrintSettings::PageRange> vct=((ClientPrinter *)item->ptr)->Settings->get_page_ranges();
                                int len=vct.size();
                                for (int i=0;i<len;i++) {
                                    if (i)
                                        result+=",";
                                    result+=AnsiString((long)vct[i].start);
                                    result+=":";
                                    result+=AnsiString((long)vct[i].end);
                                }
                            }*/
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAGESET:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_page_set(((ClientPrinter *)item->ptr)->Settings,(GtkPageSet)value->ToInt());

                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAPERHEIGHT_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_paper_height(((ClientPrinter *)item->ptr)->Settings,value->ToFloat(),((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAPERSIZE_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized) {
                                //Gtk::PaperSize ps((Glib::ustring)value->c_str());
                                GtkPaperSize *ps=gtk_paper_size_new(value->c_str());
                                gtk_print_settings_set_paper_size(((ClientPrinter *)item->ptr)->Settings, ps);
                                gtk_paper_size_free(ps);
                            }
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PAPERWIDTH_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_paper_width(((ClientPrinter *)item->ptr)->Settings,value->ToFloat(),((ClientPrinter *)item->ptr)->Unit);
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PRINTPAGES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_print_pages(((ClientPrinter *)item->ptr)->Settings,(GtkPrintPages)value->ToInt());

                            property_set=1;
                            break;
                    }
                }
                break;
        case P_PRINTER:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_printer(((ClientPrinter *)item->ptr)->Settings,value->c_str());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_QUALITY:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_quality(((ClientPrinter *)item->ptr)->Settings,(GtkPrintQuality)value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_RESOLUTION:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_resolution(((ClientPrinter *)item->ptr)->Settings,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_REVERSE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_reverse(((ClientPrinter *)item->ptr)->Settings,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        /*case P_SCALE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                ((ClientPrinter *)item->ptr)->Settings->set_scale(value->ToFloat());
                            property_set=1;
                            break;
                    }
                }
                break;*/
        case P_USECOLOR:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                gtk_print_settings_set_use_color(((ClientPrinter *)item->ptr)->Settings,value->ToInt());
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_CURRENTPAGE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            ((ClientPrinter *)item->ptr)->CurrentPage=value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_CAPABILITES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            // not used
                            //((ClientPrinter *)item->ptr)->Capabilities=(GtkPrintCapabilities)value->ToInt();
                            property_set=1;
                            break;
                    }
                }
                break;
        case P_DOTTED:
                {
                }
                break;
        default:
                SetCustomProperty(item, prop_id, value);
                property_set=1;
    }
    if (!property_set)
        SetCustomProperty(item, prop_id, value);
    //REPAINT(((Gtk::Widget *)item->ptr))
    return 1;
}

//#include <iostream>
AnsiString GetCustomProperty(GTKControl *item, int prop_id, CConceptClient *Client) {
    INVOKER Invoke=GetRequiredInvoker(item->type);
    AnsiString result;
    if (!Invoke)
        return result;
    char *data=0;
    int data_len=0;

    if (IS_OK(Invoke(item->ptr, INVOKE_GETPROPERTY, item->type, prop_id, &data, &data_len))) {
        //std::cout << data;
        result.LoadBuffer(data,data_len);
    }
    
    return result;
}

int GetProperty(long owner, int prop_id, CConceptClient *Client) {
    GValue value= { 0, };
    GValue dest_value= { 0, };
    GValue def_value2= { 0, };
    GTKControl *item=GetControlID(owner);
    if (!item) {
        Client->SendMessage("-1",MSG_GET_PROPERTY,AnsiString((long)prop_id),"");
        return 0;
    }
    /*AnsiString temp_aiurea;
    AnsiString *value=&temp_aiurea;*/
    
    char done_property=0;
    AnsiString result="";
    switch (prop_id) {
        case P_PACKTYPE:
            result=(long)item->pack_type;
            break;
        case P_CAPTION:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        result=(char*)gtk_window_get_title(GTK_WINDOW(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_BUTTON:
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        result=(char *)gtk_button_get_label(GTK_BUTTON(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_EDIT:
                        result=(char *)gtk_entry_get_text(GTK_ENTRY(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                        result=(char*)gtk_entry_get_text(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(MY_COMBO_BOX(item->ptr)))));
                        done_property=1;
                        break;
                    case CLASS_LABEL:
                        result=(char*)gtk_label_get_text(GTK_LABEL(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        result=(char*)gtk_frame_get_label(GTK_FRAME(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_PROGRESSBAR:
                        result=(char*)gtk_progress_bar_get_text(GTK_PROGRESS_BAR(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_TEXTVIEW:
                        {
                            GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                            //Gtk::TextBuffer::iterator iter = refTextBuffer->get_iter_at_offset(0);
                            GtkTextIter range_begin;
                            gtk_text_buffer_get_start_iter(refTextBuffer, &range_begin);
                            GtkTextIter range_end;
                            gtk_text_buffer_get_end_iter(refTextBuffer, &range_end);
                            result=(char *)gtk_text_buffer_get_text(refTextBuffer, &range_begin, &range_end, FALSE);
                            done_property=1;
                        }
                        break;
                    case CLASS_MENU:
                        result=(char*)gtk_menu_get_title(GTK_MENU(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_EXPANDER:
                        result=(char*)gtk_expander_get_label(GTK_EXPANDER(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_MENUTOOLBUTTON:
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                    case CLASS_TOOLBUTTON:
                        result=(char*)gtk_tool_button_get_label(GTK_TOOL_BUTTON(item->ptr));
                        done_property=1;
                        break;
                    /*case CLASS_COMBOBOX:
                        result=(char*)((Gtk::ComboBox *)item->ptr)->get_title().c_str();
                        break;*/
                }
            }
            break;
        case P_RESIZABLE:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        result=gtk_window_get_resizable(GTK_WINDOW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_HEIGHT:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_size(GTK_WINDOW(item->ptr), &x, &y);
                            result=(long)y;
                            done_property=1;
                            break;
                        }
                    default:
                        result=(long)(SAFE_WIDGET(item))->allocation.height;
                        done_property=1;
                        break;
                }
            }
            break;
        case P_VISIBLE:
            result=(long)gtk_widget_get_visible((SAFE_WIDGET(item)));
            done_property=1;
            break;
        case P_WIDTH:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_size(GTK_WINDOW(item->ptr), &x, &y);
                            result=(long)x;
                            done_property=1;
                            break;
                        }
                    default:
                        result=(long)(SAFE_WIDGET(item))->allocation.width;
                        done_property=1;
                        break;
                }
            }
            break;
        case P_LEFT:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_position(GTK_WINDOW(item->ptr),&x,&y);
                            result=(long)x;
                            done_property=1;
                            break;
                        }
                    default:
                        result=(long)(SAFE_WIDGET(item))->allocation.x;
                        done_property=1;
                        break;
                }
            }
            break;
        case P_TOP:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            int x,y;
                            gtk_window_get_position(GTK_WINDOW(item->ptr),&x,&y);
                            result=(long)y;
                            done_property=1;
                        }
                        break;
                    default:
                        result=(long)(SAFE_WIDGET(item))->allocation.y;
                        done_property=1;
                        break;
                }
            }
            break;
        case P_MODAL:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            result=(long)gtk_window_get_modal(GTK_WINDOW(item->ptr));
                            done_property=1;
                            break;
                        }
                }
            }
            break;
        case P_TITLEBAR:
            {
                switch (item->type) {
                    case CLASS_FORM:
                        {
                            result=(long)gtk_window_get_decorated(GTK_WINDOW(item->ptr));
                            done_property=1;
                            break;
                        }
                }
            }
            break;
        case P_BORDERWIDTH:
            {
                switch (item->type) {
                    case CLASS_FORM:
                    case CLASS_NOTEBOOK:
                    case CLASS_VBOX:
                    case CLASS_HBOX:
                    case CLASS_VBUTTONBOX:
                    case CLASS_HBUTTONBOX:
                    case CLASS_ALIGNMENT:
                    case CLASS_BUTTON:
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                    case CLASS_SCROLLEDWINDOW:
                    case CLASS_VPANED:
                    case CLASS_HPANED:
                    case CLASS_TEXTVIEW:
                    case CLASS_STATUSBAR:
                            result=(long)gtk_container_get_border_width(GTK_CONTAINER(item->ptr));
                            done_property=1;
                            break;
                }
            }
            break;
        case P_RELIEFSTYLE:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        result=(long)gtk_button_get_relief(GTK_BUTTON(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_TOOLBAR:
                        result=(long)gtk_toolbar_get_relief_style(GTK_TOOLBAR(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_IMAGE:
            {
                switch (item->type) {
                    case CLASS_BUTTON:
                        result=GetControlPtr(gtk_button_get_image(GTK_BUTTON(item->ptr)));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_SPACING:
            {
                switch (item->type) {
                    case CLASS_HBOX:
                    case CLASS_VBOX:
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                    case CLASS_STATUSBAR:
                        result=(long)gtk_box_get_spacing(GTK_BOX(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_HOMOGENEOUS:
            {
                switch (item->type) {
                    case CLASS_HBOX:
                    case CLASS_VBOX:
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                    case CLASS_STATUSBAR:
                        result=(long)gtk_box_get_homogeneous(GTK_BOX(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_XPADDING:
            {
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        {
                            gint ipad_x;
                            gint ipad_y;
                            gtk_button_box_get_child_ipadding(GTK_BUTTON_BOX(item->ptr), &ipad_x, &ipad_y);
                            result=(long)ipad_x;
                        }
                        done_property=1;
                        break;
                }
            }
            break;
        case P_YPADDING:
            {
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        {
                            gint ipad_x;
                            gint ipad_y;
                            gtk_button_box_get_child_ipadding(GTK_BUTTON_BOX(item->ptr), &ipad_x, &ipad_y);
                            result=(long)ipad_y;
                        }
                        done_property=1;
                        break;
                }
            }
            break;
        case P_MINHEIGHT:
            {
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        done_property=1;
                        //result=(long)((Gtk::ButtonBox *)item->ptr)->get_child_min_height();
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "child-min-height", &res, NULL);
                            result=(long)res;
                        }
                        break;
                    default:
                        {
                            int x,y;
                            gtk_widget_get_size_request(SAFE_WIDGET(item),&x,&y);
                            done_property=1;
                            result=(long)y;
                        }
                }
            }
            break;
        case P_MINWIDTH:
            {
                switch (item->type) {
                    case CLASS_HBUTTONBOX:
                    case CLASS_VBUTTONBOX:
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "child-min-width", &res, NULL);
                            result=(long)res;
                        }
                        done_property=1;
                        break;
                    default:
                        {
                            int x,y;
                            gtk_widget_get_size_request(SAFE_WIDGET(item),&x,&y);
                            result=(long)x;
                            done_property=1;
                        }
                }
            }
            break;
        case P_MASKEDCHAR:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        result=(char)gtk_entry_get_invisible_char(GTK_ENTRY(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_MASKED:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        result=(long)gtk_entry_get_visibility(GTK_ENTRY(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_READONLY:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                         {
                            gboolean res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "editable", &res, NULL);
                            result=(long)!res;
                         }
                         done_property=1;
                         break;
                    case CLASS_TEXTVIEW:
                         result=(long)!gtk_text_view_get_editable(GTK_TEXT_VIEW(item->ptr));
                         done_property=1;
                         break;
                }
            }
            break;
        case P_MAXLEN:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        result=(long)gtk_entry_get_max_length(GTK_ENTRY(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_ACTIVATEDEFAULT:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        result=(long)gtk_entry_get_activates_default(GTK_ENTRY(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_BORDER:
            {
                switch (item->type) {
                    case CLASS_EDIT:
                        result=(long)gtk_entry_get_has_frame(GTK_ENTRY(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_COMBOBOXTEXT:
                    case CLASS_COMBOBOX:
                        GET_GPROP(MY_COMBO_BOX(item->ptr),"has-frame",gboolean,result,long)
                        done_property=1;
                        break;
                }
            }
            break;
        case P_CHECKED:
            {
                switch (item->type) {
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        done_property=1;
                        result=(long)gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(item->ptr));
                        break;
                    case CLASS_RADIOMENUITEM:
                    case CLASS_CHECKMENUITEM:
                        result=(long)gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_RADIOTOOLBUTTON:
                    case CLASS_TOGGLETOOLBUTTON:
                        result=(long)gtk_toggle_tool_button_get_active(GTK_TOGGLE_TOOL_BUTTON(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_INCONSISTENT:
            {
                switch (item->type) {
                    case CLASS_CHECKBUTTON:
                    case CLASS_RADIOBUTTON:
                        result=(long)gtk_toggle_button_get_inconsistent(GTK_TOGGLE_BUTTON(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_CHECKMENUITEM:
                    case CLASS_RADIOMENUITEM:
                        result=(long)gtk_check_menu_item_get_inconsistent(GTK_CHECK_MENU_ITEM(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_SELECTABLE:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        result=(long)gtk_label_get_selectable(GTK_LABEL(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_WRAP:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        done_property=1;
                        result=(long)gtk_label_get_line_wrap(GTK_LABEL(item->ptr));
                        break;
                    case CLASS_SPINBUTTON:
                        done_property=1;
                        result=(long)gtk_spin_button_get_wrap(GTK_SPIN_BUTTON(item->ptr));
                        break;
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_wrap_mode(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_ANGLE:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        done_property=1;
                        result=(long)gtk_label_get_angle(GTK_LABEL(item->ptr));
                        break;
                }
            }
            break;
        case P_JUSTIFY:
            {
                switch (item->type) {
                    case CLASS_LABEL:
                        result=(long)gtk_label_get_justify(GTK_LABEL(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_justification(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_SHADOWTYPE:
            {
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        result=(long)gtk_frame_get_shadow_type(GTK_FRAME(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_SCROLLEDWINDOW:
                        result=(long)gtk_scrolled_window_get_shadow_type(GTK_SCROLLED_WINDOW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_HTEXTALIGN:
            {
                float x;
                float y;
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        gtk_frame_get_label_align(GTK_FRAME(item->ptr), &x, &y);
                        result=(double)y;
                        done_property=1;
                        break;
                }
            }
            break;
        case P_VTEXTALIGN:
            {
                float x;
                float y;
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                    case CLASS_FRAME:
                        gtk_frame_get_label_align(GTK_FRAME(item->ptr), &x, &y);
                        result=(double)x;
                        done_property=1;
                        break;
                }
            }
            break;
        case P_FRACTION:
            {
                switch (item->type) {
                    case CLASS_PROGRESSBAR:
                        result=(float)gtk_progress_bar_get_fraction(GTK_PROGRESS_BAR(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_ORIENTATION:
            {
                switch (item->type) {
                    case CLASS_PROGRESSBAR:
                        result=(long)gtk_progress_bar_get_orientation(GTK_PROGRESS_BAR(item->ptr));
                        done_property=1;
                        break;
                    case CLASS_PRINTER:
                        if (((ClientPrinter *)item->ptr)->initialized)
                            result=(long)gtk_page_setup_get_orientation(((ClientPrinter *)item->ptr)->PageSetup);
                        done_property=1;
                        break;
                }
            }
            break;
        case P_STEP:
            {
                switch (item->type) {
                    case CLASS_PROGRESSBAR:
                        result=(double)gtk_progress_bar_get_pulse_step(GTK_PROGRESS_BAR(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_POSITION:
            {
                switch (item->type) {
                    case CLASS_VPANED:
                    case CLASS_HPANED:
                        result=(long)gtk_paned_get_position(GTK_PANED(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_LOWER:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        result=(double)gtk_adjustment_get_lower(GTK_ADJUSTMENT(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_UPPER:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        result=(double)gtk_adjustment_get_upper(GTK_ADJUSTMENT(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_VALUE:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        result=(double)gtk_adjustment_get_value(GTK_ADJUSTMENT(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_INCREMENT:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        done_property=1;
                        result=(double)gtk_adjustment_get_step_increment(GTK_ADJUSTMENT(item->ptr));
                        break;
                }
            }
            break;
        case P_PAGEINCREMENT:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        done_property=1;
                        result=(double)gtk_adjustment_get_page_increment(GTK_ADJUSTMENT(item->ptr));
                        break;
                }
            }
            break;
        case P_PAGESIZE:
            {
                switch (item->type) {
                    case CLASS_ADJUSTMENT:
                        done_property=1;
                        result=(double)gtk_adjustment_get_page_size(GTK_ADJUSTMENT(item->ptr));
                        break;
                }
            }
            break;
        case P_DIGITS:
            {
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                        done_property=1;
                        result=(long)gtk_scale_get_digits(GTK_SCALE(item->ptr));
                        break;
                    case CLASS_SPINBUTTON:
                        done_property=1;
                        result=(long)gtk_spin_button_get_digits(GTK_SPIN_BUTTON(item->ptr));
                        break;
                }
            }
            break;
        case P_DRAWVALUE:
            {
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                        done_property=1;
                        result=(long)gtk_scale_get_draw_value(GTK_SCALE(item->ptr));
                        break;
                }
            }
            break;
        case P_VALUEPOS:
            {
                switch (item->type) {
                    case CLASS_VSCALE:
                    case CLASS_HSCALE:
                        done_property=1;
                        result=(long)gtk_scale_get_value_pos(GTK_SCALE(item->ptr));
                        break;
                }
            }
            break;
        case P_INVERTED:
            {
                switch (item->type) {
                    case CLASS_VSCROLLBAR:
                    case CLASS_HSCROLLBAR:
                        result=(long)gtk_range_get_inverted(GTK_RANGE(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_SNAPTOTICKS:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        result=(long)gtk_spin_button_get_snap_to_ticks(GTK_SPIN_BUTTON(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_NUMERIC:
            {
                switch (item->type) {
                    case CLASS_SPINBUTTON:
                        done_property=1;
                        result=(long)gtk_spin_button_get_numeric(GTK_SPIN_BUTTON(item->ptr));
                        break;
                }
            }
            break;
        case P_ACCEPTTAB:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        done_property=1;
                        result=(long)gtk_text_view_get_accepts_tab(GTK_TEXT_VIEW(item->ptr));
                        break;
                }
            }
            break;
        case P_SELECTIONSTART:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        done_property=1;
                        GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                        GtkTextMark *marker=gtk_text_buffer_get_insert(refTextBuffer);
                        GtkTextIter iter;
                        gtk_text_buffer_get_iter_at_mark(refTextBuffer, &iter, marker);

                        result=(long)gtk_text_iter_get_offset(&iter);
                        break;
                }
            }
            break;
        case P_SELECTIONLENGTH:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        done_property=1;
                        GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                        
                        GtkTextMark *marker = gtk_text_buffer_get_selection_bound(refTextBuffer);
                        GtkTextMark *marker2 = gtk_text_buffer_get_insert(refTextBuffer);
                        if ((marker) && (marker2)) {
                            GtkTextIter iter;
                            gtk_text_buffer_get_iter_at_mark(refTextBuffer, &iter, marker);

                            GtkTextIter iter2;
                            gtk_text_buffer_get_iter_at_mark(refTextBuffer, &iter2, marker2);

                            long len=gtk_text_iter_get_offset(&iter)-gtk_text_iter_get_offset(&iter2);
                            if (len<0)
                                len*=-1;
                            result=len;
                        }
                        break;
                }
            }
            break;
        case P_CURSORVISIBLE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_cursor_visible(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_INDENT:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_indent(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_LEFTMARGIN:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        done_property=1;
                        result=(long)gtk_text_view_get_left_margin(GTK_TEXT_VIEW(item->ptr));
                        break;
                    case CLASS_PRINTER:
                        if (((ClientPrinter *)item->ptr)->initialized)
                            result=(double)gtk_page_setup_get_left_margin(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                        done_property=1;
                        break;

                }
            }
            break;
        case P_RIGHTMARGIN:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        done_property=1;
                        result=(long)gtk_text_view_get_right_margin(GTK_TEXT_VIEW(item->ptr));
                        break;
                    case CLASS_PRINTER:
                        if (((ClientPrinter *)item->ptr)->initialized)
                            result=(double)gtk_page_setup_get_right_margin(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                        done_property=1;
                        break;

                }
            }
            break;
        case P_OVERWRITE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        done_property=1;
                        result=(long)gtk_text_view_get_overwrite(GTK_TEXT_VIEW(item->ptr));
                        break;
                }
            }
            break;
        case P_PIXELSABOVE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_pixels_above_lines(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_PIXELSBELOW:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_pixels_below_lines(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_PIXELSINSIDE:
            {
                switch (item->type) {
                    case CLASS_TEXTVIEW:
                        result=(long)gtk_text_view_get_pixels_inside_wrap(GTK_TEXT_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
            }
            break;
        case P_XSCALE:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        {
                            float res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "xscale", &res, NULL);
                            result=(double)res;
                        }
                        done_property=1;
                        break;
                }
            }
            break;
        case P_YSCALE:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        {
                            float res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "yscale", &res, NULL);
                            result=(double)res;
                        }
                        done_property=1;
                        break;
                }
            }
            break;
        case P_XALIGN:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        {
                            float res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "xalign", &res, NULL);
                            result=(double)res;
                        }
                        done_property=1;
                        break;
                    case CLASS_ASPECTFRAME:
                        {
                            float res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "xalign", &res, NULL);
                            result=(double)res;
                        }
                        done_property=1;
                        break;
                }
            }
            break;
        case P_YALIGN:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        {
                            float res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "yalign", &res, NULL);
                            result=(double)res;
                        }
                        done_property=1;
                        break;
                    case CLASS_ASPECTFRAME:
                        {
                            float res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "yalign", &res, NULL);
                            result=(double)res;
                        }
                        done_property=1;
                        break;
                }
            }
            break;
        case P_TOPPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        done_property=1;
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "top-padding", &res, NULL);
                            result=(long)res;
                        }
                        break;
                }
            }
            break;
        case P_LEFTPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        done_property=1;
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "left-padding", &res, NULL);
                            result=(long)res;
                        }
                        break;
                }
            }
            break;
        case P_RIGHTPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        done_property=1;
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "right-padding", &res, NULL);
                            result=(long)res;
                        }
                        break;
                }
            }
            break;
        case P_BOTTOMPADDING:
            {
                switch (item->type) {
                    case CLASS_ALIGNMENT:
                        done_property=1;
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "bottom-padding", &res, NULL);
                            result=(long)res;
                        }
                        break;
                }
            }
            break;
        case P_PAGE:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        result=(long)gtk_notebook_get_current_page(GTK_NOTEBOOK(item->ptr));
                        break;
                }
            }
            break;
        case P_SCROLLABLE:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        result=(long)gtk_notebook_get_scrollable(GTK_NOTEBOOK(item->ptr));
                        break;
                }
            }
            break;
        case P_SHOWBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        result=(long)gtk_notebook_get_show_border(GTK_NOTEBOOK(item->ptr));
                        break;
                }
            }
            break;
        case P_SHOWTABS:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        result=(long)gtk_notebook_get_show_tabs(GTK_NOTEBOOK(item->ptr));
                        break;
                }
            }
            break;
        /*case P_TABBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        result=(long)((Gtk::Notebook *)item->ptr)->property_tab_border();
                        break;
                }
            }
            break;*/
        case P_TABPOS:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        result=(long)gtk_notebook_get_tab_pos(GTK_NOTEBOOK(item->ptr));
                        break;
                }
            }
            break;
        case P_VERTICALBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "tab-vborder", &res, NULL);
                            result=(long)res;
                        }
                        break;
                }
            }
            break;
        case P_HORIZONTALBORDER:
            {
                switch (item->type) {
                    case CLASS_NOTEBOOK:
                        done_property=1;
                        {
                            int res=0;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "tab-hborder", &res, NULL);
                            result=(long)res;
                        }
                        break;
                }
            }
            break;
        case P_HADJUSTMENT:
            {
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        done_property=1;
                        result=(long)GetControlPtr(gtk_scrolled_window_get_hadjustment(GTK_SCROLLED_WINDOW(item->ptr)));
                        break;
                }
            }
            break;
        case P_VADJUSTMENT:
            {
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        done_property=1;
                        result=(long)GetControlPtr(gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(item->ptr)));
                        break;
                }
            }
            break;
        case P_PLACEMENT:
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        done_property=1;
                        result=(long)gtk_scrolled_window_get_placement(GTK_SCROLLED_WINDOW(item->ptr));
                        break;
                }
                break;
        case P_HSCROLLBARPOLICY:
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        done_property=1;
                        {
                             GtkPolicyType hscrollbar_policy;
                             GtkPolicyType vscrollbar_policy;
                             gtk_scrolled_window_get_policy(GTK_SCROLLED_WINDOW(item->ptr),&hscrollbar_policy,&vscrollbar_policy);
                             result=(long)hscrollbar_policy;
                        }
                        break;
                }
                break;
        case P_VSCROLLBARPOLICY:
                switch (item->type) {
                    case CLASS_SCROLLEDWINDOW:
                        {
                             GtkPolicyType hscrollbar_policy;
                             GtkPolicyType vscrollbar_policy;
                             gtk_scrolled_window_get_policy(GTK_SCROLLED_WINDOW(item->ptr),&hscrollbar_policy,&vscrollbar_policy);
                             result=(long)vscrollbar_policy;
                        }
                        done_property=1;
                        break;
                }
                break;
        case P_OBEYCHILD:
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                        {
                            gboolean obey;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "obey-child", &obey, NULL);

                            result=(long)obey;
                        }
                        done_property=1;
                        break;
                }
                break;
        case P_RATIO:
                switch (item->type) {
                    case CLASS_ASPECTFRAME:
                        {
                            float val;
                            g_object_get(G_OBJECT(SAFE_WIDGET(item)), "ratio", &val, NULL);

                            result=(double)val;
                        }
                        done_property=1;
                        break;
                }
                break;
        case P_EXPANDED:
                switch (item->type) {
                    case CLASS_EXPANDER:
                        result=(long)gtk_expander_get_expanded(GTK_EXPANDER(item->ptr));
                        done_property=1;
                        break;
                }
                break;
        case P_HANDLEPOSITION:
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        result=(long)gtk_handle_box_get_handle_position(GTK_HANDLE_BOX(item->ptr));
                        done_property=1;
                        break;
                }
                break;
        case P_SNAPEDGE:
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        result=(long)gtk_handle_box_get_snap_edge(GTK_HANDLE_BOX(item->ptr));
                        done_property=1;
                        break;
                }
                break;
        case P_INDRAG:
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        result=(long)GTK_HANDLE_BOX(item->ptr)->in_drag;
                        done_property=1;
                        break;
                }
                break;
        case P_ISDETACHED:
                switch (item->type) {
                    case CLASS_HANDLEBOX:
                        result=(long)gtk_handle_box_get_child_detached(GTK_HANDLE_BOX(item->ptr));
                        done_property=1;
                        break;
                }
                break;
        case P_ICONSIZE:
                switch (item->type) {
                    case CLASS_TOOLBAR:
                        result=(long)gtk_toolbar_get_icon_size(GTK_TOOLBAR(item->ptr));
                        done_property=1;
                        break;
                }
                break;
        case P_COLUMNS:
                switch (item->type) {
                    case CLASS_ICONVIEW:
                        result=(long)gtk_icon_view_get_columns(MY_ICON_VIEW(item->ptr));
                        done_property=1;
                        break;
                }
                break;                
        case P_SELECTEDCOLUMN:
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        {
                            GtkTreePath *path;
                            GtkTreeViewColumn *focus_column;

                            gtk_tree_view_get_cursor(GTK_TREE_VIEW(((DeturnatedTreeView *)item->ptr)->handle), &path, &focus_column);
                            result=(long)((DeturnatedTreeView *)item->ptr)->GetColumnIndex(focus_column);

                            done_property=1;
                        }
                        break;
                }
                break;
        case P_CURSOR:
                {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            {
                                /*Gtk::TreeModel::Path path;
                                Gtk::TreeViewColumn* focus_column;

                                ((Gtk::TreeView *)item->ptr)->get_cursor(path,focus_column);
                                if (!path.empty()) {
                                    result=(char *)path.to_string().c_str();
									if (!result.Length())
										result="-1";
                                } else {
                                    result="-1";
                                }*/
                                GtkTreePath *path;
                                GtkTreeViewColumn *focus_column;

                                gtk_tree_view_get_cursor(GTK_TREE_VIEW(((DeturnatedTreeView *)item->ptr)->handle), &path, &focus_column);
                                gchar *pstr=gtk_tree_path_to_string(path);
                                if (pstr) {
                                    result=(char *)pstr;
									if (!result.Length())
										result="-1";
                                    g_free(pstr);
                                } else {
                                    result="-1";
                                }

                                done_property=1;
                            }
                            break;
                        case CLASS_COMBOBOXTEXT:
                        case CLASS_COMBOBOX:
                            result=(long)gtk_combo_box_get_active(MY_COMBO_BOX(item->ptr));
                            done_property=1;
                            break;
                        case CLASS_ICONVIEW:
                            {
                                GtkTreePath *path;

                                gtk_icon_view_get_cursor(GTK_ICON_VIEW(((DeturnatedIconView *)item->ptr)->handle), &path, NULL);
                                gchar *pstr=gtk_tree_path_to_string(path);
                                if (pstr) {
                                    result=(char *)pstr;
									if (!result.Length())
										result="-1";
                                    g_free(pstr);
                                } else {
                                    result="-1";
                                }

                                done_property=1;
                            }
                            break;
                    }
                }
                break;
        case P_DAY:
                {
                    switch (item->type) {
                        case CLASS_CALENDAR:
                            {
                                unsigned int year, month, day;
                                gtk_calendar_get_date(GTK_CALENDAR(item->ptr),&year,&month,&day);
                                result=(long)day;
                                done_property=1;
                                break;
                            }
                    }
                }
                break;
        case P_MONTH:
                {
                    switch (item->type) {
                        case CLASS_CALENDAR:
                            {
                                unsigned int year, month, day;
                                gtk_calendar_get_date(GTK_CALENDAR(item->ptr),&year,&month,&day);
                                result=(long)month+1;
                                done_property=1;
                                break;
                            }
                    }
                }
                break;
        case P_YEAR:
                {
                    switch (item->type) {
                        case CLASS_CALENDAR:
                            {
                                unsigned int year, month, day;
                                gtk_calendar_get_date(GTK_CALENDAR(item->ptr),&year,&month,&day);
                                result=(long)year;
                                done_property=1;
                                break;
                            }
                    }
                }
                break;
        case P_UNIT:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            result=(long)((ClientPrinter *)item->ptr)->Unit;
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_BOTTOMMARGIN:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_page_setup_get_bottom_margin(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;

        case P_TOPMARGIN:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_page_setup_get_top_margin(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAGEHEIGHT:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_page_setup_get_page_height(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAGEWIDTH:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_page_setup_get_page_width(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAPERHEIGHT:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_page_setup_get_paper_height(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAPERWIDTH:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_page_setup_get_paper_width(((ClientPrinter *)item->ptr)->PageSetup, ((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAPERSIZE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized) {
                                GtkPaperSize *ps=gtk_page_setup_get_paper_size(((ClientPrinter *)item->ptr)->PageSetup);
                                result=(char *)gtk_paper_size_get_name(ps);
                                //g_object_unref(ps);
                            }
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_COLLATE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_collate(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_DITHER:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(char *)gtk_print_settings_get_dither(((ClientPrinter *)item->ptr)->Settings);
                                //result=((ClientPrinter *)item->ptr)->Settings->get_dither().c_str();
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_DUPLEX:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_duplex(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_FINISHINGS:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(char *)gtk_print_settings_get_finishings(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_MEDIATYPE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(char *)gtk_print_settings_get_media_type(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_COPIES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_n_copies(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_NUMBERUP:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_number_up(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_ORIENTATION_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_orientation(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_OUTPUTBIN:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(char *)gtk_print_settings_get_output_bin(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAGERANGES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized) {
                                int len;
                                GtkPageRange *vct=gtk_print_settings_get_page_ranges(((ClientPrinter *)item->ptr)->Settings, &len);
                                for (int i=0;i<len;i++) {
                                    if (i)
                                        result+=",";
                                    result+=AnsiString((long)vct[i].start);
                                    result+=":";
                                    result+=AnsiString((long)vct[i].end);
                                }
                                g_free(vct);
                            }
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAGESET:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_page_set(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAPERHEIGHT_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_paper_height(((ClientPrinter *)item->ptr)->Settings,((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAPERSIZE_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized) {
                                GtkPaperSize *ps=gtk_print_settings_get_paper_size(((ClientPrinter *)item->ptr)->Settings);
                                result=(char *)gtk_paper_size_get_name(ps);
                                //g_object_unref(ps);
                            }
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PAPERWIDTH_2:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_paper_width(((ClientPrinter *)item->ptr)->Settings,((ClientPrinter *)item->ptr)->Unit);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PRINTPAGES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_print_pages(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PRINTER:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(char *)gtk_print_settings_get_printer(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_QUALITY:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_quality(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_RESOLUTION:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_resolution(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_REVERSE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_reverse(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_SCALE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(double)gtk_print_settings_get_scale(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_USECOLOR:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            if (((ClientPrinter *)item->ptr)->initialized)
                                result=(long)gtk_print_settings_get_use_color(((ClientPrinter *)item->ptr)->Settings);
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_CURRENTPAGE:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            result=(long)((ClientPrinter *)item->ptr)->CurrentPage;
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_CAPABILITES:
                {
                    switch (item->type) {
                        case CLASS_PRINTER:
                            // not used
                            //result=(long)((ClientPrinter *)item->ptr)->Capabilities;
                            done_property=1;
                            break;
                    }
                }
                break;
        case P_PRESENTYOURSELF:
                {
                    guint n_specs;
                    GParamSpec **specs;
                    if (G_TYPE_IS_INTERFACE(G_OBJECT_TYPE(SAFE_WIDGET(item)))) {
                        gpointer vtable = g_type_default_interface_peek (G_OBJECT_TYPE(SAFE_WIDGET(item)));
                        specs=g_object_interface_list_properties(vtable, &n_specs);
                    } else {
                        GObjectClass *cls = G_OBJECT_CLASS(g_type_class_peek(G_OBJECT_TYPE(SAFE_WIDGET(item))));
                        specs=g_object_class_list_properties(cls, &n_specs);
                    }
                    result=(char *)"";
                    for (int idx=0;idx<n_specs;idx++) {
                        if (idx)
                            result+=(char *)"\n";
                        GParamSpec *spec=specs[idx];
                        if ((spec->flags & G_PARAM_READABLE) || (spec->flags & G_PARAM_WRITABLE)) {
                            result+=(char *)spec->name;
                            result+=(char *)",";
                            result+=(char *)g_param_spec_get_nick(spec);
                            result+=(char *)",";
                            if (spec->flags & G_PARAM_READABLE)
                                result+=(char *)"R";
                            if (spec->flags & G_PARAM_WRITABLE)
                                result+=(char *)"W";
                            result+=(char *)",";
                            result+=AnsiString((char *)g_type_name(spec->value_type));
                            if (G_IS_PARAM_SPEC_ENUM(spec)) {
                                result+=(char *)"[";
                                GParamSpecEnum *specEnum=G_PARAM_SPEC_ENUM(spec);
                                if (specEnum->enum_class) {
                                    for (int i=0;i<specEnum->enum_class->n_values;i++) {
                                        if (i)
                                            result+=(char *)";";
                                        GEnumValue *enum_val=&specEnum->enum_class->values[i];

                                        result+=AnsiString((char *)enum_val->value_nick);
                                        result+=(char *)"=";
                                        result+=AnsiString((char *)enum_val->value_name);
                                    }
                                }
                                result+=(char *)"]";
                            }
                            result+=(char *)",";
                            result+=AnsiString((char *)g_type_name(spec->owner_type));
                            result+=(char *)",";
                            g_value_init(&def_value2, spec->value_type);
                            g_param_value_defaults(spec, &def_value2);
                            g_value_init(&dest_value, G_TYPE_STRING);
                            if (g_value_transform(&def_value2, &dest_value)) {
                                result+=AnsiString((char *)g_value_get_string(&dest_value));
                            }
                            g_value_unset(&dest_value);
                            g_value_unset(&def_value2);


                            g_value_init(&value, spec->value_type);
                            g_value_init(&dest_value, G_TYPE_STRING);
                            g_object_get_property(G_OBJECT(SAFE_WIDGET(item)), spec->name, &value);
                            if (g_value_transform(&value, &dest_value)) {
                                result+=(char *)"=";
                                result+=AnsiString((char *)g_value_get_string(&dest_value));
                            }
                            g_value_unset(&value);
                            g_value_unset(&dest_value);
                        }
                    }
                    g_free(specs);
                    done_property=1;
                }
                break;
        case P_SCREENSHOT:
                {
                    //int dwidth, dheight;
                    //GdkWindow *backwindow=gtk_widget_get_window(SAFE_WIDGET(item));
                    result=(char *)"";
                    done_property=1;
                    //if (backwindow) {
                        /*gdk_drawable_get_size(backwindow,&dwidth, &dheight);
                        GdkPixbuf *tmp_buf = gdk_pixbuf_get_from_drawable (NULL,  
                                                                backwindow,
                                                                NULL,  
                                                                0, 0, 
                                                                0, 0, 
                                                                dwidth, dheight); */
                        GdkPixbuf *tmp_buf = 0;
                        GdkPixmap *tmp_map = gtk_widget_get_snapshot(SAFE_WIDGET(item), NULL);
                        if (tmp_map)
                            tmp_buf = gdk_pixbuf_get_from_drawable(NULL, tmp_map, NULL,  0, 0, 0, 0, -1, -1); 
                        if (tmp_buf) {
                            char *buffer=0;
                            gsize buf_size=0;
                            if (gdk_pixbuf_save_to_buffer(tmp_buf, &buffer, &buf_size, "png", NULL, NULL)) {
                                result.LoadBuffer(buffer, buf_size);
                            }
                        }
                    //}
                }
                break;
        default:
            result=GetCustomProperty(item, prop_id, Client);
            done_property=1;
            break;
    }

    if (!done_property)
            result=GetCustomProperty(item, prop_id, Client);

    Client->SendMessage(AnsiString(owner),MSG_GET_PROPERTY,AnsiString((long)prop_id),result);
    return 1;
}

int SetCustomStream(GTKControl *item, AnsiString *target, AnsiString *value, char secondary=0) {
    INVOKER Invoke=GetRequiredInvoker(item->type);
    if (!Invoke)
        return 0;

    if (secondary)
        return IS_OK(Invoke(item->ptr, INVOKE_SETSECONDARYSTREAM, item->type, target->c_str(), (int)target->Length(), value->c_str(), (int)value->Length()));
    return IS_OK(Invoke(item->ptr, INVOKE_SETSTREAM, item->type, target->c_str(), (int)target->Length(), value->c_str(), (int)value->Length()));
}

int CustomMessage(GTKControl *item, int message,AnsiString target, AnsiString value) {
    INVOKER Invoke=GetRequiredInvoker(item->type);
    if (!Invoke)
        return 0;

    return IS_OK(Invoke(item->ptr, INVOKE_CUSTOMMESSAGE, message, item->type, target.c_str(), (int)target.Length(), value.c_str(), (int)value.Length()));
}

int SetStream(long owner, AnsiString *target, AnsiString *value) {
    GTKControl *item=GetControlID(owner);
    if (!item) {
        std::cerr << "Error setting stream: Invalid RID in owner\n";
        return 0;
    }
    switch (item->type) {
        case CLASS_IMAGE:
            {
                //((Gtk::Image *)item->ptr)->clear();
                gtk_image_clear(GTK_IMAGE(item->ptr));
                //AnsiString full_path;//=COOKIES;
                //full_path+=*target;
                // target e gol ...
                if (*target==(char *)"")
                    break;
                //char *buffer=new char[value->Length()+1];
                //int size=decode(value->c_str(),value->Length(),buffer);
                FILE *out=fopen(target->c_str(),"wb");
                if (out) {
                    fwrite(value->c_str(),value->Length(),1,out);
                    fclose(out);
                } else {
                    std::cerr << "Warning: error writing cookie. Check your write rights.\n";
                }
                //delete[] buffer;
                gtk_image_set_from_file(GTK_IMAGE(item->ptr), target->c_str());
            }
            break;
        default:
            SetCustomStream(item,target,value);
    }
    return 1;
}


/*Glib::RefPtr<Gdk::Pixbuf>*/int GetIcon(void *ptr, char *icon, int size) {
        /*Glib::RefPtr<Gtk::IconTheme> ref=Gtk::IconTheme::get_default();
        
        if (ref)  {
            if (ref->has_icon(icon)) {
                image->
                return ref->load_icon(icon, 8*size, Gtk::ICON_LOOKUP_NO_SVG);
            }
        }

        return ((Gtk::Image *)ptr)->render_icon(Gtk::StockID(icon),(Gtk::IconSize)size);*/
        gtk_image_set_from_stock(GTK_IMAGE(ptr), icon, (GtkIconSize)size);
        return 0;
}

int SetSecondaryStream(long owner, AnsiString *target, AnsiString *value) {
    GTKControl *item=GetControlID(owner);
    if ((!item) || (!item->ptr)) {
        std::cerr << "Error setting secondary stream: Invalid RID in owner\n";
        return 0;
    }
    switch (item->type) {
        case CLASS_IMAGE:
            {
                AnsiString obj=GET_STOCK(target);
                if (obj.Length()) {
                    gtk_image_clear(GTK_IMAGE(item->ptr));
                    //Glib::RefPtr<Gdk::Pixbuf> pixbuf=((Gtk::Image *)item->ptr)->render_icon(*obj, (Gtk::IconSize)value->ToInt());
                    //((Gtk::Image *)item->ptr)->property_pixbuf()=pixbuf;
                    gtk_image_set_from_stock(GTK_IMAGE(item->ptr), obj.c_str(), (GtkIconSize)value->ToInt());
                } else {
                    gtk_image_clear(GTK_IMAGE(item->ptr));
                    //Glib::RefPtr<Gdk::Pixbuf> pixbuf=((Gtk::Image *)item->ptr)->render_icon(Gtk::StockID(target->c_str()), (Gtk::IconSize)value->ToInt());
                    /*((Gtk::Image *)item->ptr)->property_pixbuf()=*/
                    //GetIcon(item->ptr,target->c_str(),value->ToInt());
                    gtk_image_set_from_stock(GTK_IMAGE(item->ptr), target->c_str(), (GtkIconSize)value->ToInt());
                }
            }
            break;
        default:
            SetCustomStream(item,target,value,1);
    }
    return 1;
}

int CallRemoteMethod(long owner, AnsiString *target, AnsiString *value) {
    return 0;
}

void SET_COLUMN_PROPERTY(GtkTreeViewColumn *column, int type, int property, AnsiString *value, int index) {
    if (!column) {
        std::cerr << "Invalid column index:" << index << "\n";
        return;
    }
    switch (property) {
        case P_ALIGNMENT:
            gtk_tree_view_column_set_alignment(column,value->ToFloat());
            break;
        case P_EXPAND:
            gtk_tree_view_column_set_expand(column, value->ToInt());
            break;
        case P_CLICKABLE:
            gtk_tree_view_column_set_clickable(column, value->ToInt());
            break;
        case P_FIXEDWIDTH:
            gtk_tree_view_column_set_fixed_width(column,value->ToInt());
            break;
        case P_MAXWIDTH:
            gtk_tree_view_column_set_max_width(column, value->ToInt());
            break;
        case P_MINWIDTH:
            gtk_tree_view_column_set_min_width(column, value->ToInt());
            break;
        case P_REORDERABLE:
            gtk_tree_view_column_set_reorderable(column, value->ToInt());
            break;
        case P_SIZING:
            gtk_tree_view_column_set_sizing(column, (GtkTreeViewColumnSizing)value->ToInt());
            break;
        case P_RESIZABLE:
            gtk_tree_view_column_set_resizable(column, value->ToInt());
            break;
        case P_SORTINDICATOR:
            gtk_tree_view_column_set_sort_indicator(column, value->ToInt());
            break;
        case P_CAPTION:
            gtk_tree_view_column_set_title(column, value->c_str());
            break;
        case P_SORTINDICATORTYPE:
            gtk_tree_view_column_set_sort_order(column, (GtkSortType)value->ToInt());
            break;
        case P_VISIBLE:
            gtk_tree_view_column_set_visible(column, value->ToInt());
            break;
        case P_WIDGET:
            {
                GTKControl *target=GetControlID(value->ToInt());
                if ((target) && (target->ptr)) {
                    gtk_tree_view_column_set_widget(column, SAFE_WIDGET(target));
                } else {
                    std::cerr << "Invalid control ID\n";
                }
            }
            break;
        case P_BACKCOLOR:
            {
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRenderer *cr=GTK_CELL_RENDERER(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    int color=value->ToInt();
                    if (color==-1) {
                        SET_GPROP(cr,"cell-background-set",gboolean,FALSE)
                    } else {
                        int red=color/0x10000;
                        color%=0x10000;
                        int green=color/0x100;
                        color%=0x100;
                        int blue=color;
                        GdkColor uset_color;
                        uset_color.red=((unsigned short)red*0xFF);
                        uset_color.green=((unsigned short)green*0xFF);
                        uset_color.blue=((unsigned short)blue*0xFF);

                        SET_GPROP(cr,"cell-background-gdk",GdkColor *,&uset_color)
                        SET_GPROP(cr,"cell-background-set",gboolean,TRUE)
                    }
                }
            }
            break;
        case P_SENSITIVE:
            {
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRenderer *cr=GTK_CELL_RENDERER(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    SET_GPROP(cr, "sensitive", gboolean, value->ToInt());
                    //gtk_cell_renderer_set_sensitive(cr, value->ToInt());
                }
            }
            break;
        case P_FORECOLOR:
            {
                if ((type==2) || (type==5)) {
                    std::cerr << "Invalid property for non-text TreeViewColumn: forecolor\n";
                    break;
                }
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRendererText *cr=GTK_CELL_RENDERER_TEXT(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    int color=value->ToInt();
                    if (color==-1) {
                        SET_GPROP(cr,"foreground-set",gboolean,FALSE)
                    } else {
                        int red=color/0x10000;
                        color%=0x10000;
                        int green=color/0x100;
                        color%=0x100;
                        int blue=color;
                        GdkColor uset_color;
                        uset_color.red=((unsigned short)red*0xFF);
                        uset_color.green=((unsigned short)green*0xFF);
                        uset_color.blue=((unsigned short)blue*0xFF);
                        SET_GPROP(cr,"foreground-gdk",GdkColor *,&uset_color)
                        SET_GPROP(cr,"foreground-set",gboolean,TRUE)
                    }
                }
            }
            break;
        case P_XALIGN:
            {
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRenderer *cr=GTK_CELL_RENDERER(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    SET_GPROP(cr,"xalign",gfloat,value->ToFloat())
                }
            }
            break;
        case P_YALIGN:
            {
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRenderer *cr=GTK_CELL_RENDERER(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    SET_GPROP(cr,"yalign",gfloat,value->ToFloat())
                }
            }
            break;
        case P_XPADDING:
            {
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRenderer *cr=GTK_CELL_RENDERER(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    SET_GPROP(cr,"xpad",gfloat,value->ToFloat())
                }
            }
            break;
        case P_YPADDING:
            {
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRenderer *cr=GTK_CELL_RENDERER(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    SET_GPROP(cr,"ypad",gfloat,value->ToFloat())
                }
            }
            break;
        case P_WRAP:
            {
                if ((type==2) || (type==5)) {
                    std::cerr << "Invalid property for non-text TreeViewColumn: wrap\n";
                    break;
                }
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRendererText *cr=GTK_CELL_RENDERER_TEXT(lst->data);
                if (lst)
                    g_list_free(lst);

                if (cr) {
                    SET_GPROP(cr,"wrap-mode",PangoWrapMode,value->ToInt())
                }
            }
            break;
        case P_FONTNAME:
            {
                if ((type==2) || (type==5)) {
                    std::cerr << "Invalid property for non-text TreeViewColumn: fontname\n";
                    break;
                }
                GList *lst=gtk_tree_view_column_get_cell_renderers(column);
                GtkCellRendererText *cr=GTK_CELL_RENDERER_TEXT(lst->data);
                if (lst)
                    g_list_free(lst);
                if (cr) {
                    SET_GPROP(cr,"font",gchar *,value->c_str())
                }
            }
            break;
        default:
            std::cerr << "Invalid property for TreeViewColumn: " << property << "\n";
    }
}

int GetDNDFile(Parameters *PARAM) {
    GTKControl *item=GetControlID(PARAM->Sender.ToInt());
    if (!item) {		
		lpClient->SendMessage("%CLIENT",MSG_GET_DNDFILE,"-5","Error in custom message: Invalid RID in owner");
        std::cerr << "Error in custom message: Invalid RID in owner\n";
        return 0;
    }
	if (!item->event_handler) {
		lpClient->SendMessage(PARAM->Sender,MSG_GET_DNDFILE,"-4","No drop operations on this object");
        std::cerr << "No drop operations on this object\n";
		return 0;
	}
	if (PARAM->Value.ToInt()==1) {
		((ClientEventHandler *)item->event_handler)->ResetDrop();
		return 0;
	}
	if (!((ClientEventHandler *)item->event_handler)->FileIsDropped(PARAM->Target)) {
		lpClient->SendMessage(PARAM->Sender,MSG_GET_DNDFILE,"-3","The requested file was not dropped here");
        std::cerr << "The requested file was not dropped here\n";
		return 0;
	} else {
		AnsiString data;
		std::string filename;
#ifdef _WIN32
		if (PARAM->Target.Pos("file:///")==1)
			filename=UriDecode(PARAM->Target.c_str()+8);
#else
		if (PARAM->Target.Pos("file://")==1)
			filename=UriDecode(PARAM->Target.c_str()+7);
#endif
		else
			filename=UriDecode(PARAM->Target.c_str());
		
		if (data.LoadFile((char *)filename.c_str())==0) {
			lpClient->SendBigMessage(PARAM->Sender,MSG_GET_DNDFILE,"0",&data);
		} else {
			lpClient->SendMessage(PARAM->Sender,MSG_GET_DNDFILE,"-1","Error reading file (insufficient rights ?)");
			std::cerr << "Error reading file (insufficient rights ?)\n";
		}
		return 0;
	}
	return 1;
}

int MSG_CUSTOM_MESSAGE(Parameters *PARAM) {
    GTKControl *item=GetControlID(PARAM->Sender.ToInt());
    if (!item) {
        std::cerr << "Error in custom message: Invalid RID in owner\n";
        return 0;
    }
    switch (PARAM->ID) {
        case MSG_CUSTOM_MESSAGE1:
            {
                switch (item->type) {
                    // set page caption by index
                    case CLASS_NOTEBOOK:
                        {
                            GtkWidget *page=gtk_notebook_get_nth_page(GTK_NOTEBOOK(item->ptr), PARAM->Target.ToInt());
                            if (page)
                                gtk_notebook_set_tab_label_text(GTK_NOTEBOOK(item->ptr), page, PARAM->Value.c_str());
                            break;
                        }
                    case CLASS_PROGRESSBAR:
                        gtk_progress_bar_pulse(GTK_PROGRESS_BAR(item->ptr));
                        break;
                    case CLASS_EDIT:
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                        gtk_entry_progress_pulse(GTK_ENTRY(item->ptr));
#endif
                        break;
                    case CLASS_MENU:
                        gtk_menu_popup(GTK_MENU(item->ptr), 0, 0, 0, 0, 3, 0);
                        break;
                    case CLASS_TREEVIEW:
                        {
                            char param=(char)PARAM->Value.ToInt();
                            char editable=param & 0x80;
                            param &= 0x7F;

                            switch (param) {
                                    case 0:
                                    case 1:
                                        // invisible
                                        // visible
                                        ((DeturnatedTreeView *)item->ptr)->add_column(PARAM->Target.c_str(),param,editable);
                                        if (item->event_handler)
                                            ((ClientEventHandler *)item->event_handler)->refresh_events(item->ptr);
                                        break;

                                        // progressbar
                                    case 2:
                                    case 3:
                                    case 4:
                                        ((DeturnatedTreeView *)item->ptr)->add_column_number(PARAM->Target.c_str(),0,param,editable);
                                        break;
                                    case 5:
                                        ((DeturnatedTreeView *)item->ptr)->add_column_image(PARAM->Target.c_str());
                                        break;
                                    case 6:
                                        ((DeturnatedTreeView *)item->ptr)->add_column_combo(PARAM->Target.c_str(),editable);
                                        break;
                            }
                        }
                        break;
                    case CLASS_COMBOBOX:
                        ((DeturnatedComboBox *)item->ptr)->add_columns(PARAM->Value.ToInt(),PARAM->Target.ToInt());
                        break;
                    case CLASS_COMBOBOXTEXT:
                        ((DeturnatedComboBox *)item->ptr)->add_columns(PARAM->Value.ToInt(),PARAM->Target.ToInt());
                        break;
                    case CLASS_ICONVIEW:
                        ((DeturnatedIconView *)item->ptr)->add_columns(PARAM->Value.ToInt(),PARAM->Target.ToInt());
                        break;
                    case CLASS_CALENDAR:
                        if (PARAM->Value.ToInt())
                            gtk_calendar_mark_day(GTK_CALENDAR(item->ptr), PARAM->Target.ToInt());
                        else
                            gtk_calendar_unmark_day(GTK_CALENDAR(item->ptr), PARAM->Target.ToInt());
                        break;
                    case CLASS_FIXED:
                        {
                            unsigned int val=PARAM->Value.ToInt();
                            unsigned int x=val/0xFFFF;
                            unsigned int y=val%0xFFFF;
                            GTKControl *item2=GetControlID(PARAM->Target.ToInt());
                            if (!item2)
                                return 0;
                            gtk_fixed_move(GTK_FIXED(item->ptr), SAFE_WIDGET(item2), x, y);
                            //((Gtk::Fixed *)item->ptr)->move(*(Gtk::Widget *)item2->ptr,x,y);
                        }
                        break;
                    case CLASS_TEXTVIEW:
                        {
                            GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                            GtkTextIter range_end;  
                            gtk_text_buffer_get_end_iter(refTextBuffer, &range_end);

                            GTKControl *item2=GetControlID(PARAM->Target.ToInt());
                            if ((!item2) || (item2->type!=CLASS_TEXTTAG))
                                return 0;

                            gtk_text_buffer_insert_with_tags(refTextBuffer, &range_end, PARAM->Value.c_str(), PARAM->Value.Length(),GTK_TEXT_TAG(item2->ptr),NULL);
                        }
                        break;
                    case CLASS_FORM:
                        {
                            GdkWindow *win=gtk_widget_get_window(GTK_WIDGET(item->ptr));
                            if (win)
                                gdk_window_raise(win);
                        }
                        break;
                    case CLASS_IMAGE:
                        {
                            GdkPixbuf *pbuf=ForcePixbuf(item->ptr);//((Gtk::Image*)item->ptr)->get_pixbuf();
                            if (pbuf) {
                                unsigned int val=PARAM->Value.ToInt();
                                unsigned int x=val/0xFFFF;
                                unsigned int y=val%0xFFFF;
                                gtk_image_set_from_pixbuf(GTK_IMAGE(item->ptr), gdk_pixbuf_scale_simple(pbuf,x,y,(GdkInterpType)PARAM->Target.ToInt()));
                            }
                        }
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter*)item->ptr)->setup_page(PARAM->Value.ToInt());
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE2:
            {
                switch (item->type) {
                    // set page caption by control
                    case CLASS_NOTEBOOK:
                        {
                            GTKControl *item2=GetControlID(PARAM->Target.ToInt());
                            GtkWidget *page=0;
                            if (item2)
                                page=GTK_WIDGET(item2->ptr);
                            if (page)
                                gtk_notebook_set_tab_label_text(GTK_NOTEBOOK(item->ptr), page,PARAM->Value.c_str());
                            break;
                        }
                    case CLASS_TREEVIEW:
                        switch (PARAM->Target.ToInt()) {
                            case 0:
                                ((DeturnatedTreeView *)item->ptr)->add_item(&PARAM->Value);
                                break;
                            case 1:
                                ((DeturnatedTreeView *)item->ptr)->clear();
                                break;
                            case 2:
                                ((DeturnatedTreeView *)item->ptr)->delete_item(&PARAM->Value);
                                break;
                            case 3:
                                ((DeturnatedTreeView *)item->ptr)->clear_columns();
                                break;
                            case 4:
                                ((DeturnatedTreeView *)item->ptr)->remove_column_by_index(PARAM->Value.ToInt());
                                break;
                        }
                        break;
                    case CLASS_COMBOBOX:
                        switch (PARAM->Target.ToInt()) {
                            case 0:
                                ((DeturnatedComboBox *)item->ptr)->add_item(PARAM->Value.ToInt());
                                break;
                            case 1:
                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(1);

                                ((DeturnatedComboBox *)item->ptr)->clear_items();

                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(0);
                                break;
                            case 2:
                                ((DeturnatedComboBox *)item->ptr)->delete_item(PARAM->Value.ToInt());
                                break;
                            case 3:
                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(1);

                                ((DeturnatedComboBox *)item->ptr)->clear_all();

                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(0);
                                break;
                        }
                        break;
                    case CLASS_COMBOBOXTEXT:
                        switch (PARAM->Target.ToInt()) {
                            case 0:
                                ((DeturnatedComboBox *)item->ptr)->add_item(PARAM->Value.ToInt());
                                break;
                            case 1:
                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(1);

                                ((DeturnatedComboBox *)item->ptr)->clear_items();

                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(0);
                                break;
                            case 2:
                                ((DeturnatedComboBox *)item->ptr)->delete_item(PARAM->Value.ToInt());
                                break;
                            case 3:
                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(1);

                                ((DeturnatedComboBox *)item->ptr)->clear_all();

                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(0);
                                break;
                        }
                        break;
                    case CLASS_ICONVIEW:
                        switch (PARAM->Target.ToInt()) {
                            case 0:
                                ((DeturnatedIconView *)item->ptr)->add_item(PARAM->Value.ToInt());
                                break;
                            case 1:
                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(1);

                                ((DeturnatedIconView *)item->ptr)->clear_items();

                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(0);
                                break;
                            case 2:
                                ((DeturnatedIconView *)item->ptr)->delete_item(PARAM->Value.ToInt());
                                break;
                            case 3:
                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(1);

                                ((DeturnatedIconView *)item->ptr)->clear_all();

                                if (item->event_handler)
                                    ((ClientEventHandler *)item->event_handler)->ConfirmQuit(0);
                                break;
                        }
                        break;
                    case CLASS_CALENDAR:
                        gtk_calendar_clear_marks(GTK_CALENDAR(item->ptr));
                        break;
                    case CLASS_TEXTVIEW:
                        {
                            GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                            GtkTextIter iter;
                            gtk_text_buffer_get_end_iter(refTextBuffer, &iter);

                            int ctrlid=PARAM->Target.ToInt();
                            if (ctrlid>-1) {
                                GTKControl *item2=GetControlID(PARAM->Target.ToInt());
                                if ((!item2) || (item2->type!=CLASS_TEXTTAG))
                                    return 0;

                                gtk_text_buffer_insert_with_tags(refTextBuffer, &iter, PARAM->Value.c_str(), PARAM->Value.Length(), GTK_TEXT_TAG(item2->ptr),NULL);
                            } else {
                                gtk_text_buffer_insert(refTextBuffer, &iter, PARAM->Value.c_str(), PARAM->Value.Length());
                            }
                        }
                        break;
                    case CLASS_IMAGE:
                        {
                            GdkPixbuf *pbuf=ForcePixbuf(item->ptr);//((Gtk::Image*)item->ptr)->get_pixbuf();
                            if (pbuf) {
                                int val=PARAM->Value.ToInt();
                                if (PARAM->Target.ToInt())
                                    gtk_image_set_from_pixbuf(GTK_IMAGE(item->ptr), gdk_pixbuf_rotate_simple(pbuf, (GdkPixbufRotation)val));
                                    //((Gtk::Image*)item->ptr)->property_pixbuf()=pbuf->rotate_simple((Gdk::PixbufRotation)val);
                                else
                                    gtk_image_set_from_pixbuf(GTK_IMAGE(item->ptr), gdk_pixbuf_flip(pbuf, val));
                            }
                        }
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter*)item->ptr)->Write(PARAM->Value.c_str());
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE3:
            {
                switch (item->type) {
                    // set page caption by index
                    case CLASS_NOTEBOOK:
                        {
                            GtkWidget *page=gtk_notebook_get_nth_page(GTK_NOTEBOOK(item->ptr), PARAM->Target.ToInt());
                            GTKControl *ctrl=GetControlID(PARAM->Value.ToInt());
                            if ((page) && (ctrl) && (ctrl->ptr))
                                gtk_notebook_set_tab_label(GTK_NOTEBOOK(item->ptr),page,SAFE_WIDGET(ctrl));
                            break;
                        }
                    case CLASS_TREEVIEW:
                        ((DeturnatedTreeView *)item->ptr)->post_string(PARAM->Value);
                        break;
                    case CLASS_COMBOBOX:
                        ((DeturnatedComboBox *)item->ptr)->post_string(PARAM->Value);
                        break;
                    case CLASS_COMBOBOXTEXT:
                        ((DeturnatedComboBox *)item->ptr)->post_string(PARAM->Value);
                        break;
                    case CLASS_ICONVIEW:
                        ((DeturnatedIconView *)item->ptr)->post_string(PARAM->Value);
                        break;
                    case CLASS_TEXTVIEW:
                        {
                            GtkTextBuffer *refTextBuffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(item->ptr));
                            int target_val=PARAM->Target.ToInt();
                            GtkTextIter range_end;
                            if (target_val>=0) {
                                gtk_text_buffer_get_iter_at_offset(refTextBuffer, &range_end, target_val);
                            } else
                                gtk_text_buffer_get_end_iter(refTextBuffer, &range_end);

                            GTKControl *item2=GetControlID(PARAM->Value.ToInt());
                            if (item2) {
                                GtkTextChildAnchor *refAnchor = gtk_text_buffer_create_child_anchor(refTextBuffer, &range_end);
                                if ((item2->type==CLASS_IMAGE) && (target_val==-2)) {
                                    GdkImage *img=0;
                                    GdkBitmap *mask=0;
                                    GtkImageType itype=gtk_image_get_storage_type(GTK_IMAGE(SAFE_WIDGET(item2)));
                                    if ((itype==GTK_IMAGE_IMAGE) || (itype==GTK_IMAGE_EMPTY))
                                        gtk_image_get_image(GTK_IMAGE(SAFE_WIDGET(item2)), &img, &mask);

                                    GtkWidget *my_img=gtk_image_new();
                                    if (img)
                                        gtk_image_set_from_image(GTK_IMAGE(my_img), img, mask);
                                    else
                                        gtk_image_set_from_animation(GTK_IMAGE(my_img), gtk_image_get_animation(GTK_IMAGE(SAFE_WIDGET(item2))));
                                    //my_img->show();
                                    gtk_widget_show(my_img);

                                    //g_object_unref(my_img);

                                    gtk_text_view_add_child_at_anchor(GTK_TEXT_VIEW(item->ptr), my_img, refAnchor);
                                } else {
                                    gtk_text_view_add_child_at_anchor(GTK_TEXT_VIEW(item->ptr), SAFE_WIDGET(item2), refAnchor);
                                    //((Gtk::TextView *)item->ptr)->add_child_at_anchor(*(Gtk::Widget*)item2->ptr, refAnchor);
                                }
                                //g_object_unref(refAnchor);
                            }
                            //g_object_unref(refTextBuffer);
                        }
                        break;
                    case CLASS_PRINTER:
                        ((ClientPrinter*)item->ptr)->Print((GtkPrintOperationAction)PARAM->Target.ToInt(), PARAM->Value.c_str());
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE4:
            {
                switch (item->type) {
                    // set page caption by index
                    case CLASS_NOTEBOOK:
                        {
                            GTKControl *item2=GetControlID(PARAM->Target.ToInt());
                            GtkWidget *page=0;
                            if (item2)
                                page=GTK_WIDGET(item2->ptr);

                            GTKControl *ctrl=GetControlID(PARAM->Value.ToInt());
                            if ((page) && (ctrl) && (ctrl->ptr))
                                gtk_notebook_set_tab_label(GTK_NOTEBOOK(item->ptr),page,SAFE_WIDGET(ctrl));
                            break;
                        }
                    case CLASS_TREEVIEW:
                        ((DeturnatedTreeView *)item->ptr)->add_child_item(&PARAM->Target,&PARAM->Value);
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE5:
            {
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        switch (PARAM->Target.ToInt()) {
                            case 0:
                                gtk_tree_view_expand_all(MY_TREE_VIEW(item->ptr));
                                break;
                            case 1:
                                gtk_tree_view_collapse_all(MY_TREE_VIEW(item->ptr));
                                break;
                            case 2:
                                {
                                    GtkTreePath *path=gtk_tree_path_new_from_string(PARAM->Value.c_str());
                                    gtk_tree_view_expand_row(MY_TREE_VIEW(item->ptr),path,false);
                                    gtk_tree_path_free(path);
                                }
                                break;
                            case 3:
                                {
                                    GtkTreePath *path=gtk_tree_path_new_from_string(PARAM->Value.c_str());
                                    gtk_tree_view_collapse_row(MY_TREE_VIEW(item->ptr),path);
                                    gtk_tree_path_free(path);
                                }
                                break;
                            case 4:
                                {
                                    GtkTreePath *path=gtk_tree_path_new_from_string(PARAM->Value.c_str());
                                    gtk_tree_view_expand_to_path(MY_TREE_VIEW(item->ptr),path);
                                    gtk_tree_path_free(path);
                                }
                                break;
                        }
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE6:
            {
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        ((DeturnatedTreeView *)item->ptr)->update_item(&PARAM->Value);
                        break;
                    case CLASS_COMBOBOX:
                        ((DeturnatedComboBox *)item->ptr)->update_item(&PARAM->Value);
                        break;
                    case CLASS_COMBOBOXTEXT:
                        ((DeturnatedComboBox *)item->ptr)->update_item(&PARAM->Value);
                        break;
                    case CLASS_ICONVIEW:
                        ((DeturnatedIconView *)item->ptr)->update_item(&PARAM->Value);
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE7:
            {
                switch (item->type) {
                    case CLASS_TREEVIEW:
						{
							int index=POST_STRING.ToInt();
							if (index<((DeturnatedTreeView *)item->ptr)->columns_count) {
                                int type_index=((DeturnatedTreeView *)(item->ptr))->adjust_column2(index);
							    int type=((DeturnatedTreeView *)item->ptr)->columns[type_index].type;
							    SET_COLUMN_PROPERTY(gtk_tree_view_get_column(MY_TREE_VIEW(item->ptr), index),type,PARAM->Target.ToInt(),&PARAM->Value,index);
							}
						}
                        break;
                    case CLASS_COMBOBOXTEXT:
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
                        gtk_entry_progress_pulse(GTK_ENTRY(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle))));
#endif
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE8:
            {
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        {
                            if (PARAM->Value.ToInt()!=-1) {
                                GtkTreePath *path=gtk_tree_path_new_from_string(PARAM->Value.c_str());
                                GdkBitmap *bitmap_r=NULL;

                                gtk_drag_source_set_icon(GTK_WIDGET(MY_TREE_VIEW(item->ptr)),
                                            gdk_colormap_get_system(), 
                                            gtk_tree_view_create_row_drag_icon(MY_TREE_VIEW(item->ptr),path),
                                            bitmap_r);
                                gtk_tree_path_free(path);
                            } else {
                                GtkTreePath *path=NULL;
                                GtkTreeViewColumn *focus_column;
                                gtk_tree_view_get_cursor(MY_TREE_VIEW(item->ptr),&path,&focus_column);
                                GdkBitmap *bitmap_r=NULL;
                                gtk_drag_source_set_icon(GTK_WIDGET(MY_TREE_VIEW(item->ptr)),
                                            gdk_colormap_get_system(), 
                                            gtk_tree_view_create_row_drag_icon(MY_TREE_VIEW(item->ptr),path),
                                            bitmap_r);
                            }
                        }
                        break;
                    case CLASS_ICONVIEW:
                        {
                            if (PARAM->Value.ToInt()!=-1) {
                                GtkTreePath *path=gtk_tree_path_new_from_string(PARAM->Value.c_str());
                                GdkBitmap *bitmap_r=NULL;
                                gtk_drag_source_set_icon(GTK_WIDGET(MY_ICON_VIEW(item->ptr)),
                                            gdk_colormap_get_system(), 
                                            gtk_icon_view_create_drag_icon(MY_ICON_VIEW(item->ptr),path),
                                            bitmap_r);
                                gtk_tree_path_free(path);
                            } else {
                                GtkTreePath *path=NULL;
                                GtkCellRenderer *cell;
                                gtk_icon_view_get_cursor(MY_ICON_VIEW(item->ptr),&path,&cell);
                                GdkBitmap *bitmap_r=NULL;
                                gtk_drag_source_set_icon(GTK_WIDGET(MY_ICON_VIEW(item->ptr)),
                                            gdk_colormap_get_system(), 
                                            gtk_icon_view_create_drag_icon(MY_ICON_VIEW(item->ptr),path),
                                            bitmap_r);
                            }
                        }
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE9:
            {
                switch (item->type) {
                    case CLASS_TREEVIEW:
                        ((DeturnatedTreeView *)item->ptr)->SetColors(PARAM->Target.ToInt(),PARAM->Value.ToInt());
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE10:
            {
                switch (item->type) {
                    case CLASS_TREEVIEW:
						{
							int index=POST_STRING.ToInt();
							if (index<((DeturnatedTreeView *)item->ptr)->columns_count) {
								((DeturnatedTreeView *)item->ptr)->add_custom(index,PARAM->Value);
							}
						}
                        break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_CUSTOM_MESSAGE11:
            {
                    switch (item->type) {
                        case CLASS_TREEVIEW:
                            {
                                GtkTreePath *path=gtk_tree_path_new_from_string(PARAM->Value.c_str());
                                GtkTreeViewColumn *focus_column=0;
                                focus_column=gtk_tree_view_get_column(MY_TREE_VIEW(item->ptr), PARAM->Value.ToInt());
                                if (focus_column)
                                    gtk_tree_view_set_cursor(MY_TREE_VIEW(item->ptr), path, focus_column, FALSE);
                                gtk_tree_path_free(path);
                            }
                            break;
                    default:
                        CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
                        break;
                }
            }
            break;
        case MSG_REPAINT:
            REPAINT((SAFE_WIDGET(item)));
            break;
        default:
            CustomMessage(item, PARAM->ID, PARAM->Target, PARAM->Value);
            break;
    }
    //REPAINT(mainform)
    //REPAINT(((Gtk::Widget *)item->ptr))
    return 0;
}


// returns 1(true) if the cration was successfuly
int CreateCustomControl(Parameters *PARAM) {
    int cls_id=PARAM->Target.ToInt();
    INVOKER Invoke=GetRequiredInvoker(cls_id);
    if (!Invoke)
        return 0;

    void *box               =   0;
    int  pack_type          =   0;
    int  ct_id              =   PARAM->Sender.ToInt();
    GTKControl *parent      =   GetControlID(ct_id);    
    int result              =   Invoke(parent ? parent->ptr : NULL,INVOKE_CREATE,cls_id,&box,&pack_type);

    if (result==E_ACCEPTED) {
        CHECK_OWNER(GTK_WIDGET(box), pack_type)
    } else
    if (result!=E_ACCEPTED_NOADD)
        return 0;

    // add the control to the control list
    GTKControl *NEW=new GTKControl(ct_id);
    NEW->ID  = PARAM->Value.ToInt();
    NEW->type= cls_id;
    NEW->ptr = box;
    NEW->tip = 0;
    NEW->event_handler=0;
    NEW->extra_ptr=0;
    ControlList.Add(NEW,DATA_CONTROL);

    return 1;
}


AnsiString run_target;
AnsiString run_value;
int wait_thread=0;
int _debug=false;

THREAD_TYPE2 ThreadSHELL(LPVOID PARAM) {
#ifdef _WIN32
    AnsiString params=srv_host;
    params+=(char *)":";
    params+=AnsiString(CConceptClient::PORT);
    params+=(char *)" \"";
    params+=run_target;
    params+=(char *)"\"";
    if (run_value.ToInt()!=0) {
        if (CConceptClient::is_http) {
            params+=" http ";
        } else
        if (_debug)
            params+=" debug ";
        else
            params+=" pipe ";
        params+=run_value;
    }

    wait_thread=0;
    ShellExecute(   0,
                    "open",
                    app_path.c_str(),
                    params.c_str(),
                    0,
                    SW_SHOW);

#else
    AnsiString path_param;
    path_param+=app_path;
    path_param+=" ";
    path_param+=srv_host;
    path_param+=(char *)":";
    path_param+=AnsiString(CConceptClient::PORT);
    path_param+=" \"";
    path_param+=run_target;
    path_param+="\"";

    if (run_value.ToInt()!=0) {
        if (CConceptClient::is_http) {
            path_param+=" http pipe ";
        } else
        if (_debug)
            path_param+=" debug ";
        else
            path_param+=" pipe ";
        //path_param+=" pipe ";
        path_param+=run_value;
    }

    wait_thread=0;
    system(path_param.c_str());
#endif
}

int NewApplication(char *target, char *value, bool debug=false) {
        run_target=target;
        run_value=value;
        wait_thread=1;
        _debug=debug;
#ifdef _WIN32
        DWORD TID;
        CreateThread(0,0,ThreadSHELL,target,0,&TID);
#else
        //pthread *threadID;
        pthread_t threadID;
        pthread_create(&threadID, NULL, ThreadSHELL,target);
#endif
        while (wait_thread)
            Sleep(10);
        /*AnsiString path_param="\"";
        path_param+=app_path;
        path_param+="\"";

        int result=spawnl(  _P_NOWAIT,
                            app_path.c_str(),
                            path_param.c_str(),
                            srv_host.c_str(),
                            target,
                            0
                        );
        return result;*/
        return 0;
}

#ifdef _WIN32
//---------------------------------------------------------------------------------
    int PROCESS_AX_MESSAGE(Parameters *PARAM) {
            GTKControl *ax_ctrl=GetControlID(PARAM->Sender.ToInt());
            if (!ax_ctrl) {
                std::cerr << "Invalid ActiveX Controld ID: " << PARAM->Sender.c_str() << "\n";
                return -1;
            }
            if (ax_ctrl->type!=CLASS_ACTIVEX) {
                std::cerr << "Control is not an ActiveX object: " << PARAM->Sender.c_str() << "\n";
                return -2;
            }
            CAXControl *CTRL=(CAXControl *)ax_ctrl->extra_ptr;
            if (!CTRL) {
                std::cerr << "Invalid ActiveX Handle\n";
                return -3;
            }

            //Glib::RefPtr<Gdk::Window> gwin=((Gtk::DrawingArea *)ax_ctrl->ptr)->get_window();
            //HWND wnd=(HWND)GDK_WINDOW_HWND(->gobj());
            //std::cerr << wnd;

            switch (PARAM->ID) {
                case MSG_CREATE_ACTIVEX:
                    CTRL->InitControl(PARAM->Target.c_str(),PARAM->Value.c_str());
                    break;
                case MSG_AX_SET_PROPERTY:
                    CTRL->SetAXProperty(PARAM->Target/*,PARAM->Value*/);
                    break;
                case MSG_AX_ADD_PARAMETER:
                    CTRL->AddParameter(PARAM->Value);
                    break;
                case MSG_AX_CALL_METHOD:
                    CTRL->ExecuteMethod(PARAM->Target);
                    break;
                case MSG_AX_ADD_FILEPARAMETER:
                    {
#ifdef _WIN32
                            //AnsiString path=GetDirectory();
							//path+=COOKIES;
                            AnsiString path=tmpcookiesdir;
#else
							AnsiString path=COOKIES_PATH;
#endif
                            CTRL->AddParameter(path+PARAM->Value);
                    }
                    break;
                case MSG_AX_GET_PROPERTY:
                    CTRL->GetAXProperty(PARAM->Target/*,PARAM->Value*/);
                    break;
                case MSG_AX_GET_RESULT:
                    lpClient->SendMessage("%CLIENT",MSG_AX_GET_RESULT,"0",CTRL->GetLastResult(PARAM->Value.ToInt()));
                    break;
                case MSG_AX_ADD_EVENT:
                    CTRL->AddEventNotify(PARAM->Value.ToInt());
                    break;
                case MSG_AX_AKNOWLEDGE_EVENT:
                    CTRL->AknowledgeEvent(PARAM->Value.ToInt());
                    break;
                case MSG_AX_CLEAR_EVENTS_DATA:
                    CTRL->ClearEventsData();
                    break;
                case MSG_AX_GET_EVENT_PARAM:
                    lpClient->SendMessage("%CLIENT",MSG_AX_GET_EVENT_PARAM,"0",CTRL->GetEventParameter(PARAM->Value.ToInt()));
                    break;
            }
    }
//---------------------------------------------------------------------------------
    void ActiveX_CallBack(AnsiString SenderID, long wparam, long lparam) {
        AnsiString event_data=AnsiString(wparam);
        event_data+=(char *)":";
        event_data+=AnsiString(lparam);
        lpClient->SendMessage(SenderID,
                                MSG_EVENT_FIRED,
                                AnsiString((long)EVENT_ACTIVEX_EVENT),
                                event_data
        );
    }
//---------------------------------------------------------------------------------
#endif // _WIN32

/* Backing pixmap for drawing area */
static GdkPixmap *pixmap = NULL;

/* Create a new backing pixmap of the appropriate size */
static gint
configure_event (GtkWidget *widget, GdkEventConfigure *event)
{
  if (pixmap)
    gdk_pixmap_unref(pixmap);

  pixmap = gdk_pixmap_new(/*widget->window*/NULL,
                          widget->allocation.width,
                          widget->allocation.height,
                          /*-1*/24);
  gdk_draw_rectangle (pixmap,
                      widget->style->white_gc,
                      TRUE,
                      0, 0,
                      widget->allocation.width,
                      widget->allocation.height);

  return TRUE;
}

/* Redraw the screen from the backing pixmap */
static gint
expose_event (GtkWidget *widget, GdkEventExpose *event)
{
  gdk_draw_pixmap(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                  pixmap,
                  event->area.x, event->area.y,
                  event->area.x, event->area.y,
                  event->area.width, event->area.height);

  return FALSE;
}


void PRIMITIVE_DRAW(Parameters *PARAM) {
    GTKControl *ctrl=GetControlID(PARAM->Sender.ToInt());
    GdkGC *gc=0;
    GtkWidget *sel_widget=0;
    //Gtk::Widget *gctrl=0;

    bool is_printer=(ctrl->type==CLASS_PRINTER);

    if (!ctrl) {
        std::cerr << "PRIMITIVE_DRAW: Invalid Controld ID: " << PARAM->Sender.c_str() << "\n";
        return;
    }

    if (!is_printer) {
        if (ctrl->type==CLASS_ACTIVEX) {
            std::cerr << "PRIMITIVE_DRAW: Control is not drawable (is an ActiveX Control !), Control ID: " << PARAM->Sender.c_str() << ", type: " << ctrl->type << "\n";
            return;
        }

        sel_widget=SAFE_WIDGET(ctrl);
        if (!GTK_WIDGET_DRAWABLE(sel_widget)) {
            std::cerr << "PRIMITIVE_DRAW: Control is not drawable, Control ID: " << PARAM->Sender.c_str() << ", type: " << ctrl->type << "\n";
            return;
        }

        GdkWindow *gdk_wnd=gtk_widget_get_window(sel_widget);
        if (!gdk_wnd) {
            std::cerr << "PRIMITIVE_DRAW: No window to draw on, Control ID: " << PARAM->Sender.c_str() << ", type: " << ctrl->type << "\n";
            return;
        }

        /*GdkGC **/gc=/*sel_widget->style->fg_gc[GTK_WIDGET_STATE(sel_widget)];*/sel_widget->style->white_gc;

        if (ctrl->extra_ptr) {
            pixmap=(GdkPixmap *)ctrl->extra_ptr;

            int width;
            int height;
            gdk_drawable_get_size(pixmap,&width,&height);

            if ((sel_widget->allocation.width!=width) || (sel_widget->allocation.height!=height)) {

                ctrl->extra_ptr =   gdk_pixmap_new(/*gdk_wnd*/NULL,
                                        sel_widget->allocation.width,
                                        sel_widget->allocation.height,
                                    /*-1*/24);

                gdk_draw_pixmap((GdkPixmap *)ctrl->extra_ptr,
                                sel_widget->style->fg_gc[GTK_WIDGET_STATE (sel_widget)],
                                pixmap,
                                0, 0,
                                0, 0,
                                width, height);

                gdk_pixmap_unref(pixmap);

                pixmap=(GdkPixmap *)ctrl->extra_ptr;
            }

        } else {
                //GdkGC *gc = gdk_gc_new(gdk_wnd);//sel_widget->style->fg_gc[GTK_WIDGET_STATE(sel_widget)];//*/sel_widget->style->black_gc;
            //gc = gdk_gc_new(gdk_wnd);
            pixmap = gdk_pixmap_new(/*gdk_wnd*/NULL,
                            sel_widget->allocation.width,
                            sel_widget->allocation.height,
                            24);

            ctrl->extra_ptr=pixmap;

            gtk_signal_connect (GTK_OBJECT (sel_widget), "expose_event",
                                (GtkSignalFunc) expose_event, NULL);
            gtk_signal_connect (GTK_OBJECT(sel_widget),"configure_event",
                                (GtkSignalFunc) configure_event, NULL);

        }
    }

    switch (PARAM->ID) {
        case MSG_D_PRIMITIVE_LINE:
            {
                long xy1=PARAM->Target.ToInt();
                int x1=xy1/0xFFFF;
                int y1=xy1%0xFFFF;

                long xy2=PARAM->Value.ToInt();
                int x2=xy2/0xFFFF;
                int y2=xy2%0xFFFF;

                if (!is_printer)
                    gdk_draw_line(/*gdk_wnd*/pixmap, gc, x1,y1,x2,y2);
                else
                    ((ClientPrinter *)ctrl->ptr)->Draw(PARAM->ID, x1, y1, x2, y2);
            }
            break;
        case MSG_D_PRIMITIVE_ARC:
        case MSG_D_PRIMITIVE_FILL_ARC:
            {
                bool filled=(PARAM->ID==MSG_D_PRIMITIVE_FILL_ARC);

                long xy=PARAM->Target.ToInt();

                int x=xy/0xFFFF;
                int y=xy%0xFFFF;

                long wh=PARAM->Value.ToInt();
                int w=wh/0xFFFF;
                int h=wh%0xFFFF;

                int angle=POST_STRING.ToInt();
                int angle1=angle/0xFFFF;
                int angle2=angle%0xFFFF;

                if (!is_printer)
                    gdk_draw_arc(/*gdk_wnd*/pixmap, gc, filled,x,y,w,h,angle1,angle2);
                else
                    ((ClientPrinter *)ctrl->ptr)->Draw(PARAM->ID, x, y, w, h, angle1, angle2, filled);
            }
            break;
        case MSG_D_PRIMITIVE_RECT:
        case MSG_D_PRIMITIVE_FILL_RECT:
            {
                bool filled=(PARAM->ID==MSG_D_PRIMITIVE_FILL_RECT);

                long xy=PARAM->Target.ToInt();

                int x=xy/0xFFFF;
                int y=xy%0xFFFF;

                long wh=PARAM->Value.ToInt();
                int w=wh/0xFFFF;
                int h=wh%0xFFFF;

                if (!is_printer)
                    gdk_draw_rectangle(/*gdk_wnd*/pixmap, gc, filled,x,y,w,h);
                else
                    ((ClientPrinter *)ctrl->ptr)->Draw(PARAM->ID, x, y, w, h, 0, 0, filled);
            }
            break;
        case MSG_D_PRIMITIVE_POINT:
            if (!is_printer)
                gdk_draw_point(/*gdk_wnd*/pixmap, gc, PARAM->Target.ToInt(), PARAM->Value.ToInt());
            else
                ((ClientPrinter *)ctrl->ptr)->Draw(PARAM->ID, PARAM->Target.ToInt(), PARAM->Value.ToInt());
            break;
        case MSG_D_PRIMITIVE_COLOR:
            {
                int color=PARAM->Value.ToInt();
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                
                if (!is_printer) {
                    GdkColor pushed_color;
                    pushed_color.red=((unsigned short)red*0xFF);
                    pushed_color.green=((unsigned short)green*0xFF);
                    pushed_color.blue=((unsigned short)blue*0xFF);
                    //pushed_color.set_pixel((gulong)(red*65536 + green*256 + blue);

                    gdk_color_alloc(gtk_widget_get_colormap(sel_widget), &pushed_color);
                    gdk_gc_set_foreground(gc, &pushed_color);
                } else {
                    ((ClientPrinter *)ctrl->ptr)->Draw(PARAM->ID, red, green, blue);
                }
            }
            break;
    }
    if (!is_printer) {
        REPAINT(sel_widget);
    }
    //configure_event(sel_widget,0);
}

#ifdef _WIN32 
    #ifdef GTK218

        static void on_activex_realized (GtkWidget *widget, gpointer user_data) {
            gdk_window_ensure_native(gtk_widget_get_window(widget));
	        GDK_WINDOW_HWND (gtk_widget_get_window (GTK_WIDGET (widget)));
            gtk_widget_set_events(widget, GDK_ALL_EVENTS_MASK);
        }

        static gboolean on_activex_generic(GtkWidget *widget, gpointer userdata) {
            GTKControl *item=(GTKControl *)userdata;
            HWND wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(widget)->window);
            //gdk_window_flush(GTK_WIDGET(item->ptr)->window);
            SendMessage(wnd,WM_PAINT,NULL,NULL);
            return FALSE;
        }

        static gboolean on_activex_expose(GtkWidget *viewport, GdkEventExpose *event, gpointer userdata)
        {
            GTKControl *item=(GTKControl *)userdata;
            HWND wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(viewport)->window);
            //gdk_window_flush(GTK_WIDGET(item->ptr)->window);
            SendMessage(wnd,WM_PAINT,NULL,NULL);
            return FALSE;
        }

        static gboolean on_activex_resize(GtkWidget *viewport, GdkRectangle *allocation, gpointer userdata)
        {
            GTKControl *item=(GTKControl *)userdata;
            HWND wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(viewport)->window);
            //gdk_window_flush(GTK_WIDGET(item->ptr)->window);
            int x=allocation->x;
            int y=allocation->y;
            GtkWidget *parent=viewport->parent;
            if (parent) {
                GdkWindowType wt=gdk_window_get_window_type(parent->window);
                if (wt == GDK_WINDOW_CHILD) {
                    if (parent->allocation.x>0)
                        x+=parent->allocation.x;
                    if (parent->allocation.y>0)
                        y+=parent->allocation.y;
                    int border=gtk_container_get_border_width(GTK_CONTAINER(parent));
                    x+=border;
                    y+=border;
                }
                //parent=parent->parent;
            }
            EnsureHWNDVisible(wnd,x,y,allocation->width,allocation->height);
            SendMessage(wnd,WM_PAINT,NULL,NULL);
            if (item->extra_ptr) {
                HWND temp=((CAXControl *)item->extra_ptr)->Handle;
                EnsureHWNDVisible(temp,x,y,allocation->width,allocation->height);
                SendMessage(temp,WM_PAINT,NULL,NULL);
            }
            
            return FALSE;
        }
    #endif
#endif

int MESSAGE_CALLBACK(Parameters *PARAM) {
    //std::cout << "MSGID:" << PARAM->ID << " Sender:" << PARAM->Sender << " Target:" << PARAM->Target << " Value:" << PARAM->Value << "\n";
    switch (PARAM->ID) {
        case MSG_POST_OBJECT            :
            POST_OBJECT=GetControlID(PARAM->Sender.ToInt());
            break;
        case MSG_POST_STRING            :
            POST_STRING=PARAM->Value;
            break;
        case MSG_CREATE                 :
            {
                int ct_id=PARAM->Sender.ToInt();
                switch (PARAM->Target.ToInt()) {
                        case CLASS_FORM:
                                {
                                    GtkWidget *form=gtk_window_new(GTK_WINDOW_TOPLEVEL);
                                    gtk_window_set_title(GTK_WINDOW(form),"");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_FORM;
                                    NEW->ptr = form;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    if (!defacc)
                                        defacc=gtk_accel_group_new();

                                    gtk_window_add_accel_group(GTK_WINDOW(form), defacc);

                                    //--------//
                                    //CHECK_OWNER(form,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    GTKControl *owner=GetControlID(ct_id);
                                    if ((owner) && (owner->type==CLASS_FORM)) {
                                        gtk_window_set_transient_for(GTK_WINDOW(form), GTK_WINDOW(owner->ptr));
                                    }
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    if (!firstform)
                                        firstform=GTK_WINDOW(form);
                                    
                                    NEW->event_handler=new ClientEventHandler(NEW->ID,PARAM->Owner);
                                    g_signal_connect(
                                               G_OBJECT(form), 
                                               "delete-event", 
                                               G_CALLBACK(ClientEventHandler::on_delete_hook), 
                                               NEW->event_handler
                                    );
                                    break;
                                }
                        case CLASS_BUTTON:
                                {
                                    GtkWidget *button=gtk_button_new();
                                    gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_BUTTON;
                                    NEW->ptr = button;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(button,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_CHECKBUTTON:
                                {
                                    GtkWidget *button=gtk_check_button_new();
                                    gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_CHECKBUTTON;
                                    NEW->ptr = button;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(button,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_RADIOBUTTON:
                                {
                                    GtkWidget *button=gtk_radio_button_new(NULL);
                                    gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_RADIOBUTTON;
                                    NEW->ptr = button;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(button,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_EDIT:
                                {
                                    GtkWidget *ctrl=gtk_entry_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_EDIT;
                                    NEW->ptr = ctrl;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(ctrl,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HBOX:
                                {
                                    GtkWidget *box=gtk_hbox_new(FALSE, 0);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VBOX:
                                {
                                    GtkWidget *box=gtk_vbox_new(FALSE, 0);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_EVENTBOX:
                                {
                                    GtkWidget *box=gtk_event_box_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_EVENTBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VBUTTONBOX:
                                {
                                    GtkWidget *box=gtk_vbutton_box_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VBUTTONBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HBUTTONBOX:
                                {
                                    GtkWidget *box=gtk_hbutton_box_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HBUTTONBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HSEPARATOR:
                                {
                                    GtkWidget *box=gtk_hseparator_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HSEPARATOR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VSEPARATOR:
                                {
                                    GtkWidget *box=gtk_vseparator_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VSEPARATOR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_LABEL:
                                {
                                    GtkWidget *box=gtk_label_new("");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_LABEL;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_FRAME:
                                {
                                    GtkWidget *box=gtk_frame_new("");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    //box->set_label("");
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_FRAME;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_PROGRESSBAR:
                                {
                                    GtkWidget *box=gtk_progress_bar_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_PROGRESSBAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VPANED:
                                {
                                    GtkWidget *box=gtk_vpaned_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VPANED;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    NEW->extra_flags=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HPANED:
                                {
                                    GtkWidget *box=gtk_hpaned_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HPANED;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    NEW->extra_flags=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_SCROLLEDWINDOW:
                                {
                                    GtkWidget *box=gtk_scrolled_window_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)), GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_SCROLLEDWINDOW;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_IMAGE:
                                {
                                    GtkWidget *box=gtk_image_new_from_stock(GTK_STOCK_MISSING_IMAGE, GTK_ICON_SIZE_INVALID);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_IMAGE;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_ADJUSTMENT:
                                {
                                    GtkObject *box=gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,0.0);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_ADJUSTMENT;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VSCALE:
                                {
                                    GtkWidget *box=0;
                                    if ((POST_OBJECT) && (POST_OBJECT->type==CLASS_ADJUSTMENT))
                                            box=gtk_vscale_new(GTK_ADJUSTMENT(POST_OBJECT->ptr));
                                    else {
                                            box=gtk_vscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                                    }
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VSCALE;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HSCALE:
                                {
                                    GtkWidget *box=0;
                                    if ((POST_OBJECT) && (POST_OBJECT->type==CLASS_ADJUSTMENT))
                                            box=gtk_hscale_new(GTK_ADJUSTMENT(POST_OBJECT->ptr));
                                    else
                                            box=gtk_hscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HSCALE;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HSCROLLBAR:
                                {
                                    GtkWidget *box=0;
                                    if ((POST_OBJECT) && (POST_OBJECT->type==CLASS_ADJUSTMENT))
                                            box=gtk_hscrollbar_new(GTK_ADJUSTMENT(POST_OBJECT->ptr));
                                    else
                                            box=gtk_hscrollbar_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HSCROLLBAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VSCROLLBAR:
                                {
                                    GtkWidget *box=0;
                                    if ((POST_OBJECT) && (POST_OBJECT->type==CLASS_ADJUSTMENT))
                                            box=gtk_vscrollbar_new(GTK_ADJUSTMENT(POST_OBJECT->ptr));
                                    else
                                            box=gtk_vscrollbar_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VSCROLLBAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_SPINBUTTON:
                                {
                                    GtkWidget *box=0;
                                    if ((POST_OBJECT) && (POST_OBJECT->type==CLASS_ADJUSTMENT))
                                            box=gtk_spin_button_new(GTK_ADJUSTMENT(POST_OBJECT->ptr),0.0,0);
                                    else
                                            box=gtk_spin_button_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,0.0)),0.0,0);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_SPINBUTTON;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TEXTVIEW:
                                {
                                    GtkWidget *box=gtk_text_view_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TEXTVIEW;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_ALIGNMENT:
                                {
                                    GtkWidget *box=gtk_alignment_new(0.5,0.5,1.0,1.0);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_ALIGNMENT;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_NOTEBOOK:
                                {
                                    GtkWidget *box=gtk_notebook_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_NOTEBOOK;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_ASPECTFRAME:
                                {
                                    GtkWidget *box=gtk_aspect_frame_new("", 0.5, 0.5, 1.0, FALSE);
                                    //box->set_label("");
                                    gtk_frame_set_label(GTK_FRAME(box), "");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_ASPECTFRAME;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_MENUITEM:
                                {
                                    GtkWidget *box=gtk_menu_item_new_with_mnemonic(POST_STRING.c_str());
                                    POST_STRING="";
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_MENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_SEPARATORMENUITEM:
                                {
                                    GtkWidget *box=gtk_separator_menu_item_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_SEPARATORMENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_IMAGEMENUITEM:
                                {
                                    GtkWidget *box=gtk_image_menu_item_new_with_mnemonic(POST_STRING.c_str());
                                    POST_STRING="";
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_IMAGEMENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_STOCKMENUITEM:
                                {
                                    GtkWidget *box=0;
                                    /*const Gtk::BuiltinStockID *sid=GET_STOCK(&POST_STRING);
                                    if (sid) {
                                        box=new Gtk::ImageMenuItem(*sid);
                                    } else {
                                        Gtk::StockID sid2(POST_STRING.c_str());
                                        box=new Gtk::ImageMenuItem(sid2);
                                    }*/
                                    box=gtk_image_menu_item_new_from_stock(POST_STRING.c_str(), NULL);
                                    //gtk_image_menu_item_set_use_stock(GTK_IMAGE_MENU_ITEM(box), TRUE);

                                    POST_STRING="";
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_IMAGEMENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TEAROFFMENUITEM:
                                {
                                    GtkWidget *box=gtk_tearoff_menu_item_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TEAROFFMENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_CHECKMENUITEM:
                                {
                                    GtkWidget *box=gtk_check_menu_item_new_with_mnemonic(POST_STRING.c_str());
                                    POST_STRING="";
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_CHECKMENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_RADIOMENUITEM:
                                {
                                    // dirty !
                                    GtkWidget *box=gtk_radio_menu_item_new_with_mnemonic(NULL,POST_STRING.c_str());
                                    POST_STRING="";
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_RADIOMENUITEM;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    
                                    GTKControl *owner=GetControlID(ct_id);

                                    if ((owner) && (owner->type==CLASS_MENU)) {
                                        gtk_menu_append(GTK_MENU(owner->ptr), box);
                                    } else
                                    if ((owner) && (owner->type==CLASS_MENUBAR)) {
                                        gtk_menu_bar_append(GTK_MENU_BAR(owner->ptr), box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_MENU:
                                {
                                    GtkWidget *box=gtk_menu_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_MENU;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    if (!defacc)
                                        defacc=gtk_accel_group_new();

                                    gtk_menu_set_accel_group(GTK_MENU(box), defacc);

                                    GTKControl *owner1=GetControlID(ct_id);
                                    if (owner1) {
                                        if ((owner1->type==CLASS_MENUITEM) || (owner1->type==CLASS_IMAGEMENUITEM) || (owner1->type==CLASS_RADIOMENUITEM) || (owner1->type==CLASS_CHECKMENUITEM)) {
                                            gtk_menu_item_set_submenu(GTK_MENU_ITEM(owner1->ptr), box);
                                        }/* else {
                                            //--------//
                                            CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                            //--------//
                                        }*/
                                    }
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_MENUBAR:
                                {
                                    GtkWidget *box=gtk_menu_bar_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_MENUBAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_EXPANDER:
                                {
                                    GtkWidget *box=gtk_expander_new("");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    //box->set_label("");
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_EXPANDER;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_VIEWPORT:
                                {
                                    GtkWidget *box=gtk_viewport_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)), GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_VIEWPORT;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_HANDLEBOX:
                                {
                                    GtkWidget *box=gtk_handle_box_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HANDLEBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TOOLBAR:
                                {
                                    GtkWidget *box=gtk_toolbar_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TOOLBAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TOOLBUTTON:
                                {
                                    GtkToolItem *box=gtk_tool_button_new(NULL, "");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TOOLBUTTON;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    GTKControl *owner1=GetControlID(ct_id);
                                    if (owner1) {
                                        if (owner1->type==CLASS_TOOLBAR)
                                            gtk_toolbar_insert(GTK_TOOLBAR(owner1->ptr), box, -1);
                                    }
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TOOLSEPARATOR:
                                {
                                    GtkToolItem *box=gtk_separator_tool_item_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TOOLSEPARATOR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    GTKControl *owner1=GetControlID(ct_id);
                                    if ((owner1) && (owner1->type==CLASS_TOOLBAR))
                                        gtk_toolbar_insert(GTK_TOOLBAR(owner1->ptr), box, -1);

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_MENUTOOLBUTTON:
                                {
                                    GtkToolItem *box=gtk_menu_tool_button_new(NULL, "");
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_MENUTOOLBUTTON;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    GTKControl *owner1=GetControlID(ct_id);
                                    if ((owner1) && (owner1->type==CLASS_TOOLBAR))
                                        gtk_toolbar_insert(GTK_TOOLBAR(owner1->ptr), box, -1);

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TOGGLETOOLBUTTON:
                                {
                                    GtkToolItem *box=gtk_toggle_tool_button_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TOGGLETOOLBUTTON;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    GTKControl *owner1=GetControlID(ct_id);
                                    if ((owner1) && (owner1->type==CLASS_TOOLBAR))
                                        gtk_toolbar_insert(GTK_TOOLBAR(owner1->ptr), box, -1);

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_RADIOTOOLBUTTON:
                                {
                                    // dirty !
                                    //GSList *g=g_slist_alloc();
                                    GtkToolItem *box=gtk_radio_tool_button_new(NULL);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_RADIOTOOLBUTTON;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    GTKControl *owner1=GetControlID(ct_id);
                                    if ((owner1) && (owner1->type==CLASS_TOOLBAR))
                                        gtk_toolbar_insert(GTK_TOOLBAR(owner1->ptr), box, -1);

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TREEVIEW:
                                {
                                    DeturnatedTreeView *box=new DeturnatedTreeView();
                                    GtkEntry *ent=gtk_tree_view_get_search_entry(MY_TREE_VIEW(box));
                                    if (ent)
                                        gtk_entry_set_max_length(ent, 0);

                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TREEVIEW;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box->handle,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_COMBOBOX:
                                {
                                    DeturnatedComboBox *box=new DeturnatedComboBox();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_COMBOBOX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box->handle,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_COMBOBOXTEXT:
                                {
                                    DeturnatedComboBox *box=new DeturnatedComboBox(true);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_COMBOBOXTEXT;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box->handle,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_ICONVIEW:
                                {
                                    DeturnatedIconView *box=new DeturnatedIconView();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_ICONVIEW;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box->handle,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_STATUSBAR:
                                {
                                    GtkWidget *box=gtk_statusbar_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_STATUSBAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_FIXED:
                                {
                                    GtkWidget *box=gtk_fixed_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_FIXED;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_CALENDAR:
                                {
                                    GtkWidget *box=gtk_calendar_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_CALENDAR;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TEXTTAG:
                                {
                                    GTKControl *owner=GetControlID(ct_id);
                                    if ((!owner) || (owner->type!=CLASS_TEXTVIEW)) {
                                        std::cerr << "texttag owner must be a text view";
                                        break;
                                    }

                                    GtkTextTag *box=gtk_text_tag_new(NULL);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TEXTTAG;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    GtkTextBuffer *buf=gtk_text_view_get_buffer(GTK_TEXT_VIEW(owner->ptr));
                                    if (buf) {
                                        GtkTextTagTable *table=gtk_text_buffer_get_tag_table(buf);
                                        gtk_text_tag_table_add(table, box);
                                    }

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_TABLE:
                                {
                                    GtkWidget *box=gtk_table_new(1,1,FALSE);
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->extra_ptr=new int[8];
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TABLE;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_PROPERTIESBOX:
                                {
                                    PropertiesPanel *box=new PropertiesPanel();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_PROPERTIESBOX;
                                    NEW->ptr = box->handle;
                                    NEW->extra_ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(GTK_WIDGET(box->handle),MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                        case CLASS_MIRRORBIN:
                                {
#ifdef OFFSET_WINDOWS
                                    GtkWidget *box=GTK_WIDGET(gtk_mirror_bin_new());
#else
                                    GtkWidget *box=GTK_WIDGET(gtk_vbox_new(0, FALSE));
#endif
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_MIRRORBIN;
                                    NEW->ptr = box;
                                    NEW->extra_ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(GTK_WIDGET(box),MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
#ifdef _WIN32
                        case CLASS_ACTIVEX:
                                {
                                    //GtkWidget *socket=gtk_socket_new();
                                    GtkWidget *box=gtk_drawing_area_new();//gtk_fixed_new();//gtk_socket_new();//gtk_drawing_area_new();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_ACTIVEX;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_SHRINK)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);

                                    gtk_widget_realize (box);

                                    //GtkWidget* plug=gtk_plug_new(gtk_socket_get_id(GTK_SOCKET(box)));
                                    //gtk_widget_realize (plug);
                                    //gtk_widget_show(GTK_WIDGET(plug));
#ifdef GTK218
                                    if (!gdk_window_ensure_native(gtk_widget_get_window(box)))
                                        std::cerr << "Error ensuring native window for ActiveX control\n";

                                    /*if (!gdk_window_ensure_native(gtk_widget_get_window(plug)))
                                        std::cerr << "Error ensuring native window for ActiveX control\n";*/
#endif

                                    HWND wnd=(HWND)GDK_WINDOW_HWND(gtk_widget_get_window(box));//box!
                                    if (!wnd)
                                        std::cerr << "Error getting handle for window\n";
#ifdef GTK218
                                    g_signal_connect (box, "realize",  G_CALLBACK (on_activex_realized), NEW);

                                    g_signal_connect(
                                               G_OBJECT(box), 
                                               "size-allocate", 
                                               G_CALLBACK(on_activex_resize), 
                                               NEW
                                    );

                                    g_signal_connect(
                                               G_OBJECT(box), 
                                               "expose-event", 
                                               G_CALLBACK(on_activex_expose), 
                                               NEW
                                    );

                                    g_signal_connect(
                                               G_OBJECT(box), 
                                               "event", 
                                               G_CALLBACK(on_activex_expose), 
                                               NEW
                                    );
                                    gtk_widget_set_app_paintable(GTK_WIDGET(box),TRUE);
#endif
                                    CAXControl *form=new CAXControl(wnd, ActiveX_CallBack, PARAM->Value);
                                    NEW->extra_ptr=form;
                                    //gtk_socket_add_id(GTK_SOCKET(box), gtk_plug_get_id(plug));
                                    break;
                                }
#endif
                        case CLASS_PRINTER:
                                {
                                    GTKControl *owner=GetControlID(ct_id);
                                    if ((!owner) || (owner->type!=CLASS_FORM)) {
                                        std::cerr << "Printer owner must be a form !";
                                        break;
                                    }

                                    ClientPrinter *cp=new ClientPrinter(SAFE_WIDGET(owner));
                                    GTKControl *NEW=new GTKControl(ct_id);

                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_PRINTER;
                                    NEW->ptr = cp;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }
                                /*case CLASS_TRAYICON:
                                {
                                    Gtk::StatusIcon *icon=new Gtk::StatusIcon();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_TRAYICON;
                                    NEW->ptr = icon;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;

                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }*/
                        default:
                                if (!CreateCustomControl(PARAM))
                                    std::cerr << "Concept Client warning: Unable to create control with id " << PARAM->Target.c_str() << ". You need to install this control on your system in order to properly run this application.\n";
                        /*case CLASS_HTML:
                                {
                                    Gtk::HTML *box=Gtk::HTML::create();
                                    GTKControl *NEW=new GTKControl(ct_id);
                                    NEW->ID  = PARAM->Value.ToInt();
                                    NEW->type= CLASS_HTML;
                                    NEW->ptr = box;
                                    NEW->tip = 0;
                                    NEW->event_handler=0;
                                    //--------//
                                    CHECK_OWNER(box,MyPACK_EXPAND_WIDGET)
                                    //--------//
                                    ControlList.Add(NEW,DATA_CONTROL);
                                    break;
                                }*/
                }
            }
            break;
        case MSG_SET_PROPERTY:
            SetProperty(PARAM->Sender.ToInt(), PARAM->Target.ToInt(), &PARAM->Value, PARAM->Owner);
            break;
        case MSG_GET_PROPERTY:
            GetProperty(PARAM->Sender.ToInt(), PARAM->Target.ToInt(), PARAM->Owner);
            break;
        case MSG_SET_EVENT:
            SetEvent(PARAM->Sender.ToInt(), PARAM->Target.ToInt(), &PARAM->Value, PARAM->Owner);
            break;
        case MSG_CONFIRM_EVENT:
            ConfirmEvent(PARAM->Sender.ToInt(), PARAM->Target.ToInt(), &PARAM->Value, PARAM->Owner);
            break;
        case MSG_PUT_STREAM:
            SetStream(PARAM->Sender.ToInt(), &PARAM->Target, &PARAM->Value);
            break;
        case MSG_PUT_SECONDARY_STREAM:
            SetSecondaryStream(PARAM->Sender.ToInt(), &PARAM->Target, &PARAM->Value);
            break;
        case MSG_REMOTE_METHOD:
            CallRemoteMethod(PARAM->Sender.ToInt(), &PARAM->Target, &PARAM->Value);
            break;
        case MSG_CUSTOM_MESSAGE1:
        case MSG_CUSTOM_MESSAGE2:
        case MSG_CUSTOM_MESSAGE3:
        case MSG_CUSTOM_MESSAGE4:
        case MSG_CUSTOM_MESSAGE5:
        case MSG_CUSTOM_MESSAGE6:
        case MSG_CUSTOM_MESSAGE7:
        case MSG_CUSTOM_MESSAGE8:
        case MSG_CUSTOM_MESSAGE9:
        case MSG_CUSTOM_MESSAGE10:
        case MSG_CUSTOM_MESSAGE11:
        case MSG_CUSTOM_MESSAGE12:
        case MSG_CUSTOM_MESSAGE13:
        case MSG_CUSTOM_MESSAGE14:
        case MSG_CUSTOM_MESSAGE15:
        case MSG_CUSTOM_MESSAGE16:
        case MSG_REPAINT:
            MSG_CUSTOM_MESSAGE(PARAM);
            break;
		case MSG_GET_DNDFILE:
            GetDNDFile(PARAM);
			break;
        case MSG_MESSAGE_BOX:
            {
                GtkWidget *dialog=gtk_message_dialog_new(mainform, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "%s", PARAM->Value.c_str());
                gtk_window_set_title(GTK_WINDOW(dialog), PARAM->Target.c_str());
                if (mainform)
                    gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);

#ifdef _WIN32
                gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif

                WAIT=1;
                gtk_window_set_keep_above(GTK_WINDOW(dialog), TRUE);
                gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
                gtk_dialog_run(GTK_DIALOG(dialog));
                gtk_widget_destroy(GTK_WIDGET(dialog));
                WAIT=0;
                //delete dialog;
            }
            break;
        case MSG_MESSAGE_BOX_YESNO:
            {
                GtkWidget *dialog=gtk_message_dialog_new(mainform, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, "%s", PARAM->Value.c_str());
                gtk_window_set_title(GTK_WINDOW(dialog), PARAM->Target.c_str());
                if (mainform)
                    gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);

#ifdef _WIN32
                gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif
                WAIT=1;
                gtk_window_set_keep_above(GTK_WINDOW(dialog), TRUE);
                gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
                int response=gtk_dialog_run(GTK_DIALOG(dialog));
                gtk_widget_destroy(GTK_WIDGET(dialog));
                WAIT=0;
                PARAM->Owner->SendMessage("%CLIENT",MSG_MESSAGE_BOX_YESNO,"0",AnsiString((long)response));
                //delete dialog;
            }
            break;
        case MSG_MESSAGE_LOGIN:
            {
                // UNCOMMENT WHEN GTKmm IS DROPPED
                /*if (mainform)
                    login->set_transient_for(*mainform);*/
                login->reset(PARAM->Target.c_str(), PARAM->Value.c_str(), POST_STRING.c_str());
                WAIT=1;
                int response=login->run();
                login->hide();
                WAIT=0;
                PARAM->Owner->SendMessage("%CLIENT",MSG_MESSAGE_LOGIN,"0",AnsiString((long)response));
                PARAM->Owner->SendMessage("%CLIENT",MSG_MESSAGE_LOGIN,login->GetUsername(),login->GetPassword());
            }
            break;
        case MSG_MESSAGE_REQUESTINPUT:
            {
                // UNCOMMENT WHEN GTKmm IS DROPPED
                /*if (mainform)
                    inputdialog->set_transient_for(*mainform);*/
                inputdialog->reset(PARAM->Target.c_str(), POST_STRING.c_str(), PARAM->Value.ToInt());
                WAIT=1;
                int response=inputdialog->run();
                inputdialog->hide();
                WAIT=0;
                PARAM->Owner->SendMessage("%CLIENT",MSG_MESSAGE_REQUESTINPUT,inputdialog->GetText(),AnsiString((long)response));
            }
            break;
        case MSG_MESSAGE_BOX_GENERIC:
            {
                GtkWidget *dialog=0;
                int temp=POST_STRING.ToInt();
                GtkMessageType mtype=(GtkMessageType)(temp/0x100);
                int cc_buttons=temp%0x100;
                switch (cc_buttons) {
                    case CC_BUTTONS_YES_NO_CANCEL:
                        dialog=gtk_message_dialog_new_with_markup(mainform, GTK_DIALOG_MODAL, mtype, GTK_BUTTONS_NONE, "");
                        gtk_dialog_add_buttons(GTK_DIALOG(dialog), GTK_STOCK_YES, GTK_RESPONSE_YES, GTK_STOCK_NO, GTK_RESPONSE_NO, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, 0);
                        break;
                    case CC_BUTTONS_SAVE_DISCARD_CANCEL:
                        dialog=gtk_message_dialog_new_with_markup(mainform, GTK_DIALOG_MODAL, mtype, GTK_BUTTONS_NONE, "");
                        gtk_dialog_add_buttons(GTK_DIALOG(dialog), GTK_STOCK_SAVE, GTK_RESPONSE_YES, GTK_STOCK_DISCARD, GTK_RESPONSE_NO, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, 0);
                        break;
                    default:
                        {
                            GtkButtonsType mbuttons=(GtkButtonsType)(cc_buttons);
                            dialog=gtk_message_dialog_new_with_markup(mainform, GTK_DIALOG_MODAL, mtype, mbuttons, "");
                        }
                }
                gtk_message_dialog_set_markup(GTK_MESSAGE_DIALOG(dialog), PARAM->Value.c_str());

                gtk_window_set_title(GTK_WINDOW(dialog), PARAM->Target.c_str());
                if (mainform)
                    gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);

#ifdef _WIN32
                gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif
                WAIT=1;
                gtk_window_set_keep_above(GTK_WINDOW(dialog), TRUE);
                gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
                int response=gtk_dialog_run(GTK_DIALOG(dialog));
                gtk_widget_destroy(GTK_WIDGET(dialog));
                WAIT=0;
                PARAM->Owner->SendMessage("%CLIENT",MSG_MESSAGE_BOX_GENERIC,"0",AnsiString((long)response));
                //delete dialog;
            }
            break;
        case MSG_RAW_OUTPUT:
#ifdef PRINT_STATUS
		    std::cout.write(PARAM->Value.c_str(),PARAM->Value.Length());
            std::cout.flush();
#endif
            if (client_output)
                client_output(PARAM->Value.c_str());
            //std::cout << PARAM->Value.c_str();
            break;
        case MSG_CLIENT_QUERY:
            {
                if (PARAM->Target==(char *)"Version")
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"Concept Client v1.0 GTK","(c) 2005 RadGs Software. Thank you for using Concept.");
                else
                if (PARAM->Target==(char *)"System")
#ifdef _WIN32
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"windows",AnsiString((long)32));
#else
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"penguin",AnsiString((long)32));
#endif
                else
                if (PARAM->Target==(char *)"Ping")
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"Ping",PARAM->Value);
                else
                if (PARAM->Target==(char *)"Host")
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"Host",PARAM->Owner->Called_HOST);
                else
                if (PARAM->Target==(char *)"Language") {
                    if (PARAM->Value.Length()) {
                        PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"Language",setlocale(LC_ALL, PARAM->Value.c_str()));
                    } else
                        PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,"Language",setlocale(LC_ALL, 0));
                } else
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CLIENT_QUERY,PARAM->Target,"");
            }
            break;
        case MSG_APPLICATION_RUN:
            {
                GTKControl *NEW=GetControlID(PARAM->Target.ToInt());
                if (NEW) {
                    mainform=(GtkWindow *)NEW->ptr;
                    if (!NEW->event_handler)
                        NEW->event_handler=new ClientEventHandler(PARAM->Target.ToInt(),PARAM->Owner);
                    ClientEventHandler *HANDLER=(ClientEventHandler *)NEW->event_handler;
                    HANDLER->is_mainwindow=true;
                }
				semp(sem_lock_app);
                run_app=1;
				semv(sem_lock_app);
                update_status(true);
            }
            break;
        case MSG_NON_CRITICAL:
            PARAM->Owner->SetCritical(PARAM->Value.ToInt());
            break;
        case MSG_APPLICATION_QUIT:
            std::cerr << "Clean quit.\n";
            // run_app e tot 1, in caz ca nu s-a dat application_run !!!
			semp(sem_lock_app);
            run_app=-2;
			semv(sem_lock_app);
            update_status(false);

            if (mainform) {
                gtk_widget_hide(GTK_WIDGET(mainform));
            }
            update_status(false);
            return 1;
        case MSG_MESSAGING_SYSTEM:
            PARAM->Owner->EnableMessaging(PARAM->Value.ToInt());
            break;
        case MSG_RUN_APPLICATION:
            NewApplication(PARAM->Target, PARAM->Value);
            break;
        case MSG_DEBUG_APPLICATION:
            NewApplication(PARAM->Target, PARAM->Value,true);
            break;
        case MSG_RAISE_ERROR:
            {
                if (!already_aborted) {
                    GtkWidget *dialog=gtk_message_dialog_new(mainform, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,GTK_BUTTONS_YES_NO, "%s", "Run-time ERROR. Continue ?");

                    gtk_window_set_title(GTK_WINDOW(dialog), PARAM->Target.c_str());
                    if (mainform)
                        gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);

                    gtk_window_set_keep_above(GTK_WINDOW(dialog), TRUE);
                    gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);

                    gtk_message_dialog_format_secondary_text(GTK_MESSAGE_DIALOG(dialog), "%s", PARAM->Value.c_str());
#ifdef _WIN32
                    gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif

                    // daca nu s-a dat ok, nu vreau sau continui
                    if (gtk_dialog_run(GTK_DIALOG(dialog))!=GTK_RESPONSE_YES) {
                        //run_app=-1;
						semp(sem_lock_app);
						run_app=-1;
						semv(sem_lock_app);
                        already_aborted=1;
                        gtk_widget_destroy(GTK_WIDGET(dialog));
                        if (mainform)
                            gtk_widget_hide(GTK_WIDGET(mainform));
                        update_status(false);
                        return 1;
                    }
                    gtk_widget_destroy(GTK_WIDGET(dialog));
                }
            }
            break;
        case MSG_SEND_COOKIE:
            PARAM->Value.SaveFile(SafeFile(PARAM->Target));
            break;
		case MSG_SET_COOKIE:
			{
				AnsiString cookie_name=SafeFile(PARAM->Target);
				cookie_name+=(char *)"@";
				cookie_name+=lpClient->Called_HOST;
				cookie_name+=".txt";
				if (PARAM->Value.Length())
					PARAM->Value.SaveFile(cookie_name.c_str());
				else
					unlink(cookie_name.c_str());
			}
            break;
		case MSG_GET_COOKIE:
			{
				AnsiString cookie_name=PARAM->Target;
				cookie_name+=(char *)"@";
				cookie_name+=lpClient->Called_HOST;
				cookie_name+=".txt";
				PARAM->Value.LoadFile(cookie_name);
                PARAM->Owner->SendBigMessage("%CLIENT",MSG_GET_COOKIE,PARAM->Target,&PARAM->Value);
			}
            break;
        case MSG_SEND_ZCOOKIE:
            PARAM->Value.SaveFile(SafeFile(PARAM->Target));
            UnZip(PARAM->Target.c_str());
			unlink(PARAM->Target.c_str());
            break;
        case MSG_OS_COMMAND:
#ifdef _WIN32
			{
				char *file=NULL;
				char *param=NULL;
				GetShell(&PARAM->Value, &file, &param);

				ShellExecute(NULL, "open", file, param, NULL, SW_SHOWNORMAL);
				//system(PARAM->Value.c_str());
			}
#else
            system(PARAM->Value.c_str());
#endif
            break;
        case MSG_REORDER_CHILD:
            {
                    GTKControl *item=GetControlID(PARAM->Sender.ToInt());
                    GTKControl *child=GetControlID(PARAM->Target.ToInt());
                    if (item) {
                        switch (item->type) {
                            case CLASS_VBOX:
                            case CLASS_HBOX:
                            case CLASS_VBUTTONBOX:
                            case CLASS_HBUTTONBOX:
                            case CLASS_STATUSBAR:
                                if (!child)
                                    std::cerr << "Invalid RID in child\n";
                                else
                                    gtk_box_reorder_child(GTK_BOX(SAFE_WIDGET(item)), SAFE_WIDGET(child),PARAM->Value.ToInt());
                                break;
                            default:
                                std::cerr << "Control doesn't support reordering\n";
                        }
                    } else
                            std::cerr << "Invalid RID in owner\n";
            }
            break;
#ifdef _WIN32
        case MSG_CREATE_ACTIVEX:
        case MSG_AX_SET_PROPERTY:
        case MSG_AX_ADD_PARAMETER:
        case MSG_AX_CALL_METHOD:
        case MSG_AX_ADD_FILEPARAMETER:
        case MSG_AX_GET_PROPERTY:
        case MSG_AX_GET_RESULT:
        case MSG_AX_ADD_EVENT:
        case MSG_AX_AKNOWLEDGE_EVENT:
        case MSG_AX_CLEAR_EVENTS_DATA:
        case MSG_AX_GET_EVENT_PARAM:
            PROCESS_AX_MESSAGE(PARAM);
            break;
#endif
        case MSG_D_PRIMITIVE_LINE:
        case MSG_D_PRIMITIVE_ARC:
        case MSG_D_PRIMITIVE_FILL_ARC:
        case MSG_D_PRIMITIVE_RECT:
        case MSG_D_PRIMITIVE_FILL_RECT:
        case MSG_D_PRIMITIVE_POINT:
        case MSG_D_PRIMITIVE_COLOR:
            PRIMITIVE_DRAW(PARAM);
            break;
        case MSG_SET_CLIPBOARD:
            {
                GtkClipboard *refClipboard = gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
                switch (PARAM->Target.ToInt()) {
                    case 1:
                        {
                            GTKControl *ctrl=GetControlID(PARAM->Value.ToInt());

                            if ((ctrl) && (ctrl->type==CLASS_IMAGE))
                                gtk_clipboard_set_image(refClipboard, ForcePixbuf(ctrl->ptr)/*((Gtk::Image*)ctrl->ptr)->get_pixbuf()*/);
                            else
                                std::cerr << "Invalid image ID in clipboard copy";
                        }
                        break;
                    case 2:
                        gtk_clipboard_set_text(refClipboard, PARAM->Value.c_str(), PARAM->Value.Length());
                        break;
                    default:
                        gtk_clipboard_clear(refClipboard);
                        break;
                }
            }
            break;
        case MSG_GET_CLIPBOARD:
            {
                GtkClipboard *refClipboard = gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
                switch (PARAM->Target.ToInt()) {
                    case 1:
                        if (gtk_clipboard_wait_is_image_available(refClipboard)) {
                            GdkPixbuf *pixbuf_image=gtk_clipboard_wait_for_image(refClipboard);
                            gchar* buffer=0;
                            gsize buffer_size=0;
                            GError *gmerror=NULL;
                            gdk_pixbuf_save_to_buffer(pixbuf_image, &buffer, &buffer_size, PARAM->Value.c_str(),&gmerror,NULL);
                            AnsiString data;

                            if (buffer_size)
                                data.LoadBuffer((char *)buffer, buffer_size);

                            PARAM->Owner->SendMessage("%CLIENT",MSG_GET_CLIPBOARD,"1",data);
                        } else {
                            PARAM->Owner->SendMessage("%CLIENT",MSG_GET_CLIPBOARD,"0","0");
                        }
                        break;
                    case 2:
                        if (gtk_clipboard_wait_is_text_available(refClipboard)) {
                            char *text=gtk_clipboard_wait_for_text(refClipboard);
                            PARAM->Owner->SendMessage("%CLIENT",MSG_GET_CLIPBOARD,"1",(char *)text);
                        } else
                            PARAM->Owner->SendMessage("%CLIENT",MSG_GET_CLIPBOARD,"0","0");
                        break;
                }
            }
            break;
        case MSG_SET_PROPERTY_BY_NAME:
            {
                GTKControl *item=GetControlID(PARAM->Sender.ToInt());
                if (item) {
                    GObject *obj=G_OBJECT(SAFE_WIDGET(item));
                    if (obj) {
                        GParamSpec *spec=0;
                        if (G_TYPE_IS_INTERFACE(G_OBJECT_TYPE(obj))) {
                            gpointer vtable = g_type_default_interface_peek (G_OBJECT_TYPE(obj));
                            spec=g_object_interface_find_property(vtable, PARAM->Target.c_str());
                        } else {
                            GObjectClass *cls = G_OBJECT_CLASS(g_type_class_peek(G_OBJECT_TYPE(obj)));
                            spec=g_object_class_find_property(cls, PARAM->Target.c_str());
                        }
                        if (spec) {
                            GValue value= { 0, };
                            GValue dest_value= { 0, };
                            g_value_init(&value, G_TYPE_STRING);
                            g_value_set_static_string(&value, PARAM->Value.c_str());

                            g_value_init(&dest_value, spec->value_type);
                            if ((spec->value_type==G_TYPE_DOUBLE) || (spec->value_type==G_TYPE_FLOAT)) {
                                g_value_unset(&value);
                                g_value_init(&value, G_TYPE_DOUBLE);
                                g_value_set_double(&value, PARAM->Value.ToFloat());
                                g_object_set_property(obj, spec->name, &value);
                            } else
                            if (g_value_transform(&value, &dest_value)) {
                                g_object_set_property(obj, spec->name, &dest_value);
                                //g_object_set_property(obj, PARAM->Target.c_str(), &dest_value);
                            } else 
                            if (spec->value_type==G_TYPE_BOOLEAN) {
                                g_value_unset(&dest_value);
                                g_value_init(&dest_value, G_TYPE_BOOLEAN);
                                g_value_set_boolean(&dest_value, TRUE);
                                if ((PARAM->Value==(char *)"FALSE") || (PARAM->Value==(char *)"false") ||
                                    (PARAM->Value==(char *)"0") || (!PARAM->Value.Length()))
                                    g_value_set_boolean(&dest_value, FALSE);
                                g_object_set_property(obj, spec->name, &dest_value);
                            } else {
                                g_value_unset(&value);
                                g_value_init(&value, G_TYPE_INT);
                                g_value_set_int(&value, PARAM->Value.ToInt());
                                if (g_value_transform(&value, &dest_value)) {
                                    g_object_set_property(obj, spec->name, &dest_value);
                                } else
					                std::cerr << "Cannot set value \"" << PARAM->Value.c_str() << "\" for property \"" << PARAM->Target.c_str() << "\" for object RID " << PARAM->Sender.ToInt() << "\n";
                            }
                            g_value_unset(&dest_value);
                            g_value_unset(&value);
                        } else {
					        std::cerr << "Invalid property \"" << PARAM->Target.c_str() << "\" for object RID " << PARAM->Sender.ToInt() << "\n";
                        }
                    }
                }
            }
            break;
        case MSG_CHOOSE_COLOR:
            {
                
                GtkWidget *dialog=color_dialog;
                if (!dialog) {
                    dialog=gtk_color_selection_dialog_new(PARAM->Target.c_str());
                    if (mainform)
                        gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);
#ifdef _WIN32
                    gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif
                }

                int result = gtk_dialog_run(GTK_DIALOG(dialog));
                if (result==GTK_RESPONSE_OK) {
                    GtkWidget* color_selection=gtk_color_selection_dialog_get_color_selection(GTK_COLOR_SELECTION_DIALOG(dialog));
                    if (color_selection) {
                        //double color=0;
                        //gtk_color_selection_get_color(GTK_COLOR_SELECTION(color_selection), &color);
                        GdkColor color;
                        gtk_color_selection_get_current_color(GTK_COLOR_SELECTION(color_selection), &color);
                        long l_color=(color.red/0x100)*0x10000;
                        l_color+=(color.green/0x100)*0x100;
                        l_color+=color.blue/0x100;
                        if (l_color>0xFFFFFF)
                            l_color=0xFFFFFF;
                        PARAM->Owner->SendMessage("%CLIENT",MSG_CHOOSE_COLOR,"1",AnsiString((long)l_color));
                    }
                } else
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CHOOSE_COLOR,"0","0");
                gtk_widget_hide(GTK_WIDGET(dialog));
            }
            break;
        case MSG_CHOOSE_FONT:
            {
                GtkWidget *dialog=font_dialog;
                if (!dialog) {
                    dialog=gtk_font_selection_dialog_new(PARAM->Target.c_str());
                    font_dialog=dialog;
                    if (mainform)
                        gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);
#ifdef _WIN32
                    gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif
                }

                int result = gtk_dialog_run(GTK_DIALOG(dialog));
                if (result==GTK_RESPONSE_OK) {
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CHOOSE_FONT,"1",AnsiString(gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(dialog))));
                } else
                    PARAM->Owner->SendMessage("%CLIENT",MSG_CHOOSE_FONT,"0","");
                gtk_widget_hide(GTK_WIDGET(dialog));
            }
            break;
        case MSG_REQUEST_FOR_FILE:
            {
#ifdef WIN32OPENSAVEDIALOG
                OPENFILENAME ofn;       // common dialog box structure
                char szFile[0x2000];       // buffer for file name
                HWND wnd=0;
                HANDLE hf;              // file handle

                //if (mainform)
                //    wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(mainform)->window);
                // Initialize OPENFILENAME
                ZeroMemory(&ofn, sizeof(ofn));
                ofn.lStructSize = sizeof(ofn);
                ofn.hwndOwner = wnd;
                ofn.lpstrFile = szFile;
                // Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
                // use the contents of szFile to initialize itself.
                ofn.lpstrFile[0] = '\0';
                ofn.nMaxFile = sizeof(szFile);
                ofn.lpstrFilter = "All\0*.*\0";
                ofn.nFilterIndex = 0;
                ofn.lpstrFileTitle = NULL;
                ofn.nMaxFileTitle = 0;
                ofn.lpstrInitialDir = NULL;
                ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;

                if (PARAM->Target.Length())
                    ofn.lpstrFileTitle=PARAM->Target.c_str();

                int len=PARAM->Value.Length();
                AnsiString name;
                AnsiString pattern;
                char put_to=0;
                AnsiString filter;
                for (int i=0;i<len;i++) {
                    char c=PARAM->Value[i];
                    if (c=='|') {
                        put_to=1;
                    } else
                    if (c==';') {
                        put_to=0;
                        filter+=name;
                        filter+='\0';
                        filter+=pattern;
                        filter+='\0';
                        name=(char *)"";
                        pattern=(char *)"";
                    } else {
                        if (put_to)
                            pattern+=c;
                        else
                            name+=c;
                    }
                }
                if ((len) && (pattern.Length())) {
                        filter+=name;
                        filter+='\0';
                        filter+=pattern;
                        filter+='\0';
                }
                if (filter.Length()) {
                    ofn.lpstrFilter=filter.c_str();
                }

                if (GetOpenFileName(&ofn)==TRUE) {
                    AnsiString filename(ofn.lpstrFile);
                    len=filename.Length();
                    int offset=0;
                    for (int i=len-1;i>=0;i--) {
                        if ((filename[i]=='\\') || (filename[i]=='/')) {
                            offset=i+1;
                            break;
                        }
                    }
                    PARAM->Owner->SendFileMessage("%CLIENT",MSG_REQUEST_FOR_FILE,filename.c_str()+offset,filename.c_str());
                } else {
                    PARAM->Owner->SendMessage("%CLIENT",MSG_REQUEST_FOR_FILE,"","");
                }
#else
                GtkWidget *dialog=gtk_file_chooser_dialog_new(PARAM->Target.c_str(), mainform, GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_OK, NULL);
                if (mainform)
                    gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);
                gtk_file_chooser_set_select_multiple (GTK_FILE_CHOOSER(dialog), FALSE);

                if (lastdir.Length())
                    gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), lastdir.c_str());

                int len=PARAM->Value.Length();
                AnsiString name;
                AnsiString pattern;
                char put_to=0;
                for (int i=0;i<len;i++) {
                    char c=PARAM->Value[i];
                    if (c=='|') {
                        put_to=1;
                    } else
                    if (c==';') {
                        put_to=0;
                        GtkFileFilter *filter=gtk_file_filter_new();
                        gtk_file_filter_set_name(filter, name.c_str());
                        gtk_file_filter_add_pattern(filter, pattern.c_str());
                        gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
                        name=(char *)"";
                        pattern=(char *)"";
                    } else {
                        if (put_to)
                            pattern+=c;
                        else
                            name+=c;
                    }
                }
                if ((len) && (pattern.Length())) {
                        /*GtkFileFilter filter;
                        filter.set_name(name.c_str());
                        filter.add_pattern(pattern.c_str());
                        dialog.add_filter(filter);*/
                        GtkFileFilter *filter=gtk_file_filter_new();
                        gtk_file_filter_set_name(filter, name.c_str());
                        gtk_file_filter_add_pattern(filter, pattern.c_str());
                        gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
                }

#ifdef _WIN32
                gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif

                int result = gtk_dialog_run(GTK_DIALOG(dialog));
                if (result==GTK_RESPONSE_OK) {
                    lastdir=(char *)gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER(dialog));
                    //AnsiString content;
                    AnsiString filename((char *)gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog)));
                    //content.LoadFile(filename);

                    len=filename.Length();
                    int offset=0;
                    for (int i=len-1;i>=0;i--) {
                        if ((filename[i]=='\\') || (filename[i]=='/')) {
                            offset=i+1;
                            break;
                        }
                    }
                    //PARAM->Owner->SendBigMessage("%CLIENT",MSG_REQUEST_FOR_FILE,filename.c_str()+offset,&content);
                    PARAM->Owner->SendFileMessage("%CLIENT",MSG_REQUEST_FOR_FILE,filename.c_str()+offset,filename.c_str());
                } else {
                    PARAM->Owner->SendMessage("%CLIENT",MSG_REQUEST_FOR_FILE,"","");
                }
                gtk_widget_destroy(GTK_WIDGET(dialog));
#endif
            }
            break;
        case MSG_SAVE_FILE:
            {
#ifdef WIN32OPENSAVEDIALOG
                OPENFILENAME ofn;       // common dialog box structure
                char szFile[0x2000];       // buffer for file name
                HWND wnd=0;
                HANDLE hf;              // file handle

                //if (mainform)
                //    wnd=(HWND)GDK_WINDOW_HWND(GTK_WIDGET(mainform)->window);
                // Initialize OPENFILENAME
                ZeroMemory(&ofn, sizeof(ofn));
                ofn.lStructSize = sizeof(ofn);
                ofn.hwndOwner = wnd;
                ofn.lpstrFile = szFile;
                // Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
                // use the contents of szFile to initialize itself.
                ofn.lpstrFile[0] = '\0';
                ofn.nMaxFile = sizeof(szFile);
                ofn.lpstrFilter = "All\0*.*\0";
                ofn.nFilterIndex = 0;
                ofn.lpstrFileTitle = NULL;
                ofn.nMaxFileTitle = 0;
                ofn.lpstrInitialDir = NULL;
                ofn.Flags = OFN_SHOWHELP | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR; 

                if (PARAM->Target.Length())
                    ofn.lpstrFileTitle=PARAM->Target.c_str();

                int len=PARAM->Value.Length();
                AnsiString name;
                AnsiString pattern;
                char put_to=0;
                AnsiString filter;
                for (int i=0;i<len;i++) {
                    char c=PARAM->Value[i];
                    if (c=='|') {
                        put_to=1;
                    } else
                    if (c==';') {
                        put_to=0;
                        filter+=name;
                        filter+='\0';
                        filter+=pattern;
                        filter+='\0';
                        name=(char *)"";
                        pattern=(char *)"";
                    } else {
                        if (put_to)
                            pattern+=c;
                        else
                            name+=c;
                    }
                }
                if ((len) && (pattern.Length())) {
                        filter+=name;
                        filter+='\0';
                        filter+=pattern;
                        filter+='\0';
                }
                if (filter.Length()) {
                    ofn.lpstrFilter=filter.c_str();
                }
                if (PARAM->Sender.Length())
                    ofn.lpstrFile=PARAM->Sender.c_str();

                if (GetSaveFileName(&ofn)==TRUE) {
                    POST_STRING.SaveFile(ofn.lpstrFile);
                    PARAM->Owner->SendMessage("%CLIENT",MSG_SAVE_FILE,PARAM->Target,"1");
                } else {
                    PARAM->Owner->SendMessage("%CLIENT",MSG_SAVE_FILE,PARAM->Target,"0");
                }
#else
                GtkWidget *dialog=gtk_file_chooser_dialog_new(PARAM->Target.c_str(), mainform, GTK_FILE_CHOOSER_ACTION_SAVE, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE, GTK_RESPONSE_OK, NULL);

                if (mainform)
                    gtk_window_set_transient_for(GTK_WINDOW(dialog), mainform);

                gtk_file_chooser_set_select_multiple (GTK_FILE_CHOOSER(dialog), FALSE);

                if (lastdir.Length())
                    gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), lastdir.c_str());

                int len=PARAM->Value.Length();
                AnsiString name;
                AnsiString pattern;
                char put_to=0;
                for (int i=0;i<len;i++) {
                    char c=PARAM->Value[i];
                    if (c=='|') {
                        put_to=1;
                    } else
                    if (c==';') {
                        put_to=0;
                        GtkFileFilter *filter=gtk_file_filter_new();
                        gtk_file_filter_set_name(filter, name.c_str());
                        gtk_file_filter_add_pattern(filter, pattern.c_str());
                        gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
                        name=(char *)"";
                        pattern=(char *)"";
                    } else {
                        if (put_to)
                            pattern+=c;
                        else
                            name+=c;
                    }
                }
                if ((len) && (pattern.Length())) {
                    GtkFileFilter *filter=gtk_file_filter_new();
                    gtk_file_filter_set_name(filter, name.c_str());
                    gtk_file_filter_add_pattern(filter, pattern.c_str());
                    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
                }
                AnsiString full_path=(char *)gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER(dialog));

#ifdef _WIN32
                full_path+=(char *)"\\";
#else
                full_path+=(char *)"/";
#endif
                full_path+=PARAM->Sender.c_str();

                gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(dialog), /*full_path.c_str()*/PARAM->Sender.c_str());
                //dialog.set_do_overwrite_confirmation(true);
				gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(dialog), FALSE);
                //gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(dialog), FALSE);

#ifdef _WIN32
                gtk_signal_connect_object (GTK_OBJECT (dialog), "realize", GTK_SIGNAL_FUNC (PATCH_SetOnTop), GTK_OBJECT (dialog));
#endif

                int result = gtk_dialog_run(GTK_DIALOG(dialog));
                if (result==GTK_RESPONSE_OK) {
                    lastdirsave=(char *)gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER(dialog));
                    AnsiString content;
                    AnsiString filename((char *)gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog)));
                    POST_STRING.SaveFile(filename);

                    PARAM->Owner->SendMessage("%CLIENT",MSG_SAVE_FILE,PARAM->Target,"1");
                } else {
                    PARAM->Owner->SendMessage("%CLIENT",MSG_SAVE_FILE,PARAM->Target,"0");
                }
                gtk_widget_destroy(GTK_WIDGET(dialog));
#endif
            }
            break;
		case MSG_STATIC_QUERY:
			{
				INTEGER cls_id=PARAM->Sender.ToInt();
				INVOKER Invoke=GetRequiredInvoker(cls_id);
				if (!Invoke) {
					std::cerr << "Uknown static query interface " << "MSGID:" << PARAM->ID << " Sender:" << PARAM->Sender << " Target:" << PARAM->Target << " Value:" << PARAM->Value << "\n";
					return 0;
				}
				if (Invoke(0,INVOKE_STATICQUERY, cls_id, (char *)PARAM->Target.c_str(), (INTEGER)PARAM->Target.Length(), (char *)PARAM->Value.c_str(), (INTEGER)PARAM->Value.Length())!=E_ACCEPTED) {
					std::cerr << "Error invoking static query interface " << "MSGID:" << PARAM->ID << " Sender:" << PARAM->Sender << " Target:" << PARAM->Target << " Value:" << PARAM->Value << "\n";
				}
			}
			break;
		case MSG_STATIC_RESPONSE:
			{
				INTEGER cls_id=PARAM->Sender.ToInt();
				INVOKER Invoke=GetRequiredInvoker(cls_id);
				if (!Invoke) {
					std::cerr << "Uknown static query interface " << "MSGID:" << PARAM->ID << " Sender:" << PARAM->Sender << " Target:" << PARAM->Target << " Value:" << PARAM->Value << "\n";
					return 0;
				}
				char *result=0;
				INTEGER result_len=0;
				if (Invoke(0,INVOKE_STATICRESPONSE, cls_id, (char *)PARAM->Target.c_str(), (INTEGER)PARAM->Target.Length(), (char *)PARAM->Value.c_str(), (INTEGER)PARAM->Value.Length(), &result, &result_len)!=E_ACCEPTED) {
					std::cerr << "Error invoking static query interface " << "MSGID:" << PARAM->ID << " Sender:" << PARAM->Sender << " Target:" << PARAM->Target << " Value:" << PARAM->Value << "\n";
				}
				AnsiString res;
				if (result_len>0)
					res.LoadBuffer(result, result_len);
                PARAM->Owner->SendMessage(PARAM->Target,MSG_STATIC_RESPONSE,"0",res);
			}
			break;
        default:
            std::cerr << "Uknown message id: " << "MSGID:" << PARAM->ID << " Sender:" << PARAM->Sender << " Target:" << PARAM->Target << " Value:" << PARAM->Value << "\n";
            break;
    }
    return 0;
}

void DeturnatedTreeView::on_cell_data(GtkTreeViewColumn *tree_column, GtkCellRenderer *cell, GtkTreeModel *tree_model, GtkTreeIter *iter, gpointer THIS_REF) {
    DeturnatedTreeView *THIS=(DeturnatedTreeView *)THIS_REF;
    if (THIS->alternate) {
        //GtkTreeModel *model=gtk_tree_view_get_model(GTK_TREE_VIEW(handle));
        GtkTreePath *path=gtk_tree_model_get_path(tree_model, iter);

        if (THIS->alternate) {
            g_object_set(G_OBJECT(cell), "cell-background-set", TRUE, NULL);
            int *indices=gtk_tree_path_get_indices(path);
            if (indices) {
                if ( indices[ 0 ] % 2 ) {
                    g_object_set(G_OBJECT(cell), "cell-background-gdk", &THIS->odd_color, NULL);
                } else 
                    g_object_set(G_OBJECT(cell), "cell-background-gdk", &THIS->even_color, NULL);
            }
        }
        gtk_tree_path_free(path);
    }
}

gboolean DeturnatedTreeView::signal_header_clicked(void *Sender, void *THIS_REF) {
    if (((DeturnatedTreeView *)THIS_REF)->EVENT_HANDLER) {
        my_header_event(((DeturnatedTreeView *)THIS_REF)->EVENT_HANDLER);
    }
    return FALSE;
}

int QuitPending() {
    while (WAIT) {
           Sleep(1000);
    }
}
